# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "image3d4xi.py">
#<abstract4xi abstract = "3D image management"/>
#<refer4xi reference = "3D images"/>
#<verify4xi verification = "10" target = "image3d4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4moduletesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API                
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Image3D4Xi',                         # ACK 5.31  p76 
            
            'copy3image4xi',                      # ACK 5.3.3 p88
            'copy3imagetobuffer4xi',              # ACK 5.3.4 p90
            'copy3buffertoimage4xi',              # ACK 5.3.4 p92
            'create3image4xi',                    # ACK 5.31  p76           

            'get3imageinfo4xi',                   # ACK 5.3.6 p97        
            'get3supportedimageformats4xi',       # ACK 5.3.2 p82 
                              
            'manoeuvre3copyimage4xi',             # ACK 
            'manoeuvre3copyimagetobuffer4xi',     # ACK     
            'manoeuvre3copybuffertoimage4xi',     # ACK 
            'manoeuvre3mapimage4xi',              # ACK                                       
            'manoeuvre3readimage4xi',             # ACK  
            'manoeuvre3writeimage4xi',            # ACK       
            
            'map3image4xi',                       # ACK 5.3.5 p94 
            
            'read3image4xi',                      # ACK 5.3.3 p84 
            'retain3image4xi',                    # ACK 5.4.1 p99
            'release3image4xi',                   # ACK 5.4.1 p99

            'set3imagecallback4xi',               # ACK
            'set3image4xi',                       # ACK          

            'trace3image4xi',                     # ACK 
                                    
            'wait3image4xi',                      # ACK 
            'write3image4xi'                      # ACK 5.3.3 p84                 
          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi


# -------------------------------------------------------------------------------------------------
# Image modules of devices                           
# -------------------------------------------------------------------------------------------------
from apu3image4xi import APU3Image4Xi                                                             
from bpu3image4xi import BPU3Image4Xi
from cpu3image4xi import CPU3Image4Xi
from dpu3image4xi import DPU3Image4Xi
from epu3image4xi import EPU3Image4Xi
from fpu3image4xi import FPU3Image4Xi
from gpu3image4xi import GPU3Image4Xi
from hpu3image4xi import HPU3Image4Xi
from ipu3image4xi import IPU3Image4Xi
from jpu3image4xi import JPU3Image4Xi
from kpu3image4xi import KPU3Image4Xi
from lpu3image4xi import LPU3Image4Xi
from mpu3image4xi import MPU3Image4Xi
from npu3image4xi import NPU3Image4Xi
from opu3image4xi import OPU3Image4Xi
from ppu3image4xi import PPU3Image4Xi
from qpu3image4xi import QPU3Image4Xi
from rpu3image4xi import RPU3Image4Xi
from spu3image4xi import SPU3Image4Xi
from tpu3image4xi import TPU3Image4Xi
from upu3image4xi import UPU3Image4Xi
from vpu3image4xi import VPU3Image4Xi
from xpu3image4xi import XPU3Image4Xi
from wpu3image4xi import WPU3Image4Xi
from ypu3image4xi import YPU3Image4Xi
from zpu3image4xi import ZPU3Image4Xi

from apu3image4xi import copy3image4apu                                                            
from bpu3image4xi import copy3image4bpu
from cpu3image4xi import copy3image4cpu
from dpu3image4xi import copy3image4dpu
from epu3image4xi import copy3image4epu
from fpu3image4xi import copy3image4fpu
from gpu3image4xi import copy3image4gpu
from hpu3image4xi import copy3image4hpu
from ipu3image4xi import copy3image4ipu
from jpu3image4xi import copy3image4jpu
from kpu3image4xi import copy3image4kpu
from lpu3image4xi import copy3image4lpu
from mpu3image4xi import copy3image4mpu
from npu3image4xi import copy3image4npu
from opu3image4xi import copy3image4opu
from ppu3image4xi import copy3image4ppu
from qpu3image4xi import copy3image4qpu
from rpu3image4xi import copy3image4rpu
from spu3image4xi import copy3image4spu
from tpu3image4xi import copy3image4tpu
from upu3image4xi import copy3image4upu
from vpu3image4xi import copy3image4vpu
from xpu3image4xi import copy3image4xpu
from wpu3image4xi import copy3image4wpu
from ypu3image4xi import copy3image4ypu
from zpu3image4xi import copy3image4zpu

from apu3image4xi import copy3imagetobuffer4apu                                                            
from bpu3image4xi import copy3imagetobuffer4bpu
from cpu3image4xi import copy3imagetobuffer4cpu
from dpu3image4xi import copy3imagetobuffer4dpu
from epu3image4xi import copy3imagetobuffer4epu
from fpu3image4xi import copy3imagetobuffer4fpu
from gpu3image4xi import copy3imagetobuffer4gpu
from hpu3image4xi import copy3imagetobuffer4hpu
from ipu3image4xi import copy3imagetobuffer4ipu
from jpu3image4xi import copy3imagetobuffer4jpu
from kpu3image4xi import copy3imagetobuffer4kpu
from lpu3image4xi import copy3imagetobuffer4lpu
from mpu3image4xi import copy3imagetobuffer4mpu
from npu3image4xi import copy3imagetobuffer4npu
from opu3image4xi import copy3imagetobuffer4opu
from ppu3image4xi import copy3imagetobuffer4ppu
from qpu3image4xi import copy3imagetobuffer4qpu
from rpu3image4xi import copy3imagetobuffer4rpu
from spu3image4xi import copy3imagetobuffer4spu
from tpu3image4xi import copy3imagetobuffer4tpu
from upu3image4xi import copy3imagetobuffer4upu
from vpu3image4xi import copy3imagetobuffer4vpu
from xpu3image4xi import copy3imagetobuffer4xpu
from wpu3image4xi import copy3imagetobuffer4wpu
from ypu3image4xi import copy3imagetobuffer4ypu
from zpu3image4xi import copy3imagetobuffer4zpu

from apu3image4xi import copy3buffertoimage4apu                                                            
from bpu3image4xi import copy3buffertoimage4bpu
from cpu3image4xi import copy3buffertoimage4cpu
from dpu3image4xi import copy3buffertoimage4dpu
from epu3image4xi import copy3buffertoimage4epu
from fpu3image4xi import copy3buffertoimage4fpu
from gpu3image4xi import copy3buffertoimage4gpu
from hpu3image4xi import copy3buffertoimage4hpu
from ipu3image4xi import copy3buffertoimage4ipu
from jpu3image4xi import copy3buffertoimage4jpu
from kpu3image4xi import copy3buffertoimage4kpu
from lpu3image4xi import copy3buffertoimage4lpu
from mpu3image4xi import copy3buffertoimage4mpu
from npu3image4xi import copy3buffertoimage4npu
from opu3image4xi import copy3buffertoimage4opu
from ppu3image4xi import copy3buffertoimage4ppu
from qpu3image4xi import copy3buffertoimage4qpu
from rpu3image4xi import copy3buffertoimage4rpu
from spu3image4xi import copy3buffertoimage4spu
from tpu3image4xi import copy3buffertoimage4tpu
from upu3image4xi import copy3buffertoimage4upu
from vpu3image4xi import copy3buffertoimage4vpu
from xpu3image4xi import copy3buffertoimage4xpu
from wpu3image4xi import copy3buffertoimage4wpu
from ypu3image4xi import copy3buffertoimage4ypu
from zpu3image4xi import copy3buffertoimage4zpu

from apu3image4xi import create3image4apu                                                            
from bpu3image4xi import create3image4bpu
from cpu3image4xi import create3image4cpu
from dpu3image4xi import create3image4dpu
from epu3image4xi import create3image4epu
from fpu3image4xi import create3image4fpu
from gpu3image4xi import create3image4gpu
from hpu3image4xi import create3image4hpu
from ipu3image4xi import create3image4ipu
from jpu3image4xi import create3image4jpu
from kpu3image4xi import create3image4kpu
from lpu3image4xi import create3image4lpu
from mpu3image4xi import create3image4mpu
from npu3image4xi import create3image4npu
from opu3image4xi import create3image4opu
from ppu3image4xi import create3image4ppu
from qpu3image4xi import create3image4qpu
from rpu3image4xi import create3image4rpu
from spu3image4xi import create3image4spu
from tpu3image4xi import create3image4tpu
from upu3image4xi import create3image4upu
from vpu3image4xi import create3image4vpu
from xpu3image4xi import create3image4xpu
from wpu3image4xi import create3image4wpu
from ypu3image4xi import create3image4ypu
from zpu3image4xi import create3image4zpu

from apu3image4xi import create3image4apu                                                            
from bpu3image4xi import create3image4bpu
from cpu3image4xi import create3image4cpu
from dpu3image4xi import create3image4dpu
from epu3image4xi import create3image4epu
from fpu3image4xi import create3image4fpu
from gpu3image4xi import create3image4gpu
from hpu3image4xi import create3image4hpu
from ipu3image4xi import create3image4ipu
from jpu3image4xi import create3image4jpu
from kpu3image4xi import create3image4kpu
from lpu3image4xi import create3image4lpu
from mpu3image4xi import create3image4mpu
from npu3image4xi import create3image4npu
from opu3image4xi import create3image4opu
from ppu3image4xi import create3image4ppu
from qpu3image4xi import create3image4qpu
from rpu3image4xi import create3image4rpu
from spu3image4xi import create3image4spu
from tpu3image4xi import create3image4tpu
from upu3image4xi import create3image4upu
from vpu3image4xi import create3image4vpu
from xpu3image4xi import create3image4xpu
from wpu3image4xi import create3image4wpu
from ypu3image4xi import create3image4ypu
from zpu3image4xi import create3image4zpu

from apu3image4xi import get3imageinfo4apu                                                            
from bpu3image4xi import get3imageinfo4bpu
from cpu3image4xi import get3imageinfo4cpu
from dpu3image4xi import get3imageinfo4dpu
from epu3image4xi import get3imageinfo4epu
from fpu3image4xi import get3imageinfo4fpu
from gpu3image4xi import get3imageinfo4gpu
from hpu3image4xi import get3imageinfo4hpu
from ipu3image4xi import get3imageinfo4ipu
from jpu3image4xi import get3imageinfo4jpu
from kpu3image4xi import get3imageinfo4kpu
from lpu3image4xi import get3imageinfo4lpu
from mpu3image4xi import get3imageinfo4mpu
from npu3image4xi import get3imageinfo4npu
from opu3image4xi import get3imageinfo4opu
from ppu3image4xi import get3imageinfo4ppu
from qpu3image4xi import get3imageinfo4qpu
from rpu3image4xi import get3imageinfo4rpu
from spu3image4xi import get3imageinfo4spu
from tpu3image4xi import get3imageinfo4tpu
from upu3image4xi import get3imageinfo4upu
from vpu3image4xi import get3imageinfo4vpu
from xpu3image4xi import get3imageinfo4xpu
from wpu3image4xi import get3imageinfo4wpu
from ypu3image4xi import get3imageinfo4ypu
from zpu3image4xi import get3imageinfo4zpu

from apu3image4xi import get3supportedimageformats4apu                                                            
from bpu3image4xi import get3supportedimageformats4bpu
from cpu3image4xi import get3supportedimageformats4cpu
from dpu3image4xi import get3supportedimageformats4dpu
from epu3image4xi import get3supportedimageformats4epu
from fpu3image4xi import get3supportedimageformats4fpu
from gpu3image4xi import get3supportedimageformats4gpu
from hpu3image4xi import get3supportedimageformats4hpu
from ipu3image4xi import get3supportedimageformats4ipu
from jpu3image4xi import get3supportedimageformats4jpu
from kpu3image4xi import get3supportedimageformats4kpu
from lpu3image4xi import get3supportedimageformats4lpu
from mpu3image4xi import get3supportedimageformats4mpu
from npu3image4xi import get3supportedimageformats4npu
from opu3image4xi import get3supportedimageformats4opu
from ppu3image4xi import get3supportedimageformats4ppu
from qpu3image4xi import get3supportedimageformats4qpu
from rpu3image4xi import get3supportedimageformats4rpu
from spu3image4xi import get3supportedimageformats4spu
from tpu3image4xi import get3supportedimageformats4tpu
from upu3image4xi import get3supportedimageformats4upu
from vpu3image4xi import get3supportedimageformats4vpu
from xpu3image4xi import get3supportedimageformats4xpu
from wpu3image4xi import get3supportedimageformats4wpu
from ypu3image4xi import get3supportedimageformats4ypu
from zpu3image4xi import get3supportedimageformats4zpu

from apu3image4xi import manoeuvre3copyimage4apu                                                            
from bpu3image4xi import manoeuvre3copyimage4bpu
from cpu3image4xi import manoeuvre3copyimage4cpu
from dpu3image4xi import manoeuvre3copyimage4dpu
from epu3image4xi import manoeuvre3copyimage4epu
from fpu3image4xi import manoeuvre3copyimage4fpu
from gpu3image4xi import manoeuvre3copyimage4gpu
from hpu3image4xi import manoeuvre3copyimage4hpu
from ipu3image4xi import manoeuvre3copyimage4ipu
from jpu3image4xi import manoeuvre3copyimage4jpu
from kpu3image4xi import manoeuvre3copyimage4kpu
from lpu3image4xi import manoeuvre3copyimage4lpu
from mpu3image4xi import manoeuvre3copyimage4mpu
from npu3image4xi import manoeuvre3copyimage4npu
from opu3image4xi import manoeuvre3copyimage4opu
from ppu3image4xi import manoeuvre3copyimage4ppu
from qpu3image4xi import manoeuvre3copyimage4qpu
from rpu3image4xi import manoeuvre3copyimage4rpu
from spu3image4xi import manoeuvre3copyimage4spu
from tpu3image4xi import manoeuvre3copyimage4tpu
from upu3image4xi import manoeuvre3copyimage4upu
from vpu3image4xi import manoeuvre3copyimage4vpu
from xpu3image4xi import manoeuvre3copyimage4xpu
from wpu3image4xi import manoeuvre3copyimage4wpu
from ypu3image4xi import manoeuvre3copyimage4ypu
from zpu3image4xi import manoeuvre3copyimage4zpu

from apu3image4xi import manoeuvre3copyimagetobuffer4apu                                                            
from bpu3image4xi import manoeuvre3copyimagetobuffer4bpu
from cpu3image4xi import manoeuvre3copyimagetobuffer4cpu
from dpu3image4xi import manoeuvre3copyimagetobuffer4dpu
from epu3image4xi import manoeuvre3copyimagetobuffer4epu
from fpu3image4xi import manoeuvre3copyimagetobuffer4fpu
from gpu3image4xi import manoeuvre3copyimagetobuffer4gpu
from hpu3image4xi import manoeuvre3copyimagetobuffer4hpu
from ipu3image4xi import manoeuvre3copyimagetobuffer4ipu
from jpu3image4xi import manoeuvre3copyimagetobuffer4jpu
from kpu3image4xi import manoeuvre3copyimagetobuffer4kpu
from lpu3image4xi import manoeuvre3copyimagetobuffer4lpu
from mpu3image4xi import manoeuvre3copyimagetobuffer4mpu
from npu3image4xi import manoeuvre3copyimagetobuffer4npu
from opu3image4xi import manoeuvre3copyimagetobuffer4opu
from ppu3image4xi import manoeuvre3copyimagetobuffer4ppu
from qpu3image4xi import manoeuvre3copyimagetobuffer4qpu
from rpu3image4xi import manoeuvre3copyimagetobuffer4rpu
from spu3image4xi import manoeuvre3copyimagetobuffer4spu
from tpu3image4xi import manoeuvre3copyimagetobuffer4tpu
from upu3image4xi import manoeuvre3copyimagetobuffer4upu
from vpu3image4xi import manoeuvre3copyimagetobuffer4vpu
from xpu3image4xi import manoeuvre3copyimagetobuffer4xpu
from wpu3image4xi import manoeuvre3copyimagetobuffer4wpu
from ypu3image4xi import manoeuvre3copyimagetobuffer4ypu
from zpu3image4xi import manoeuvre3copyimagetobuffer4zpu

from apu3image4xi import manoeuvre3copybuffertoimage4apu                                                            
from bpu3image4xi import manoeuvre3copybuffertoimage4bpu
from cpu3image4xi import manoeuvre3copybuffertoimage4cpu
from dpu3image4xi import manoeuvre3copybuffertoimage4dpu
from epu3image4xi import manoeuvre3copybuffertoimage4epu
from fpu3image4xi import manoeuvre3copybuffertoimage4fpu
from gpu3image4xi import manoeuvre3copybuffertoimage4gpu
from hpu3image4xi import manoeuvre3copybuffertoimage4hpu
from ipu3image4xi import manoeuvre3copybuffertoimage4ipu
from jpu3image4xi import manoeuvre3copybuffertoimage4jpu
from kpu3image4xi import manoeuvre3copybuffertoimage4kpu
from lpu3image4xi import manoeuvre3copybuffertoimage4lpu
from mpu3image4xi import manoeuvre3copybuffertoimage4mpu
from npu3image4xi import manoeuvre3copybuffertoimage4npu
from opu3image4xi import manoeuvre3copybuffertoimage4opu
from ppu3image4xi import manoeuvre3copybuffertoimage4ppu
from qpu3image4xi import manoeuvre3copybuffertoimage4qpu
from rpu3image4xi import manoeuvre3copybuffertoimage4rpu
from spu3image4xi import manoeuvre3copybuffertoimage4spu
from tpu3image4xi import manoeuvre3copybuffertoimage4tpu
from upu3image4xi import manoeuvre3copybuffertoimage4upu
from vpu3image4xi import manoeuvre3copybuffertoimage4vpu
from xpu3image4xi import manoeuvre3copybuffertoimage4xpu
from wpu3image4xi import manoeuvre3copybuffertoimage4wpu
from ypu3image4xi import manoeuvre3copybuffertoimage4ypu
from zpu3image4xi import manoeuvre3copybuffertoimage4zpu

from apu3image4xi import manoeuvre3mapimage4apu                                                            
from bpu3image4xi import manoeuvre3mapimage4bpu
from cpu3image4xi import manoeuvre3mapimage4cpu
from dpu3image4xi import manoeuvre3mapimage4dpu
from epu3image4xi import manoeuvre3mapimage4epu
from fpu3image4xi import manoeuvre3mapimage4fpu
from gpu3image4xi import manoeuvre3mapimage4gpu
from hpu3image4xi import manoeuvre3mapimage4hpu
from ipu3image4xi import manoeuvre3mapimage4ipu
from jpu3image4xi import manoeuvre3mapimage4jpu
from kpu3image4xi import manoeuvre3mapimage4kpu
from lpu3image4xi import manoeuvre3mapimage4lpu
from mpu3image4xi import manoeuvre3mapimage4mpu
from npu3image4xi import manoeuvre3mapimage4npu
from opu3image4xi import manoeuvre3mapimage4opu
from ppu3image4xi import manoeuvre3mapimage4ppu
from qpu3image4xi import manoeuvre3mapimage4qpu
from rpu3image4xi import manoeuvre3mapimage4rpu
from spu3image4xi import manoeuvre3mapimage4spu
from tpu3image4xi import manoeuvre3mapimage4tpu
from upu3image4xi import manoeuvre3mapimage4upu
from vpu3image4xi import manoeuvre3mapimage4vpu
from xpu3image4xi import manoeuvre3mapimage4xpu
from wpu3image4xi import manoeuvre3mapimage4wpu
from ypu3image4xi import manoeuvre3mapimage4ypu
from zpu3image4xi import manoeuvre3mapimage4zpu

from apu3image4xi import manoeuvre3readimage4apu                                                            
from bpu3image4xi import manoeuvre3readimage4bpu
from cpu3image4xi import manoeuvre3readimage4cpu
from dpu3image4xi import manoeuvre3readimage4dpu
from epu3image4xi import manoeuvre3readimage4epu
from fpu3image4xi import manoeuvre3readimage4fpu
from gpu3image4xi import manoeuvre3readimage4gpu
from hpu3image4xi import manoeuvre3readimage4hpu
from ipu3image4xi import manoeuvre3readimage4ipu
from jpu3image4xi import manoeuvre3readimage4jpu
from kpu3image4xi import manoeuvre3readimage4kpu
from lpu3image4xi import manoeuvre3readimage4lpu
from mpu3image4xi import manoeuvre3readimage4mpu
from npu3image4xi import manoeuvre3readimage4npu
from opu3image4xi import manoeuvre3readimage4opu
from ppu3image4xi import manoeuvre3readimage4ppu
from qpu3image4xi import manoeuvre3readimage4qpu
from rpu3image4xi import manoeuvre3readimage4rpu
from spu3image4xi import manoeuvre3readimage4spu
from tpu3image4xi import manoeuvre3readimage4tpu
from upu3image4xi import manoeuvre3readimage4upu
from vpu3image4xi import manoeuvre3readimage4vpu
from xpu3image4xi import manoeuvre3readimage4xpu
from wpu3image4xi import manoeuvre3readimage4wpu
from ypu3image4xi import manoeuvre3readimage4ypu
from zpu3image4xi import manoeuvre3readimage4zpu

from apu3image4xi import manoeuvre3writeimage4apu                                                            
from bpu3image4xi import manoeuvre3writeimage4bpu
from cpu3image4xi import manoeuvre3writeimage4cpu
from dpu3image4xi import manoeuvre3writeimage4dpu
from epu3image4xi import manoeuvre3writeimage4epu
from fpu3image4xi import manoeuvre3writeimage4fpu
from gpu3image4xi import manoeuvre3writeimage4gpu
from hpu3image4xi import manoeuvre3writeimage4hpu
from ipu3image4xi import manoeuvre3writeimage4ipu
from jpu3image4xi import manoeuvre3writeimage4jpu
from kpu3image4xi import manoeuvre3writeimage4kpu
from lpu3image4xi import manoeuvre3writeimage4lpu
from mpu3image4xi import manoeuvre3writeimage4mpu
from npu3image4xi import manoeuvre3writeimage4npu
from opu3image4xi import manoeuvre3writeimage4opu
from ppu3image4xi import manoeuvre3writeimage4ppu
from qpu3image4xi import manoeuvre3writeimage4qpu
from rpu3image4xi import manoeuvre3writeimage4rpu
from spu3image4xi import manoeuvre3writeimage4spu
from tpu3image4xi import manoeuvre3writeimage4tpu
from upu3image4xi import manoeuvre3writeimage4upu
from vpu3image4xi import manoeuvre3writeimage4vpu
from xpu3image4xi import manoeuvre3writeimage4xpu
from wpu3image4xi import manoeuvre3writeimage4wpu
from ypu3image4xi import manoeuvre3writeimage4ypu
from zpu3image4xi import manoeuvre3writeimage4zpu

from apu3image4xi import map3image4apu                                                            
from bpu3image4xi import map3image4bpu
from cpu3image4xi import map3image4cpu
from dpu3image4xi import map3image4dpu
from epu3image4xi import map3image4epu
from fpu3image4xi import map3image4fpu
from gpu3image4xi import map3image4gpu
from hpu3image4xi import map3image4hpu
from ipu3image4xi import map3image4ipu
from jpu3image4xi import map3image4jpu
from kpu3image4xi import map3image4kpu
from lpu3image4xi import map3image4lpu
from mpu3image4xi import map3image4mpu
from npu3image4xi import map3image4npu
from opu3image4xi import map3image4opu
from ppu3image4xi import map3image4ppu
from qpu3image4xi import map3image4qpu
from rpu3image4xi import map3image4rpu
from spu3image4xi import map3image4spu
from tpu3image4xi import map3image4tpu
from upu3image4xi import map3image4upu
from vpu3image4xi import map3image4vpu
from xpu3image4xi import map3image4xpu
from wpu3image4xi import map3image4wpu
from ypu3image4xi import map3image4ypu
from zpu3image4xi import map3image4zpu

from apu3image4xi import read3image4apu                                                            
from bpu3image4xi import read3image4bpu
from cpu3image4xi import read3image4cpu
from dpu3image4xi import read3image4dpu
from epu3image4xi import read3image4epu
from fpu3image4xi import read3image4fpu
from gpu3image4xi import read3image4gpu
from hpu3image4xi import read3image4hpu
from ipu3image4xi import read3image4ipu
from jpu3image4xi import read3image4jpu
from kpu3image4xi import read3image4kpu
from lpu3image4xi import read3image4lpu
from mpu3image4xi import read3image4mpu
from npu3image4xi import read3image4npu
from opu3image4xi import read3image4opu
from ppu3image4xi import read3image4ppu
from qpu3image4xi import read3image4qpu
from rpu3image4xi import read3image4rpu
from spu3image4xi import read3image4spu
from tpu3image4xi import read3image4tpu
from upu3image4xi import read3image4upu
from vpu3image4xi import read3image4vpu
from xpu3image4xi import read3image4xpu
from wpu3image4xi import read3image4wpu
from ypu3image4xi import read3image4ypu
from zpu3image4xi import read3image4zpu

from apu3image4xi import retain3image4apu                                                            
from bpu3image4xi import retain3image4bpu
from cpu3image4xi import retain3image4cpu
from dpu3image4xi import retain3image4dpu
from epu3image4xi import retain3image4epu
from fpu3image4xi import retain3image4fpu
from gpu3image4xi import retain3image4gpu
from hpu3image4xi import retain3image4hpu
from ipu3image4xi import retain3image4ipu
from jpu3image4xi import retain3image4jpu
from kpu3image4xi import retain3image4kpu
from lpu3image4xi import retain3image4lpu
from mpu3image4xi import retain3image4mpu
from npu3image4xi import retain3image4npu
from opu3image4xi import retain3image4opu
from ppu3image4xi import retain3image4ppu
from qpu3image4xi import retain3image4qpu
from rpu3image4xi import retain3image4rpu
from spu3image4xi import retain3image4spu
from tpu3image4xi import retain3image4tpu
from upu3image4xi import retain3image4upu
from vpu3image4xi import retain3image4vpu
from xpu3image4xi import retain3image4xpu
from wpu3image4xi import retain3image4wpu
from ypu3image4xi import retain3image4ypu
from zpu3image4xi import retain3image4zpu

from apu3image4xi import release3image4apu                                                            
from bpu3image4xi import release3image4bpu
from cpu3image4xi import release3image4cpu
from dpu3image4xi import release3image4dpu
from epu3image4xi import release3image4epu
from fpu3image4xi import release3image4fpu
from gpu3image4xi import release3image4gpu
from hpu3image4xi import release3image4hpu
from ipu3image4xi import release3image4ipu
from jpu3image4xi import release3image4jpu
from kpu3image4xi import release3image4kpu
from lpu3image4xi import release3image4lpu
from mpu3image4xi import release3image4mpu
from npu3image4xi import release3image4npu
from opu3image4xi import release3image4opu
from ppu3image4xi import release3image4ppu
from qpu3image4xi import release3image4qpu
from rpu3image4xi import release3image4rpu
from spu3image4xi import release3image4spu
from tpu3image4xi import release3image4tpu
from upu3image4xi import release3image4upu
from vpu3image4xi import release3image4vpu
from xpu3image4xi import release3image4xpu
from wpu3image4xi import release3image4wpu
from ypu3image4xi import release3image4ypu
from zpu3image4xi import release3image4zpu

from apu3image4xi import set3imagecallback4apu                                                            
from bpu3image4xi import set3imagecallback4bpu
from cpu3image4xi import set3imagecallback4cpu
from dpu3image4xi import set3imagecallback4dpu
from epu3image4xi import set3imagecallback4epu
from fpu3image4xi import set3imagecallback4fpu
from gpu3image4xi import set3imagecallback4gpu
from hpu3image4xi import set3imagecallback4hpu
from ipu3image4xi import set3imagecallback4ipu
from jpu3image4xi import set3imagecallback4jpu
from kpu3image4xi import set3imagecallback4kpu
from lpu3image4xi import set3imagecallback4lpu
from mpu3image4xi import set3imagecallback4mpu
from npu3image4xi import set3imagecallback4npu
from opu3image4xi import set3imagecallback4opu
from ppu3image4xi import set3imagecallback4ppu
from qpu3image4xi import set3imagecallback4qpu
from rpu3image4xi import set3imagecallback4rpu
from spu3image4xi import set3imagecallback4spu
from tpu3image4xi import set3imagecallback4tpu
from upu3image4xi import set3imagecallback4upu
from vpu3image4xi import set3imagecallback4vpu
from xpu3image4xi import set3imagecallback4xpu
from wpu3image4xi import set3imagecallback4wpu
from ypu3image4xi import set3imagecallback4ypu
from zpu3image4xi import set3imagecallback4zpu

from apu3image4xi import set3image4apu                                                            
from bpu3image4xi import set3image4bpu
from cpu3image4xi import set3image4cpu
from dpu3image4xi import set3image4dpu
from epu3image4xi import set3image4epu
from fpu3image4xi import set3image4fpu
from gpu3image4xi import set3image4gpu
from hpu3image4xi import set3image4hpu
from ipu3image4xi import set3image4ipu
from jpu3image4xi import set3image4jpu
from kpu3image4xi import set3image4kpu
from lpu3image4xi import set3image4lpu
from mpu3image4xi import set3image4mpu
from npu3image4xi import set3image4npu
from opu3image4xi import set3image4opu
from ppu3image4xi import set3image4ppu
from qpu3image4xi import set3image4qpu
from rpu3image4xi import set3image4rpu
from spu3image4xi import set3image4spu
from tpu3image4xi import set3image4tpu
from upu3image4xi import set3image4upu
from vpu3image4xi import set3image4vpu
from xpu3image4xi import set3image4xpu
from wpu3image4xi import set3image4wpu
from ypu3image4xi import set3image4ypu
from zpu3image4xi import set3image4zpu

from apu3image4xi import trace3image4apu                                                            
from bpu3image4xi import trace3image4bpu
from cpu3image4xi import trace3image4cpu
from dpu3image4xi import trace3image4dpu
from epu3image4xi import trace3image4epu
from fpu3image4xi import trace3image4fpu
from gpu3image4xi import trace3image4gpu
from hpu3image4xi import trace3image4hpu
from ipu3image4xi import trace3image4ipu
from jpu3image4xi import trace3image4jpu
from kpu3image4xi import trace3image4kpu
from lpu3image4xi import trace3image4lpu
from mpu3image4xi import trace3image4mpu
from npu3image4xi import trace3image4npu
from opu3image4xi import trace3image4opu
from ppu3image4xi import trace3image4ppu
from qpu3image4xi import trace3image4qpu
from rpu3image4xi import trace3image4rpu
from spu3image4xi import trace3image4spu
from tpu3image4xi import trace3image4tpu
from upu3image4xi import trace3image4upu
from vpu3image4xi import trace3image4vpu
from xpu3image4xi import trace3image4xpu
from wpu3image4xi import trace3image4wpu
from ypu3image4xi import trace3image4ypu
from zpu3image4xi import trace3image4zpu

from apu3image4xi import wait3image4apu                                                            
from bpu3image4xi import wait3image4bpu
from cpu3image4xi import wait3image4cpu
from dpu3image4xi import wait3image4dpu
from epu3image4xi import wait3image4epu
from fpu3image4xi import wait3image4fpu
from gpu3image4xi import wait3image4gpu
from hpu3image4xi import wait3image4hpu
from ipu3image4xi import wait3image4ipu
from jpu3image4xi import wait3image4jpu
from kpu3image4xi import wait3image4kpu
from lpu3image4xi import wait3image4lpu
from mpu3image4xi import wait3image4mpu
from npu3image4xi import wait3image4npu
from opu3image4xi import wait3image4opu
from ppu3image4xi import wait3image4ppu
from qpu3image4xi import wait3image4qpu
from rpu3image4xi import wait3image4rpu
from spu3image4xi import wait3image4spu
from tpu3image4xi import wait3image4tpu
from upu3image4xi import wait3image4upu
from vpu3image4xi import wait3image4vpu
from xpu3image4xi import wait3image4xpu
from wpu3image4xi import wait3image4wpu
from ypu3image4xi import wait3image4ypu
from zpu3image4xi import wait3image4zpu

from apu3image4xi import write3image4apu                                                            
from bpu3image4xi import write3image4bpu
from cpu3image4xi import write3image4cpu
from dpu3image4xi import write3image4dpu
from epu3image4xi import write3image4epu
from fpu3image4xi import write3image4fpu
from gpu3image4xi import write3image4gpu
from hpu3image4xi import write3image4hpu
from ipu3image4xi import write3image4ipu
from jpu3image4xi import write3image4jpu
from kpu3image4xi import write3image4kpu
from lpu3image4xi import write3image4lpu
from mpu3image4xi import write3image4mpu
from npu3image4xi import write3image4npu
from opu3image4xi import write3image4opu
from ppu3image4xi import write3image4ppu
from qpu3image4xi import write3image4qpu
from rpu3image4xi import write3image4rpu
from spu3image4xi import write3image4spu
from tpu3image4xi import write3image4tpu
from upu3image4xi import write3image4upu
from vpu3image4xi import write3image4vpu
from xpu3image4xi import write3image4xpu
from wpu3image4xi import write3image4wpu
from ypu3image4xi import write3image4ypu
from zpu3image4xi import write3image4zpu

# -------------------------------------------------------------------------------------------------
# Buffer module                           
# -------------------------------------------------------------------------------------------------
from buffer4xi import Buffer4Xi
from buffer4xi import create2buffer4xi
from buffer4xi import create2subbuffer4xi
from buffer4xi import get2bufferinfo4xi
from buffer4xi import release2buffer4xi
from buffer4xi import retain2buffer4xi
from buffer4xi import set2buffer4xi


# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from commandqueue4xi import CommandQueue4Xi
from commandqueue4xi import create2commandqueue4xi 
from commandqueue4xi import flush2commandqueue4xi
from commandqueue4xi import finish2commandqueue4xi
from commandqueue4xi import get2commandqueueinfo4xi
from commandqueue4xi import release2commandqueue4xi
from commandqueue4xi import retain2commandqueue4xi
from commandqueue4xi import set2commandqueue4xi


# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from context4xi import Context4Xi 
from context4xi import create2context4xi
from context4xi import get2context4xi
from context4xi import release2context4xi
from context4xi import retain2context4xi
from context4xi import set2context4xi


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from device4xi import Device4Xi
from device4xi import init2device4xi 
from device4xi import set2device4xi
from device4xi import get2device4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from event4xi import Event4Xi


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global image3d4xi                                                      # 3D-IMAGES

global image3dtrace4xi                                                 # TRACE

global image3dbuffer4xi                                                # BUFFER FOR 3D-IMAGES
global info3image4xi                                                   # IMAGE INFORMATION

global platform3xi                                                     # PLATFORM
global device3xi                                                       # DEVICE
global context3xi                                                      # CONTEXT

global mission3read                                                    # MISSION TO READ
global mission3copy                                                    # MISSION TO COPY 
global mission3copyimagetobuffer                                       # MISSION TO COPYIMAGETOBUFFER     
global mission3copybuffertoimage                                       # MISSION TO COPYBUFFERTOIMAGE  
global mission3map                                                     # MISSION TO MAP                                       
global mission3write                                                   # MISSION TO WRITE  

global control3readimage4xi                                            # COMMAND AND CONTROL TO READ 3D IMAGES  
global state3read4xi                                                   # STATE FOR COMMAND AND CONTROL
global max3readstate4xi                                                # MAX FOR STATE
global ack3readinfo4xi                                                 # ACK FOR IMAGE INFO
global message3readget4xi                                              # QUEUE GET
global message3readput4xi                                              # QUEUE PUT
global message3readreceive4xi                                          # PIPE RECEIVE
global message3readsend4xi                                             # PIPE SEND

global control3writeimage4xi                                           # COMMAND AND CONTROL TO WRITE 3D IMAGES 
global state3write4xi                                                  # STATE FOR COMMAND AND CONTROL
global max3writestate4xi                                               # MAX FOR STATE
global ack3writeinfo4xi                                                # ACK FOR IMAGE INFO
global message3writeget4xi                                             # QUEUE GET
global message3writeput4xi                                             # QUEUE PUT
global message3writereceive4xi                                         # PIPE RECEIVE
global message3writesend4xi                                            # PIPE SEND

global control3copy4xi                                                 # COMMAND AND CONTROL TO COPY 3D IMAGES 
global state3copy4xi                                                   # STATE FOR COMMAND AND CONTROL
global max3copystate4xi                                                # MAX FOR STATE
global ack3copyinfo4xi                                                 # ACK FOR IMAGE INFO
global message3copyget4xi                                              # QUEUE GET
global message3copyput4xi                                              # QUEUE PUT
global message3copyreceive4xi                                          # PIPE RECEIVE
global message3copysend4xi                                             # PIPE SEND

global control3copytobuffer4xi                                         # COMMAND AND CONTROL TO COPY 3D IMAGES TO BUFFER WITH XI 
global state3copyimagetobuffer4xi                                      # STATE FOR COMMAND AND CONTROL
global max3copyimagetobufferstate4xi                                   # MAX FOR STATE
global ack3copyimagetobufferinfo4xi                                    # ACK FOR IMAGE INFO
global message3copyimagetobufferget4xi                                 # QUEUE GET
global message3copyimagetobufferput4xi                                 # QUEUE PUT
global message3copyimagetobufferreceive4xi                             # PIPE RECEIVE
global message3copyimagetobuffersend4xi                                # PIPE SEND

global control3copybuffertoimage4xi                                    # COMMAND AND CONTROL TO COPY BUFFER TO 3D IMAGE WITH XI 
global state3copybuffertoimage4xi                                      # STATE FOR COMMAND AND CONTROL
global max3copybuffertoimagestate4xi                                   # MAX FOR STATE
global ack3copybuffertoimageinfo4xi                                    # ACK FOR IMAGE INFO
global message3copybuffertoimageget4xi                                 # QUEUE GET
global message3copybuffertoimageput4xi                                 # QUEUE PUT
global message3copybuffertoimagereceive4xi                             # PIPE RECEIVE
global message3copybuffertoimagesend4xi                                # PIPE SEND                      

global control3mapimage4xi                                             # COMMAND AND CONTROL TO READ  3D IMAGES  
global state3map4xi                                                    # STATE FOR COMMAND AND CONTROL
global max3mapstate4xi                                                 # MAX FOR STATE
global ack3mapinfo4xi                                                  # ACK FOR IMAGE INFO
global message3mapget4xi                                               # QUEUE GET
global message3mapput4xi                                               # QUEUE PUT
global message3mapreceive4xi                                           # PIPE RECEIVE
global message3mapsend4xi                                              # PIPE SEND

          
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
image3d4xi = {}                                                      # 3D-IMAGES
image3dtrace4xi = {}                                                 # TRACE
image3dbuffer4xi = {}                                                # BUFFER FOR 3D-IMAGES
info3image4xi = {}                                                   # IMAGE INFORMATION

platform3xi = {}                                                     # PLATFORM
device3xi   = {}                                                     # DEVICE
context3xi  = {}                                                     # CONTEXT

mission3read = "NACK"                                                # MISSION TO READ

control3readimage4xi = {}                                            # COMMAND AND CONTROL TO READ 3D IMAGES  

state3read4xi = {}                                                   # STATE FOR COMMAND AND CONTROL
    
max3readstate4xi = {}                                                # MAX FOR STATE
ack3readinfo4xi = {}                                                 # ACK FOR IMAGE INFO
message3readget4xi = {}                                              # QUEUE GET
message3readput4xi = {}                                              # QUEUE PUT
message3readreceive4xi = {}                                          # PIPE RECEIVE
message3readsend4xi = {}                                             # PIPE SEND

control3writeimage4xi = {}                                           # COMMAND AND CONTROL TO WRITE 3D IMAGES 
state3write4xi = {}                                                  # STATE FOR COMMAND AND CONTROL
max3writestate4xi = {}                                               # MAX FOR STATE
ack3writeinfo4xi = {}                                                # ACK FOR IMAGE INFO
message3writeget4xi = {}                                             # QUEUE GET
message3writeput4xi = {}                                             # QUEUE PUT
message3writereceive4xi = {}                                         # PIPE RECEIVE
message3writesend4xi = {}                                            # PIPE SEND

control3copy4xi = {}                                                 # COMMAND AND CONTROL TO COPY 3D IMAGES 
state3copy4xi = {}                                                   # STATE FOR COMMAND AND CONTROL
max3copystate4xi = {}                                                # MAX FOR STATE
ack3copyinfo4xi = {}                                                 # ACK FOR IMAGE INFO
message3copyget4xi = {}                                              # QUEUE GET
message3copyput4xi = {}                                              # QUEUE PUT
message3copyreceive4xi = {}                                          # PIPE RECEIVE
message3copysend4xi = {}                                             # PIPE SEND

control3copytobuffer4xi = {}                                         # COMMAND AND CONTROL TO COPY 3D IMAGES TO BUFFER WITH XI 
state3copyimagetobuffer4xi = {}                                      # STATE FOR COMMAND AND CONTROL
max3copyimagetobufferstate4xi = {}                                   # MAX FOR STATE
ack3copyimagetobufferinfo4xi = {}                                    # ACK FOR IMAGE INFO
message3copyimagetobufferget4xi = {}                                 # QUEUE GET
message3copyimagetobufferput4xi = {}                                 # QUEUE PUT
message3copyimagetobufferreceive4xi = {}                             # PIPE RECEIVE
message3copyimagetobuffersend4xi = {}                                # PIPE SEND

control3copybuffertoimage4xi = {}                                    # COMMAND AND CONTROL TO COPY BUFFER TO 3D IMAGE WITH XI 
state3copybuffertoimage4xi = {}                                      # STATE FOR COMMAND AND CONTROL
max3copybuffertoimagestate4xi = {}                                   # MAX FOR STATE
ack3copybuffertoimageinfo4xi = {}                                    # ACK FOR IMAGE INFO
message3copybuffertoimageget4xi = {}                                 # QUEUE GET
message3copybuffertoimageput4xi = {}                                 # QUEUE PUT
message3copybuffertoimagereceive4xi = {}                             # PIPE RECEIVE
message3copybuffertoimagesend4xi = {}                                # PIPE SEND                      

control3mapimage4xi = {}                                             # COMMAND AND CONTROL TO READ  3D IMAGES  
state3map4xi = {}                                                    # STATE FOR COMMAND AND CONTROL
max3mapstate4xi = {}                                                 # MAX FOR STATE
ack3mapinfo4xi = {}                                                  # ACK FOR IMAGE INFO
message3mapget4xi = {}                                               # QUEUE GET
message3mapput4xi = {}                                               # QUEUE PUT
message3mapreceive4xi = {}                                           # PIPE RECEIVE
message3mapsend4xi = {}                                              # PIPE SEND
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace3image4xi" usage = "  
#
#   print('(Step 15A/25) OF IMAGE3D4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
#   try:                               
#       task4trace3image  = {}
#       for key3pu in keys3pu:
#           task4trace3image[key3pu]  = {}
#       response4trace3image = trace3image4xi(task4trace3image)  
#       key3response = response4trace3image.keys()
#       for key3response in sorted(keys3response):
#           print(key3response, ' : ', response4trace3image[key3response] )
#           # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4apu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace3image4apu', 'METHOD': 'trace3image4apu'}
#           # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4gpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace3image4gpu', 'METHOD': 'trace3image4gpu'}
#           # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4xpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace3image4xpu', 'METHOD': 'trace3image4xpu'}
#           # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4zpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace3image4zpu', 'METHOD': 'trace3image4zpu'}                                                                                                  
#   except:
#       print('(Step 15Z1/25) OF IMAGE3D4XI5TEST *** FAILED TO TRACE XI: ', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def trace3image4xi(task4trace3xi=None):  

    '''
    creates callback to image3d4xi
    '''

    global image3dtrace4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    debug = True
    
    class3print = "trace3image4xi" 
    method3print = "trace3image4xi"

    message3print = "{(Step 1A/33) started" + "; trace3image4xi-started: " + str(trace3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                              
    # <function trace3image4xi at 0x0000000003AF0348> 
  
             
    message3print = "{(Step 1B/33) passed" + "; task4trace3xi-to-trace3image4xi: " + str(task4trace3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              # 
    # None 

    code3ack  = ' '
    code3nack = ' '    
    
    image3dtrace4xi = {}                                                                                             # INITIALIZES TO EMPTY DICTIONARY
      
      
    if task4trace3xi is None:
        keys3task = None    
    else:
        try:
            keys3task = task4trace3xi.keys()
        except:
            keys3task = None   
    if debug is True:
       print("{(Step 1C/33) of trace3image4xi - keys3task: ", sorted(keys3task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys3task:
            message3print = "{(Step A/33) passing" + "; task-passing-to-trace3image4apu: " + str(task4trace3xi['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            
            image3dtrace4xi ['APU']  = trace3image4apu()                                                      
             
            message3print = "{(Step A1/33) set" + "; apu-image-trace-set-by-trace3image4apu to: " + str(image3dtrace4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of trace3image4xi - set trace4xi of APU image to: ", image3dtrace4xi ['APU'])
            
            code3ack  = code3ack + 'A1-'
        else:
            pass    
    except:
        message3print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-trace3image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys3task:
            message3print = "{(Step B/33) passing" + "; task-passing-to-trace3image4bpu: " + str(task4trace3xi['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['BPU']  = trace3image4bpu()                                                      # 
         
            message3print = "{(Step B1/33) set" + "; bpu-image-trace-set-by-trace3image4bpu to: " + str(image3dtrace4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'B1-'
        else:
            pass    
    except:
        message3print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-trace3image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys3task:
            message3print = "{(Step C/33) passing" + "; task-passing-to-trace3image4cpu: " + str(task4trace3xi['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['CPU']  = trace3image4cpu()                                                      # 
         
            message3print = "{(Step C1/33) set" + "; cpu-image-trace-set-by-trace3image4cpu to: " + str(image3dtrace4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'C1-'
        else:
            pass    
    except:
        message3print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-trace3image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys3task:
            message3print = "{(Step D/33) passing" + "; task-passing-to-trace3image4dpu: " + str(task4trace3xi['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['DPU']  = trace3image4dpu()                                                      # 
         
            message3print = "{(Step D1/33) set" + "; dpu-image-trace-set-by-trace3image4dpu to: " + str(image3dtrace4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'D1-'
        else:
            pass    
    except:
        message3print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-trace3image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys3task:
            message3print = "{(Step E/33) passing" + "; task-passing-to-trace3image4epu: " + str(task4trace3xi['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['EPU']  = trace3image4epu()                                                      # 
         
            message3print = "{(Step E1/33) set" + "; epu-image-trace-set-by-trace3image4epu to: " + str(image3dtrace4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'E1-'
        else:
            pass    
    except:
        message3print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-trace3image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys3task:
            message3print = "{(Step F/33) passing" + "; task-passing-to-trace3image4fpu: " + str(task4trace3xi['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['FPU']  = trace3image4fpu()                                                      # 
         
            message3print = "{(Step F1/33) set" + "; fpu-image-trace-set-by-trace3image4fpu to: " + str(image3dtrace4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'F1-'
        else:
            pass    
    except:
        message3print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-trace3image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys3task:
            message3print = "{(Step G/33) passing" + "; task-passing-to-trace3image4gpu: " + str(task4trace3xi['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['GPU']  = trace3image4gpu()                                                      # 
         
            message3print = "{(Step G1/33) set" + "; gpu-image-trace-set-by-trace3image4gpu to: " + str(image3dtrace4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'G1-'
        else:
            pass    
    except:
        message3print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-trace3image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys3task:
            message3print = "{(Step H/33) passing" + "; task-passing-to-trace3image4hpu: " + str(task4trace3xi['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['HPU']  = trace3image4hpu()                                                      # 
         
            message3print = "{(Step H1/33) set" + "; hpu-image-trace-set-by-trace3image4hpu to: " + str(image3dtrace4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'H1-'
        else:
            pass    
    except:
        message3print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-trace3image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys3task:
            message3print = "{(Step I/33) passing" + "; task-passing-to-trace3image4ipu: " + str(task4trace3xi['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['IPU']  = trace3image4ipu()                                                      # 
         
            message3print = "{(Step I1/33) set" + "; ipu-image-trace-set-by-trace3image4ipu to: " + str(image3dtrace4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'I1-'
        else:
            pass    
    except:
        message3print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-trace3image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys3task:
            message3print = "{(Step J/33) passing" + "; task-passing-to-trace3image4jpu: " + str(task4trace3xi['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['JPU']  = trace3image4jpu()                                                      # 
         
            message3print = "{(Step J1/33) set" + "; jpu-image-trace-set-by-trace3image4jpu to: " + str(image3dtrace4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'J1-'
        else:
            pass    
    except:
        message3print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-trace3image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys3task:
            message3print = "{(Step K/33) passing" + "; task-passing-to-trace3image4kpu: " + str(task4trace3xi['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['KPU']  = trace3image4kpu()                                                      # 
         
            message3print = "{(Step K1/33) set" + "; kpu-image-trace-set-by-trace3image4kpu to: " + str(image3dtrace4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'K1-'
        else:
            pass    
    except:
        message3print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-trace3image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys3task:
            message3print = "{(Step L/33) passing" + "; task-passing-to-trace3image4lpu: " + str(task4trace3xi['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['LPU']  = trace3image4lpu()                                                      # 
         
            message3print = "{(Step L1/33) set" + "; lpu-image-trace-set-by-trace3image4lpu to: " + str(image3dtrace4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + '1-'
        else:
            pass    
    except:
        message3print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-trace3image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys3task:
            message3print = "{(Step M/33) passing" + "; task-passing-to-trace3image4mpu: " + str(task4trace3xi['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['MPU']  = trace3image4mpu()                                                      # 
         
            message3print = "{(Step M1/33) set" + "; mpu-image-trace-set-by-trace3image4mpu to: " + str(image3dtrace4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'M1-'
        else:
            pass    
    except:
        message3print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-trace3image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys3task:
            message3print = "{(Step N/33) passing" + "; task-passing-to-trace3image4npu: " + str(task4trace3xi['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['NPU']  = trace3image4npu()                                                      # 
         
            message3print = "{(Step N1/33) set" + "; npu-image-trace-set-by-trace3image4npu to: " + str(image3dtrace4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'N1-'
        else:
            pass    
    except:
        message3print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-trace3image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys3task:
            message3print = "{(Step O/33) passing" + "; task-passing-to-trace3image4opu: " + str(task4trace3xi['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['OPU']  = trace3image4opu()                                                      # 
         
            message3print = "{(Step O1/33) set" + "; opu-image-trace-set-by-trace3image4opu to: " + str(image3dtrace4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'O1-'
        else:
            pass    
    except:
        message3print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-trace3image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys3task:
            message3print = "{(Step P/33) passing" + "; task-passing-to-trace3image4ppu: " + str(task4trace3xi['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['PPU']  = trace3image4ppu()                                                      # 
         
            message3print = "{(Step P1/33) set" + "; ppu-image-trace-set-by-trace3image4ppu to: " + str(image3dtrace4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'P1-'
        else:
            pass    
    except:
        message3print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-trace3image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys3task:
            message3print = "{(Step Q/33) passing" + "; task-passing-to-trace3image4qpu: " + str(task4trace3xi['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['QPU']  = trace3image4qpu()                                                      # 
         
            message3print = "{(Step Q1/33) set" + "; qpu-image-trace-set-by-trace3image4qpu to: " + str(image3dtrace4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'Q1-'
        else:
            pass    
    except:
        message3print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-trace3image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys3task:
            message3print = "{(Step R/33) passing" + "; task-passing-to-trace3image4rpu: " + str(task4trace3xi['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['RPU']  = trace3image4rpu()                                                      # 
         
            message3print = "{(Step R1/33) set" + "; rpu-image-trace-set-by-trace3image4rpu to: " + str(image3dtrace4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'R1-'
        else:
            pass    
    except:
        message3print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-trace3image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys3task:
            message3print = "{(Step S/33) passing" + "; task-passing-to-trace3image4spu: " + str(task4trace3xi['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['SPU']  = trace3image4spu()                                                      # 
         
            message3print = "{(Step S1/33) set" + "; spu-image-trace-set-by-trace3image4spu to: " + str(image3dtrace4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'S1-'
        else:
            pass    
    except:
        message3print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-trace3image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys3task:
            message3print = "{(Step T/33) passing" + "; task-passing-to-trace3image4tpu: " + str(task4trace3xi['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['TPU']  = trace3image4tpu()                                                      # 
         
            message3print = "{(Step T1/33) set" + "; tpu-image-trace-set-by-trace3image4tpu to: " + str(image3dtrace4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'T1-'
        else:
            pass    
    except:
        message3print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-trace3image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys3task:
            message3print = "{(Step U/33) passing" + "; task-passing-to-trace3image4upu: " + str(task4trace3xi['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['UPU']  = trace3image4upu()                                                      # 
         
            message3print = "{(Step U1/33) set" + "; upu-image-trace-set-by-trace3image4upu to: " + str(image3dtrace4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'U1-'
        else:
            pass    
    except:
        message3print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-trace3image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys3task:
            message3print = "{(Step V/33) passing" + "; task-passing-to-trace3image4vpu: " + str(task4trace3xi['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['VPU']  = trace3image4vpu()                                                      # 
         
            message3print = "{(Step V1/33) set" + "; vpu-image-trace-set-by-trace3image4vpu to: " + str(image3dtrace4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'V1-'
        else:
            pass    
    except:
        message3print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-trace3image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys3task:
            message3print = "{(Step W/33) passing" + "; task-passing-to-trace3image4wpu: " + str(task4trace3xi['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['WPU']  = trace3image4wpu()                                                      # 
         
            message3print = "{(Step W1/33) set" + "; wpu-image-trace-set-by-trace3image4wpu to: " + str(image3dtrace4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'W1-'
        else:
            pass    
    except:
        message3print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-trace3image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys3task:
            message3print = "{(Step X/33) passing" + "; task-passing-to-trace3image4xpu: " + str(task4trace3xi['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['XPU']  = trace3image4xpu()                                                      # 
         
            message3print = "{(Step X1/33) set" + "; xpu-image-trace-set-by-trace3image4xpu to: " + str(image3dtrace4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of trace3image4xi - set trace4xi of XPU image to: ", image3dtrace4xi ['XPU'])
            code3ack  = code3ack + 'X1-'
        else:
            pass    
    except:
        message3print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-trace3image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys3task:
            message3print = "{(Step Y/33) passing" + "; task-passing-to-trace3image4ypu: " + str(task4trace3xi['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['YPU']  = trace3image4ypu()                                                      # 
         
            message3print = "{(Step Y1/33) set" + "; ypu-image-trace-set-by-trace3image4ypu to: " + str(image3dtrace4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'Y1-'
        else:
            pass    
    except:
        message3print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-trace3image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys3task:
            message3print = "{(Step Z/33) passing" + "; task-passing-to-trace3image4zpu: " + str(task4trace3xi['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3dtrace4xi ['ZPU']  = trace3image4zpu()                                                      # 
         
            message3print = "{(Step Z1/33) set" + "; zpu-image-trace-set-by-trace3image4zpu to: " + str(image3dtrace4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of trace3image4xi - set trace4xi of ZPU image to: ", image3dtrace4xi ['ZPU'])
            code3ack  = code3ack + 'Z1-'
        else:
            pass    
    except:
        message3print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-trace3image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of trace3image4xi image3dtrace4xi - RETURNING : ", image3dtrace4xi)
    
    message3print = "{(Step 33/33) returning" + "; image3dtrace4xi-returning-by-trace3image4xi: " + str(image3dtrace4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)
    # 
    
    return image3dtrace4xi


#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set3imagecallback4xi" usage = " 
#
#   print('(Step 14B/700) OF IMAGE3D4XI5TEST - TRYING TO SET 3D IMAGE CALLBACK OF XI DEVICE ', time4xi())     
#   try:                               
#       task4callback3image  = {}
#       for key3pu in keys3pu:
#           task4callback3image[key3pu]  = {}
#       response4setcallback3image = set3imagecallback4xi(task4callback3image) 
#       key3response = response4setcallback3image.keys()
#       for key3response in sorted(keys3response):
#           print(key3response, ' : ', response4setcallback3image[key3response])
#           # APU  :  <function trace3image4apu at 0x00000000043F1C48>
#           # ...
#           # ZPU  :  <function trace3image4zpu at 0x00000000058610C8>
#                                                                                                     
#   except:
#       print('(Step 14Z2/700) OF IMAGE3D4XI5TEST *** FAILED TO SET 3D IMAGE CALLBACK OF XI DEVICE ', time4xi())
#
#">

# ------------------------------------------------------------------------------------------------- 
 
def set3imagecallback4xi(task4set3imagecallback=None):

    '''
    registers callback function to image3d4xi
    '''
    global image3d4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    
    class3print = "set3imagecallback4xi"
    method3print = "set3imagecallback4xi"

    message3print = "{(Step 1A/33) started" + "; set3imagecallback4xi-started: " + str(set3imagecallback4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                                     #  
    # <function set3imagecallback4xi at 0x0000000003A62848> 
    
    message3print = "{(Step 1B/33) passed" + "; task4imageset3xi-to-set3imagecallback4xi: " + str(task4set3imagecallback) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # 
            
    code3ack  = ' '
    code3nack = ' '
    if image3d4xi is None:
        image3d4xi = create3image3d4xi()                                                                            
                                
        message3print = "{(Step 1C/33) set" + "; image3d4xi-set-by-set3imagecallback4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        code3ack  = code3ack + '1C-'
    else:
        pass    
    
        
    if task4set3imagecallback is None:
        keys3task = None    
    else:
        try:
            keys3task = task4set3imagecallback.keys()
        except:
            keys3task = None   
    if debug is True:
       print("{(Step 1C/33) of set3imagecallback4xi - keys3task: ", sorted(keys3task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys3task:
            message3print = "{(Step A/33) passing" + "; task-passing-to-set3imagecallback4apu: " + str(task4set3imagecallback['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            
            image3d4xi ['APU'] ['CALLBACK'] = set3imagecallback4apu()                                                      # 
             
            message3print = "{(Step A1/33) set" + "; apu-image-set-by-set3imagecallback4apu to: " + str(image3d4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of set3imagecallback4xi - set callback4xi of APU image to: ", image3d4xi ['APU'] ['CALLBACK'])
            
            code3ack  = code3ack + 'A1-'
        else:
            pass    
    except:
        message3print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set3imagecallback4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys3task:
            message3print = "{(Step B/33) passing" + "; task-passing-to-set3imagecallback4bpu: " + str(task4set3imagecallback['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['BPU'] ['CALLBACK'] = set3imagecallback4bpu()                                                      # 
         
            message3print = "{(Step B1/33) set" + "; bpu-image-set-by-set3imagecallback4bpu to: " + str(image3d4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'B1-'
        else:
            pass    
    except:
        message3print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set3imagecallback4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys3task:
            message3print = "{(Step C/33) passing" + "; task-passing-to-set3imagecallback4cpu: " + str(task4set3imagecallback['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['CPU'] ['CALLBACK'] = set3imagecallback4cpu()                                                      # 
         
            message3print = "{(Step C1/33) set" + "; cpu-image-set-by-set3imagecallback4cpu to: " + str(image3d4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'C1-'
        else:
            pass    
    except:
        message3print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set3imagecallback4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys3task:
            message3print = "{(Step D/33) passing" + "; task-passing-to-set3imagecallback4dpu: " + str(task4set3imagecallback['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['DPU'] ['CALLBACK'] = set3imagecallback4dpu()                                                      # 
         
            message3print = "{(Step D1/33) set" + "; dpu-image-set-by-set3imagecallback4dpu to: " + str(image3d4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'D1-'
        else:
            pass    
    except:
        message3print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set3imagecallback4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys3task:
            message3print = "{(Step E/33) passing" + "; task-passing-to-set3imagecallback4epu: " + str(task4set3imagecallback['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['EPU'] ['CALLBACK'] = set3imagecallback4epu()                                                      # 
         
            message3print = "{(Step E1/33) set" + "; epu-image-set-by-set3imagecallback4epu to: " + str(image3d4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'E1-'
        else:
            pass    
    except:
        message3print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set3imagecallback4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys3task:
            message3print = "{(Step F/33) passing" + "; task-passing-to-set3imagecallback4fpu: " + str(task4set3imagecallback['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['FPU'] ['CALLBACK'] = set3imagecallback4fpu()                                                      # 
         
            message3print = "{(Step F1/33) set" + "; fpu-image-set-by-set3imagecallback4fpu to: " + str(image3d4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'F1-'
        else:
            pass    
    except:
        message3print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set3imagecallback4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys3task:
            message3print = "{(Step G/33) passing" + "; task-passing-to-set3imagecallback4gpu: " + str(task4set3imagecallback['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['GPU'] ['CALLBACK'] = set3imagecallback4gpu()                                                      # 
         
            message3print = "{(Step G1/33) set" + "; gpu-image-set-by-set3imagecallback4gpu to: " + str(image3d4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'G1-'
        else:
            pass    
    except:
        message3print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set3imagecallback4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys3task:
            message3print = "{(Step H/33) passing" + "; task-passing-to-set3imagecallback4hpu: " + str(task4set3imagecallback['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['HPU'] ['CALLBACK'] = set3imagecallback4hpu()                                                      # 
         
            message3print = "{(Step H1/33) set" + "; hpu-image-set-by-set3imagecallback4hpu to: " + str(image3d4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'H1-'
        else:
            pass    
    except:
        message3print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set3imagecallback4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys3task:
            message3print = "{(Step I/33) passing" + "; task-passing-to-set3imagecallback4ipu: " + str(task4set3imagecallback['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['IPU'] ['CALLBACK'] = set3imagecallback4ipu()                                                      # 
         
            message3print = "{(Step I1/33) set" + "; ipu-image-set-by-set3imagecallback4ipu to: " + str(image3d4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'I1-'
        else:
            pass    
    except:
        message3print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set3imagecallback4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys3task:
            message3print = "{(Step J/33) passing" + "; task-passing-to-set3imagecallback4jpu: " + str(task4set3imagecallback['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['JPU'] ['CALLBACK'] = set3imagecallback4jpu()                                                      # 
         
            message3print = "{(Step J1/33) set" + "; jpu-image-set-by-set3imagecallback4jpu to: " + str(image3d4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'J1-'
        else:
            pass    
    except:
        message3print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set3imagecallback4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys3task:
            message3print = "{(Step K/33) passing" + "; task-passing-to-set3imagecallback4kpu: " + str(task4set3imagecallback['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['KPU'] ['CALLBACK'] = set3imagecallback4kpu()                                                      # 
         
            message3print = "{(Step K1/33) set" + "; kpu-image-set-by-set3imagecallback4kpu to: " + str(image3d4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'K1-'
        else:
            pass    
    except:
        message3print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set3imagecallback4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys3task:
            message3print = "{(Step L/33) passing" + "; task-passing-to-set3imagecallback4lpu: " + str(task4set3imagecallback['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['LPU'] ['CALLBACK'] = set3imagecallback4lpu()                                                      # 
         
            message3print = "{(Step L1/33) set" + "; lpu-image-set-by-set3imagecallback4lpu to: " + str(image3d4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + '1-'
        else:
            pass    
    except:
        message3print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set3imagecallback4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys3task:
            message3print = "{(Step M/33) passing" + "; task-passing-to-set3imagecallback4mpu: " + str(task4set3imagecallback['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['MPU'] ['CALLBACK'] = set3imagecallback4mpu()                                                      # 
         
            message3print = "{(Step M1/33) set" + "; mpu-image-set-by-set3imagecallback4mpu to: " + str(image3d4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'M1-'
        else:
            pass    
    except:
        message3print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set3imagecallback4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys3task:
            message3print = "{(Step N/33) passing" + "; task-passing-to-set3imagecallback4npu: " + str(task4set3imagecallback['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['NPU'] ['CALLBACK'] = set3imagecallback4npu()                                                      # 
         
            message3print = "{(Step N1/33) set" + "; npu-image-set-by-set3imagecallback4npu to: " + str(image3d4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'N1-'
        else:
            pass    
    except:
        message3print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set3imagecallback4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys3task:
            message3print = "{(Step O/33) passing" + "; task-passing-to-set3imagecallback4opu: " + str(task4set3imagecallback['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['OPU'] ['CALLBACK'] = set3imagecallback4opu()                                                      # 
         
            message3print = "{(Step O1/33) set" + "; opu-image-set-by-set3imagecallback4opu to: " + str(image3d4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'O1-'
        else:
            pass    
    except:
        message3print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set3imagecallback4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys3task:
            message3print = "{(Step P/33) passing" + "; task-passing-to-set3imagecallback4ppu: " + str(task4set3imagecallback['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['PPU'] ['CALLBACK'] = set3imagecallback4ppu()                                                      # 
         
            message3print = "{(Step P1/33) set" + "; ppu-image-set-by-set3imagecallback4ppu to: " + str(image3d4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'P1-'
        else:
            pass    
    except:
        message3print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set3imagecallback4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys3task:
            message3print = "{(Step Q/33) passing" + "; task-passing-to-set3imagecallback4qpu: " + str(task4set3imagecallback['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['QPU'] ['CALLBACK'] = set3imagecallback4qpu()                                                      # 
         
            message3print = "{(Step Q1/33) set" + "; qpu-image-set-by-set3imagecallback4qpu to: " + str(image3d4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'Q1-'
        else:
            pass    
    except:
        message3print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set3imagecallback4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys3task:
            message3print = "{(Step R/33) passing" + "; task-passing-to-set3imagecallback4rpu: " + str(task4set3imagecallback['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['RPU'] ['CALLBACK'] = set3imagecallback4rpu()                                                      # 
         
            message3print = "{(Step R1/33) set" + "; rpu-image-set-by-set3imagecallback4rpu to: " + str(image3d4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'R1-'
        else:
            pass    
    except:
        message3print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set3imagecallback4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys3task:
            message3print = "{(Step S/33) passing" + "; task-passing-to-set3imagecallback4spu: " + str(task4set3imagecallback['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['SPU'] ['CALLBACK'] = set3imagecallback4spu()                                                      # 
         
            message3print = "{(Step S1/33) set" + "; spu-image-set-by-set3imagecallback4spu to: " + str(image3d4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'S1-'
        else:
            pass    
    except:
        message3print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set3imagecallback4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys3task:
            message3print = "{(Step T/33) passing" + "; task-passing-to-set3imagecallback4tpu: " + str(task4set3imagecallback['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['TPU'] ['CALLBACK'] = set3imagecallback4tpu()                                                      # 
         
            message3print = "{(Step T1/33) set" + "; tpu-image-set-by-set3imagecallback4tpu to: " + str(image3d4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'T1-'
        else:
            pass    
    except:
        message3print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set3imagecallback4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys3task:
            message3print = "{(Step U/33) passing" + "; task-passing-to-set3imagecallback4upu: " + str(task4set3imagecallback['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['UPU'] ['CALLBACK'] = set3imagecallback4upu()                                                      # 
         
            message3print = "{(Step U1/33) set" + "; upu-image-set-by-set3imagecallback4upu to: " + str(image3d4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'U1-'
        else:
            pass    
    except:
        message3print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set3imagecallback4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys3task:
            message3print = "{(Step V/33) passing" + "; task-passing-to-set3imagecallback4vpu: " + str(task4set3imagecallback['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['VPU'] ['CALLBACK'] = set3imagecallback4vpu()                                                      # 
         
            message3print = "{(Step V1/33) set" + "; vpu-image-set-by-set3imagecallback4vpu to: " + str(image3d4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'V1-'
        else:
            pass    
    except:
        message3print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set3imagecallback4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys3task:
            message3print = "{(Step W/33) passing" + "; task-passing-to-set3imagecallback4wpu: " + str(task4set3imagecallback['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['WPU'] ['CALLBACK'] = set3imagecallback4wpu()                                                      # 
         
            message3print = "{(Step W1/33) set" + "; wpu-image-set-by-set3imagecallback4wpu to: " + str(image3d4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'W1-'
        else:
            pass    
    except:
        message3print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set3imagecallback4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys3task:
            message3print = "{(Step X/33) passing" + "; task-passing-to-set3imagecallback4xpu: " + str(task4set3imagecallback['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['XPU'] ['CALLBACK'] = set3imagecallback4xpu()                                                      # 
         
            message3print = "{(Step X1/33) set" + "; xpu-image-set-by-set3imagecallback4xpu to: " + str(image3d4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of set3imagecallback4xi - set callback4xi of XPU image to: ", image3d4xi ['XPU'] ['CALLBACK'])
            code3ack  = code3ack + 'X1-'
        else:
            pass    
    except:
        message3print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set3imagecallback4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys3task:
            message3print = "{(Step Y/33) passing" + "; task-passing-to-set3imagecallback4ypu: " + str(task4set3imagecallback['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['YPU'] ['CALLBACK'] = set3imagecallback4ypu()                                                      # 
         
            message3print = "{(Step Y1/33) set" + "; ypu-image-set-by-set3imagecallback4ypu to: " + str(image3d4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'Y1-'
        else:
            pass    
    except:
        message3print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set3imagecallback4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys3task:
            message3print = "{(Step Z/33) passing" + "; task-passing-to-set3imagecallback4zpu: " + str(task4set3imagecallback['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['ZPU'] ['CALLBACK'] = set3imagecallback4zpu()                                                      # 
         
            message3print = "{(Step Z1/33) set" + "; zpu-image-set-by-set3imagecallback4zpu to: " + str(image3d4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of set3imagecallback4xi - set callback4xi of ZPU image to: ", image3d4xi ['ZPU'] ['CALLBACK'])
            code3ack  = code3ack + 'Z1-'
        else:
            pass    
    except:
        message3print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set3imagecallback4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of set3imagecallback4xi - RETURNING IMAGE3D4XI: ", image3d4xi)
    
    message3print = "{(Step 33/33) returning" + "; image3d4xi-returning-by-set3imagecallback4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)
    # 
    
    return image3d4xi
         
#</function4xi> 

 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "create3image4xi" usage = "
#1     
#   print('=' *33)          
#   print('(Step 2A/700) OF IMAGE3D4XI5TEST - TRYING TO CREATE 3D IMAGE4XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4create3Dimage = create3image4xi()                                                                 
#       print('(Step 2B/700) OF IMAGE3D4XI5TEST - CREATED 3D IMAGE4XI ', time4xi())
#       keys3response = response4create3Dimage.keys()
#       for key3response in sorted(keys3response):
#           print(key3response, ' : ', response4create3Dimage[key3response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO CREATE 3D IMAGE4XI *** ', time4xi())
#2
#   print('(Step 123A/700) OF IMAGE3D4XI5TEST - TRYING TO CREATE 3D IMAGE for XI ', time4xi()) 
#   # 
#   try:
#       xi3xi = Image3D4Xi()                            
#       response4create3Dimage = xi3xi.create3image()                                  
#       keys3response = response4create3Dimage.keys()
#       print('(Step 122B/700) OF IMAGE3D4XI5TEST - CREATED 3D IMAGE ', time4xi())  
#       for key3response in sorted(keys3response):
#           print(key3response, ' : ', response4create3Dimage[key3response])
#           # 
#   except:
#       print('(Step 123Z/700) OF IMAGE3D4XI5TEST *** FAILED TO CREATE 3D IMAGE for XI ', time4xi())    
#">

# -------------------------------------------------------------------------------------------------   
def create3image4xi(task4imagecreate3xi=None):

    '''
    creates 3D image for device xi
    '''
    global platform3xi
    global device3xi
    global context3xi 
    global image3d4xi
    global info3image4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
        
    class3print = "create3image4xi" 
    method3print = "create3image4xi"

    message3print = "{(Step 1A/70) started" + "; create3image4xi-started: " + str(create3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)
    # <function create3image4xi at 0x00000000038D97C8> 
  
             
    message3print = "{(Step 1B/70) passed" + "; task4imagecreate3xi-to-create3image4xi: " + str(task4imagecreate3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # None 

    code3ack  = ' '
    code3nack = ' '    
    
    ack3all = False             
    if task4imagecreate3xi is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack3all = True                                                                                                
        code3ack  = code3ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - IMAGE3D4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if image3d4xi is None:                                                                                       
                image3d4xi = {} 
                code3ack  = code3ack + '1D-'
        except:
            image3d4xi = {} 
            code3ack  = code3ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message3print = "{(Step 2A/3) try" + "; task4imagecreate3xi-try-by-create3image4xi: " + str(task4imagecreate3xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print) 
    # None 
    
    if ack3all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES - EACH WITH THE CONTEXT OR THEIR OWN (GIVEN BY THE CALLED ONE) 
            # ----------------------------------------------------------------------------------------- 
            image3d4xi = {} 
            image3d4xi['APU'] = create3image4apu()                                                                        
            image3d4xi['BPU'] = create3image4bpu()   
            image3d4xi['CPU'] = create3image4cpu()   
            image3d4xi['DPU'] = create3image4dpu()   
            image3d4xi['EPU'] = create3image4epu()   
            image3d4xi['FPU'] = create3image4fpu()   
            image3d4xi['GPU'] = create3image4gpu()   
            image3d4xi['HPU'] = create3image4hpu()   
            image3d4xi['IPU'] = create3image4ipu()   
            image3d4xi['JPU'] = create3image4jpu()   
            image3d4xi['KPU'] = create3image4kpu()   
            image3d4xi['LPU'] = create3image4lpu()   
            image3d4xi['MPU'] = create3image4mpu()   
            image3d4xi['NPU'] = create3image4npu()   
            image3d4xi['OPU'] = create3image4opu()   
            image3d4xi['PPU'] = create3image4ppu()   
            image3d4xi['QPU'] = create3image4qpu()   
            image3d4xi['RPU'] = create3image4rpu()   
            image3d4xi['SPU'] = create3image4spu()   
            image3d4xi['TPU'] = create3image4tpu()   
            image3d4xi['UPU'] = create3image4upu()   
            image3d4xi['VPU'] = create3image4vpu()   
            image3d4xi['XPU'] = create3image4xpu()   
            image3d4xi['WPU'] = create3image4wpu()   
            image3d4xi['YPU'] = create3image4ypu()   
            image3d4xi['ZPU'] = create3image4zpu()   
            
            message3print = "{(Step 3A/33) initialized" + "; image3d4xi-initialized-by-create3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class3print, method3print, message3print)                                                      
            # 
            
            code3ack  = code3ack + '3A-'
        except:
            message3print = "{(Step 3Z1/33) yielded" + "; image3d4xi-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                               #   
            code3nack  = code3nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['APU'] = create3image4apu(task4imagecreate3xi['APU'])
            
            message3print = "{(Step A/33) initialized" + "; apu-initialized-by-create3image4xi to: " + str(image3d4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'A-'
        except: 
            message3print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['BPU'] = create3image4bpu(task4imagecreate3xi['BPU'])
            
            message3print = "{(Step B/33) initialized" + "; bpu-initialized-by-create3image4xi to: " + str(image3d4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'B-'
        except: 
            message3print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['CPU'] = create3image4cpu(task4imagecreate3xi['CPU'])
            
            message3print = "{(Step C/33) initialized" + "; cpu-initialized-by-create3image4xi to: " + str(image3d4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'C-'
        except: 
            message3print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['DPU'] = create3image4dpu(task4imagecreate3xi['DPU'])
            
            message3print = "{(Step D/33) initialized" + "; dpu-initialized-by-create3image4xi to: " + str(image3d4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'D-'
        except: 
            message3print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['EPU'] = create3image4epu(task4imagecreate3xi['EPU'])
            
            message3print = "{(Step E/33) initialized" + "; epu-initialized-by-create3image4xi to: " + str(image3d4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'E-'
        except: 
            message3print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['FPU'] = create3image4fpu(task4imagecreate3xi['FPU'])
            
            message3print = "{(Step F/33) initialized" + "; fpu-initialized-by-create3image4xi to: " + str(image3d4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'F-'
        except: 
            message3print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['GPU'] = create3image4gpu(task4imagecreate3xi['GPU'])
            
            message3print = "{(Step G/33) initialized" + "; gpu-initialized-by-create3image4xi to: " + str(image3d4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'G-'
        except: 
            message3print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['HPU'] = create3image4hpu(task4imagecreate3xi['HPU'])
            
            message3print = "{(Step H/33) initialized" + "; hpu-initialized-by-create3image4xi to: " + str(image3d4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'H-'
        except: 
            message3print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['IPU'] = create3image4ipu(task4imagecreate3xi['IPU'])
            
            message3print = "{(Step I/33) initialized" + "; ipu-initialized-by-create3image4xi to: " + str(image3d4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'I-'
        except: 
            message3print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['JPU'] = create3image4jpu(task4imagecreate3xi['JPU'])
            
            message3print = "{(Step J/33) initialized" + "; jpu-initialized-by-create3image4xi to: " + str(image3d4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'J-'
        except: 
            message3print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['KPU'] = create3image4kpu(task4imagecreate3xi['KPU'])
            
            message3print = "{(Step K/33) initialized" + "; kpu-initialized-by-create3image4xi to: " + str(image3d4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'K-'
        except: 
            message3print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['LPU'] = create3image4lpu(task4imagecreate3xi['LPU'])
            
            message3print = "{(Step L/33) initialized" + "; lpu-initialized-by-create3image4xi to: " + str(image3d4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'L-'
        except: 
            message3print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['MPU'] = create3image4mpu(task4imagecreate3xi['MPU'])
            
            message3print = "{(Step M/33) initialized" + "; mpu-initialized-by-create3image4xi to: " + str(image3d4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'M-'
        except: 
            message3print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['NPU'] = create3image4npu(task4imagecreate3xi['NPU'])
            
            message3print = "{(Step N/33) initialized" + "; npu-initialized-by-create3image4xi to: " + str(image3d4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'N-'
        except: 
            message3print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['OPU'] = create3image4opu(task4imagecreate3xi['OPU'])
            
            message3print = "{(Step O/33) initialized" + "; opu-initialized-by-create3image4xi to: " + str(image3d4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'O-'
        except: 
            message3print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['PPU'] = create3image4ppu(task4imagecreate3xi['PPU'])
            
            message3print = "{(Step P/33) initialized" + "; ppu-initialized-by-create3image4xi to: " + str(image3d4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'P-'
        except: 
            message3print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['QPU'] = create3image4qpu(task4imagecreate3xi['QPU'])
            
            message3print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create3image4xi to: " + str(image3d4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'Q-'
        except: 
            message3print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['RPU'] = create3image4rpu(task4imagecreate3xi['RPU'])
            
            message3print = "{(Step R/33) initialized" + "; rpu-initialized-by-create3image4xi to: " + str(image3d4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'R-'
        except: 
            message3print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['SPU'] = create3image4spu(task4imagecreate3xi['SPU'])
            
            message3print = "{(Step S/33) initialized" + "; spu-initialized-by-create3image4xi to: " + str(image3d4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'S-'
        except: 
            message3print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['TPU'] = create3image4tpu(task4imagecreate3xi['TPU'])
            
            message3print = "{(Step T/33) initialized" + "; tpu-initialized-by-create3image4xi to: " + str(image3d4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'T-'
        except: 
            message3print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['UPU'] = create3image4upu(task4imagecreate3xi['UPU'])
            
            message3print = "{(Step U/33) initialized" + "; upu-initialized-by-create3image4xi to: " + str(image3d4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'U-'
        except: 
            message3print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['VPU'] = create3image4vpu(task4imagecreate3xi['VPU'])
            
            message3print = "{(Step V/33) initialized" + "; vpu-initialized-by-create3image4xi to: " + str(image3d4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'V-'
        except: 
            message3print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['WPU'] = create3image4wpu(task4imagecreate3xi['WPU'])
            
            message3print = "{(Step W/33) initialized" + "; wpu-initialized-by-create3image4xi to: " + str(image3d4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'W-'
        except: 
            message3print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['XPU'] = create3image4xpu(task4imagecreate3xi['XPU'])
            
            message3print = "{(Step X/33) initialized" + "; xpu-initialized-by-create3image4xi to: " + str(image3d4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'X-'
        except: 
            message3print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['YPU'] = create3image4ypu(task4imagecreate3xi['YPU'])
            
            message3print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create3image4xi to: " + str(image3d4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'Y-'
        except: 
            message3print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            image3d4xi['ZPU'] = create3image4zpu(task4imagecreate3xi['ZPU'])
            
            message3print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create3image4xi to: " + str(image3d4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            
            code3ack  = code3ack + 'Z-'
        except: 
            message3print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of create3image4xi - RETURNING IMAGE3D4XI: ", image3d4xi)
            
    message3print = "{(Step 33/33) returning" + "; image3d4xi-returning-by-create3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"  
    print4xi(class3print, method3print, message3print)                                                              
    # 

    return image3d4xi
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set3image4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------
#   # (10) FINALLY SET 3D IMAGE AFTER HAVING PROVIDED VALUES FOR REQUIRED PROCESSING UNITS                            
#   # ---------------------------------------------------------------------------------------------          
#   response4set3Dimage = {} 
#   print('(Step 10A/700) OF IMAGE3D4XI5TEST - TRYING TO SET 3D IMAGE4XI ', time4xi())   
#   try:                               
#       response4set3Dimage = set3image4xi(task4set3image)                                                                                                         
#                                                                                     
#       print('(Step 10B/700) OF IMAGE3D4XI5TEST - SET 3D IMAGE4XI ', time4xi())
#       keys3response = response4set3Dimage.keys()
#       for key3response in sorted(keys3response):
#           print(key3response, ' : ', response4set3Dimage[key3response])
#           # APU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
#           # ....
#           # ZPU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
#   except:
#       print('(Step 10Z/700) OF IMAGE3D4XI5TEST *** FAILED TO SET 3D IMAGE4XI *** ', time4xi())  
#
#">

# -------------------------------------------------------------------------------------------------   
def set3image4xi(task4imageset3xi=None):

    '''
    sets 3D images for xi device
    '''
    global platform3xi
    global device3xi
    global context3xi    
    global image3d4xi
    global info3image4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    
    class3print = "set3image4xi"
    method3print = "set3image4xi"

    message3print = "{(Step 1A/33) started" + "; set3image4xi-started: " + str(set3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                                     #  
    # <function set3image4xi at 0x0000000003A62848> 
    
    message3print = "{(Step 1B/33) passed" + "; task4imageset3xi-to-set3image4xi: " + str(task4imageset3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # 
            
    code3ack  = ' '
    code3nack = ' '
    if image3d4xi is None:
        image3d4xi = create3image3d4xi()                                                                            
                                
        message3print = "{(Step 1C/33) set" + "; image3d4xi-set-by-set3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        code3ack  = code3ack + '1C-'
    else:
        pass    
        

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step A/33) passing" + "; task-passing-to-set3image4apu: " + str(task4set3image['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['APU'] = set3image4apu(task4set3image['APU'])                                                      # 
         
        message3print = "{(Step A1/33) set" + "; apu-image-set-by-set3image4apu to: " + str(image3d4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'A1-'
    except:
        message3print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set3image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step B/33) passing" + "; task-passing-to-set3image4bpu: " + str(task4set3image['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['BPU'] = set3image4bpu(task4set3image['BPU'])                                                      # 
         
        message3print = "{(Step B1/33) set" + "; bpu-image-set-by-set3image4bpu to: " + str(image3d4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'B1-'
    except:
        message3print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set3image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step C/33) passing" + "; task-passing-to-set3image4cpu: " + str(task4set3image['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['CPU'] = set3image4cpu(task4set3image['CPU'])                                                      # 
         
        message3print = "{(Step C1/33) set" + "; cpu-image-set-by-set3image4cpu to: " + str(image3d4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'C1-'
    except:
        message3print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set3image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step D/33) passing" + "; task-passing-to-set3image4dpu: " + str(task4set3image['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['DPU'] = set3image4dpu(task4set3image['DPU'])                                                      # 
         
        message3print = "{(Step D1/33) set" + "; dpu-image-set-by-set3image4dpu to: " + str(image3d4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'D1-'
    except:
        message3print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set3image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step E/33) passing" + "; task-passing-to-set3image4epu: " + str(task4set3image['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['EPU'] = set3image4epu(task4set3image['EPU'])                                                      # 
         
        message3print = "{(Step E1/33) set" + "; epu-image-set-by-set3image4epu to: " + str(image3d4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'E1-'
    except:
        message3print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set3image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step F/33) passing" + "; task-passing-to-set3image4fpu: " + str(task4set3image['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['FPU'] = set3image4fpu(task4set3image['FPU'])                                                      # 
         
        message3print = "{(Step F1/33) set" + "; fpu-image-set-by-set3image4fpu to: " + str(image3d4xi ['PU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'F1-'
    except:
        message3print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set3image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step G/33) passing" + "; task-passing-to-set3image4gpu: " + str(task4set3image['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['GPU'] = set3image4gpu(task4set3image['GPU'])                                                      # 
         
        message3print = "{(Step G1/33) set" + "; gpu-image-set-by-set3image4gpu to: " + str(image3d4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'G1-'
    except:
        message3print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set3image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step H/33) passing" + "; task-passing-to-set3image4hpu: " + str(task4set3image['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['HPU'] = set3image4hpu(task4set3image['HPU'])                                                      # 
         
        message3print = "{(Step H1/33) set" + "; hpu-image-set-by-set3image4hpu to: " + str(image3d4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'H1-'
    except:
        message3print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set3image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step I/33) passing" + "; task-passing-to-set3image4ipu: " + str(task4set3image['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['IPU'] = set3image4ipu(task4set3image['IPU'])                                                      # 
         
        message3print = "{(Step I1/33) set" + "; ipu-image-set-by-set3image4ipu to: " + str(image3d4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'I1-'
    except:
        message3print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set3image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step J/33) passing" + "; task-passing-to-set3image4jpu: " + str(task4set3image['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['JPU'] = set3image4jpu(task4set3image['JPU'])                                                      # 
         
        message3print = "{(Step J1/33) set" + "; jpu-image-set-by-set3image4jpu to: " + str(image3d4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'J1-'
    except:
        message3print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set3image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step K/33) passing" + "; task-passing-to-set3image4kpu: " + str(task4set3image['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['KPU'] = set3image4kpu(task4set3image['KPU'])                                                      # 
         
        message3print = "{(Step K1/33) set" + "; kpu-image-set-by-set3image4kpu to: " + str(image3d4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'K1-'
    except:
        message3print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set3image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step L/33) passing" + "; task-passing-to-set3image4lpu: " + str(task4set3image['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['LPU'] = set3image4lpu(task4set3image['LPU'])                                                      # 
         
        message3print = "{(Step L1/33) set" + "; lpu-image-set-by-set3image4lpu to: " + str(image3d4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + '1-'
    except:
        message3print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set3image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step M/33) passing" + "; task-passing-to-set3image4mpu: " + str(task4set3image['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['MPU'] = set3image4mpu(task4set3image['MPU'])                                                      # 
         
        message3print = "{(Step M1/33) set" + "; mpu-image-set-by-set3image4mpu to: " + str(image3d4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'M1-'
    except:
        message3print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set3image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step N/33) passing" + "; task-passing-to-set3image4npu: " + str(task4set3image['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['NPU'] = set3image4npu(task4set3image['NPU'])                                                      # 
         
        message3print = "{(Step N1/33) set" + "; npu-image-set-by-set3image4npu to: " + str(image3d4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'N1-'
    except:
        message3print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set3image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step O/33) passing" + "; task-passing-to-set3image4opu: " + str(task4set3image['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['OPU'] = set3image4opu(task4set3image['OPU'])                                                      # 
         
        message3print = "{(Step O1/33) set" + "; opu-image-set-by-set3image4opu to: " + str(image3d4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'O1-'
    except:
        message3print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set3image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step P/33) passing" + "; task-passing-to-set3image4ppu: " + str(task4set3image['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['PPU'] = set3image4ppu(task4set3image['PPU'])                                                      # 
         
        message3print = "{(Step P1/33) set" + "; ppu-image-set-by-set3image4ppu to: " + str(image3d4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'P1-'
    except:
        message3print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set3image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step Q/33) passing" + "; task-passing-to-set3image4qpu: " + str(task4set3image['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['QPU'] = set3image4qpu(task4set3image['QPU'])                                                      # 
         
        message3print = "{(Step Q1/33) set" + "; qpu-image-set-by-set3image4qpu to: " + str(image3d4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'Q1-'
    except:
        message3print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set3image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step R/33) passing" + "; task-passing-to-set3image4rpu: " + str(task4set3image['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['RPU'] = set3image4rpu(task4set3image['RPU'])                                                      # 
         
        message3print = "{(Step R1/33) set" + "; rpu-image-set-by-set3image4rpu to: " + str(image3d4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'R1-'
    except:
        message3print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set3image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step S/33) passing" + "; task-passing-to-set3image4spu: " + str(task4set3image['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['SPU'] = set3image4spu(task4set3image['SPU'])                                                      # 
         
        message3print = "{(Step S1/33) set" + "; spu-image-set-by-set3image4spu to: " + str(image3d4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'S1-'
    except:
        message3print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set3image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step T/33) passing" + "; task-passing-to-set3image4tpu: " + str(task4set3image['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['TPU'] = set3image4tpu(task4set3image['TPU'])                                                      # 
         
        message3print = "{(Step T1/33) set" + "; tpu-image-set-by-set3image4tpu to: " + str(image3d4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'T1-'
    except:
        message3print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set3image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step U/33) passing" + "; task-passing-to-set3image4upu: " + str(task4set3image['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['UPU'] = set3image4upu(task4set3image['UPU'])                                                      # 
         
        message3print = "{(Step U1/33) set" + "; upu-image-set-by-set3image4upu to: " + str(image3d4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'U1-'
    except:
        message3print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set3image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step V/33) passing" + "; task-passing-to-set3image4vpu: " + str(task4set3image['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['VPU'] = set3image4vpu(task4set3image['VPU'])                                                      # 
         
        message3print = "{(Step V1/33) set" + "; vpu-image-set-by-set3image4vpu to: " + str(image3d4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'V1-'
    except:
        message3print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set3image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step W/33) passing" + "; task-passing-to-set3image4wpu: " + str(task4set3image['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['WPU'] = set3image4wpu(task4set3image['WPU'])                                                      # 
         
        message3print = "{(Step W1/33) set" + "; wpu-image-set-by-set3image4wpu to: " + str(image3d4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'W1-'
    except:
        message3print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set3image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step X/33) passing" + "; task-passing-to-set3image4xpu: " + str(task4set3image['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['XPU'] = set3image4xpu(task4set3image['XPU'])                                                      # 
         
        message3print = "{(Step X1/33) set" + "; xpu-image-set-by-set3image4xpu to: " + str(image3d4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'X1-'
    except:
        message3print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set3image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step Y/33) passing" + "; task-passing-to-set3image4ypu: " + str(task4set3image['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['YPU'] = set3image4ypu(task4set3image['YPU'])                                                      # 
         
        message3print = "{(Step Y1/33) set" + "; ypu-image-set-by-set3image4ypu to: " + str(image3d4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'Y1-'
    except:
        message3print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set3image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message3print = "{(Step Z/33) passing" + "; task-passing-to-set3image4zpu: " + str(task4set3image['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                         
        # 
        
        image3d4xi ['ZPU'] = set3image4zpu(task4set3image['ZPU'])                                                      # 
         
        message3print = "{(Step Z1/33) set" + "; zpu-image-set-by-set3image4zpu to: " + str(image3d4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        code3ack  = code3ack + 'Z1-'
    except:
        message3print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set3image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print('(Step 33/33) of set3image4xi - RETURNING IMAGE3D4XI:  ', image3d4xi) 
    
    message3print = "{(Step 33/33) returning" + "; image3d4xi-returning-by-set3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)
    # 
    
    
    return image3d4xi
           
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "copy3image4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: COPY FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 40A/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY3IMAGE4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   respon4copy3image      = {} 
#   task4copy3image        = {}                                                                                    
#   queue4copy          = {} 
#   channel4copy3publish = {} 
#   channel4copy3consume = {} 
#   try: 
#       task4copy3image = {} 
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':
#               task4copy3image [key3pu]  = {}
#                                               
#       response4copy3image = copy3image4xi(task4copy3image)
#       
#       print('(Step 40B/700) OF IMAGE3D4XI5TEST - GOT RESPONSE4COPY3IMAGE ', response4copy3image)
#       # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005EE6898>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6848>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6844>}, 
#       #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005EE6D68>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6880>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6876>},
#       #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005EE6550>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6816>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6812>}}
#     except:
#       print('(Step 40Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY3IMAGE4XI ', time4xi())
#                
#   print('(Step 40C/700) OF IMAGE3D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR COPY ', time4xi())               
#   try: 
#       queue4copy          = {}
#       channel4copy3publish = {} 
#       channel4copy3consume = {}
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':   
#               queue4copy [key3pu] = response4copy3image [key3pu] ['QUEUE']
#               print(key3pu, ' SET QUEUE TO : ', queue4copy [key3pu])
#               # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006047240>; GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006047160>; APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006047128>
#               
#               channel4copy3publish [key3pu] = response4copy3image [key3pu] ['PUBLISHERCHANNEL']
#               print(key3pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4copy3publish [key3pu])
#               # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 6880>; GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 6848>; APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 6816>
#                       
#               channel4copy3consume [key3pu] = response4copy3image [key3pu]['CONSUMERCHANNEL']
#               print(key3pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4copy3consume [key3pu])
#               # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 6876>; GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 6844>; APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 6812>
#                       
#   except:
#       print('(Step 40Z2/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR COPY ', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def copy3image4xi(task4copyimage3xi=None):

    '''
    copies 3D images for XI
    '''
    global platform3xi
    global device3xi
    global context3xi    
    global image3d4xi                                                     # 3D-IMAGES
    global info3image4xi  
    global control3copy4xi                                           # COMMAND AND CONTROL FOR 3D IMAGE FOR XIS 
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "copy3image4xi"
    method3print = "copy3image4xi"

    message3print = "{(Step 1A/33) started" + "; copy3image4xi-started: " + str(copy3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                                     #  
    # <function copy3image4xi at 0x00000000039595C8> 
    
    message3print = "{(Step 1B/33) passed" + "; task4copyimage3xi-to-copy3image4xi: " + str(task4copyimage3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # 
            
    code3ack  = ' '
    code3nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # CREATE 3D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image3d4xi is None:
            image3d4xi = create3image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message3print = "{(Step 1C/70) created" + "; image3d4xi-created-by-copy3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        else:
            message3print = "{(Step 1D/70) skipped" + "; create3image4xi-skipped-by-copy3image4xi: " + str(copy3image4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # skipped                                 
    except:
        try:
            image3d4xi = create3image4xi()
            message3print = "{(Step 1E/70) set" + "; image3d4xi-set-by-copy3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        except:
            image3d4xi = {}
            message3print = "{(Step 1Z/70) yielded" + "; image3d4xi-yielded-by-copy3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control3copy4xi = {}
    try:         
        keys3taskcopyimage = task4copyimage3xi.keys()
        if debug is True:
            print('(Step 1/33) of copy3image4xi - keys3taskcopyimage:  ', keys3taskcopyimage) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
        if 'APU' in keys3taskcopyimage:
            try:
                control3copy4xi['APU'] = copy3image4apu(task4copyimage3xi['APU'])
                message3print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1A/33) of copy3image4xi - control3copy4xi:  ', control3copy4xi['APU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006047128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6816>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6812>}

            except:
                pass     
        if 'BPU' in keys3taskcopyimage:
            try:
                control3copy4xi['BPU'] = copy3image4bpu(task4copyimage3xi['BPU'])
                message3print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'CPU' in keys3taskcopyimage:
            try:
                control3copy4xi['CPU'] = copy3image4cpu(task4copyimage3xi['CPU'])
                message3print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'DPU' in keys3taskcopyimage:
            try:
                control3copy4xi['DPU'] = copy3image4dpu(task4copyimage3xi['DPU'])
                message3print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'EPU' in keys3taskcopyimage:
            try:
                control3copy4xi['EPU'] = copy3image4epu(task4copyimage3xi['EPU'])
                message3print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'FPU' in keys3taskcopyimage:
            try:
                control3copy4xi['FPU'] = copy3image4fpu(task4copyimage3xi['FPU'])
                message3print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'GPU' in keys3taskcopyimage:
            try:
                control3copy4xi['GPU'] = copy3image4gpu(task4copyimage3xi['GPU'])
                message3print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'HPU' in keys3taskcopyimage:
            try:
                control3copy4xi['HPU'] = copy3image4hpu(task4copyimage3xi['HPU'])
                message3print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #             
            except:
                pass
        if 'IPU' in keys3taskcopyimage:    
            try:
                control3copy4xi['IPU'] = copy3image4ipu(task4copyimage3xi['IPU'])
                message3print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'JPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['JPU'] = copy3image4jpu(task4copyimage3xi['JPU'])
                message3print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'KPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['KPU'] = copy3image4kpu(task4copyimage3xi['KPU'])
                message3print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'LPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['LPU'] = copy3image4lpu(task4copyimage3xi['LPU'])
                message3print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'MPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['MPU'] = copy3image4mpu(task4copyimage3xi['MPU'])
                message3print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'NPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['NPU'] = copy3image4npu(task4copyimage3xi['NPU'])
                message3print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'OPU' in keys3taskcopyimage:                    
            try:
                control3copy4xi['OPU'] = copy3image4opu(task4copyimage3xi['OPU'])
                message3print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'PPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['PPU'] = copy3image4ppu(task4copyimage3xi['PPU'])
                message3print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'QPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['QPU'] = copy3image4qpu(task4copyimage3xi['QPU'])
                message3print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'RPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['RPU'] = copy3image4rpu(task4copyimage3xi['RPU'])
                message3print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'SPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['SPU'] = copy3image4spu(task4copyimage3xi['SPU'])
                message3print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'TPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['TPU'] = copy3image4tpu(task4copyimage3xi['TPU'])
                message3print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'UPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['UPU'] = copy3image4upu(task4copyimage3xi['UPU'])
                message3print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'VPU' in keys3taskcopyimage:                    
            try:
                control3copy4xi['VPU'] = copy3image4vpu(task4copyimage3xi['VPU'])
                message3print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'WPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['WPU'] = copy3image4wpu(task4copyimage3xi['WPU'])
                message3print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'XPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['XPU'] = copy3image4xpu(task4copyimage3xi['XPU'])
                message3print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'YPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['YPU'] = copy3image4ypu(task4copyimage3xi['YPU'])
                message3print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'ZPU' in keys3taskcopyimage:                     
            try:
                control3copy4xi['ZPU'] = copy3image4zpu(task4copyimage3xi['ZPU'])
                message3print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get3imageinfo: " + str(control3copy4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
               
    except:
        message3print = "{(Step 1Z/70) yielded" + "; control3copy4xi-yielded-by-copy3image4xi: " + str(control3copy4xi) + "; time: " + time4xi() + "}"                
        print4xi(class3print, method3print, message3print)  
        code3nack  = code3nack + '1Z-'     
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    message3print = "{(Step 70A/70) set" + "; code3ack-set-by-copy3image4xi: " + str(code3ack) + "; time: " + time4xi() + "}"  
    print4xi(class3print, method3print, message3print)                                                             
    # 
     
    message3print = "{(Step 70B/70) set" + "; code3nack-set-by-copy3image4xi: " + str(code3nack) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             
    #   
        
    message3print = "{(Step 70C/70) returning" + "; control3copy4xi-returning-by-copy3image4xi: " + str(control3copy4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             
    # 
    if debug is True:
        print('(Step 33/33) of control3copy4xi - RETURNING CONTROL3COPYIMAGE4XI:  ', control3copy4xi) 
        # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006047160>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6848>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6844>}, 
        #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006047240>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6880>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6876>}, 
        #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006047128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6816>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6812>}}
        
    return control3copy4xi
                    
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "copy3imagetobuffer4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: COPY3IMAGETOBUFFER4XI FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 60A/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY3IMAGETOBUFFER4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   response4copy3imagetobuffer      = {} 
#   task4copy3imagetobuffer        = {}                                                                                    
#   queue4copyimagetobuffer          = {} 
#   channel4copyimagetobuffer3publish = {} 
#   channel4copyimagetobuffer3consume = {} 
#   try:
#       task4copy3imagetobuffer = {} 
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':
#               task4copy3imagetobuffer [key3pu]  = {}
#                                               
#       response4copy3imagetobuffer = copy3imagetobuffer4xi(task4copy3imagetobuffer)
#       
#       print('(Step 60B/700) OF IMAGE3D4XI5TEST - GOT RESPONSE4COPY3IMAGETOBUFFER4XI3IMAGE ', response4copy3imagetobuffer)
#       # 
#   except:
#       print('(Step 60Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY3IMAGETOBUFFER4XI ', time4xi())
#                
#   print('(Step 60C/700) OF IMAGE3D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR COPY3IMAGETOBUFFER4XI ', time4xi())               
#   try: 
#       queue4copyimagetobuffer          = {}
#       channel4copyimagetobuffer3publish = {} 
#       channel4copyimagetobuffer3consume = {}
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':   
#               queue4copyimagetobuffer [key3pu] = response4copy3imagetobuffer [key3pu] ['QUEUE']
#               print(key3pu, ' SET QUEUE TO : ', queue4copyimagetobuffer [key3pu])
#               # 
#               
#               channel4copyimagetobuffer3publish [key3pu] = response4copy3imagetobuffer [key3pu] ['PUBLISHERCHANNEL']
#               print(key3pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4copyimagetobuffer3publish [key3pu])
#               # 
#                       
#               channel4copyimagetobuffer3consume [key3pu] = response4copy3imagetobuffer [key3pu]['CONSUMERCHANNEL']
#               print(key3pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4copyimagetobuffer3consume [key3pu])
#               # 
#                       
#   except:
#       print('(Step 60Z2/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR COPY3IMAGETOBUFFER4XI ', time4xi()) 
#">

# -------------------------------------------------------------------------------------------------   
def copy3imagetobuffer4xi(task4copyimagetobuffer3xi=None):

    '''
    copies 3D images to buffer for XI
    '''
    global platform3xi
    global device3xi
    global context3xi    
    global image3d4xi                                                                                               # 3D-IMAGES
    global info3image4xi  
    global image3dbuffer4xi                                                                                         # BUFFER FOR XI
    
    global control3copytobuffer4xi                                                                             # COMMAND AND CONTROL FOR 3D IMAGE FOR XIS 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "copy3imagetobuffer4xi"
    method3print = "copy3imagetobuffer4xi"

    message3print = "{(Step 1A/33) started" + "; copy3imagetobuffer4xi-started: " + str(copy3imagetobuffer4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                                     #  
    # <function copy3imagetobuffer4xi at 0x00000000039595C8> 
    
    message3print = "{(Step 1B/33) passed" + "; task4copyimagetobuffer3xi-to-copy3imagetobuffer4xi: " + str(task4copyimagetobuffer3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # 
            
    code3ack  = ' '
    code3nack = ' '
    
    if task4copyimagetobuffer3xi is None:
        task4copyimagetobuffer3xi = {}
    
    # -----------------------------------------------------------------------------------------
    # CREATE 3D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image3d4xi is None:
            image3d4xi = create3image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message3print = "{(Step 1C/70) created" + "; image3d4xi-created-by-copy3imagetobuffer4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        else:
            message3print = "{(Step 1D/70) skipped" + "; create3image4xi-skipped-by-copy3imagetobuffer4xi: " + str(copy3imagetobuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # skipped                                 
    except:
        try:
            image3d4xi = create3image4xi()
            message3print = "{(Step 1E/70) set" + "; image3d4xi-set-by-copy3imagetobuffer4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        except:
            image3d4xi = {}
            message3print = "{(Step 1Z/70) yielded" + "; image3d4xi-yielded-by-copy3imagetobuffer4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control3copytobuffer4xi = {}
    try:         
        keys3taskcopyimagetobuffer = task4copyimagetobuffer3xi.keys()
        if debug is True:
            print('(Step 1/33) of copy3imagetobuffer4xi - keys3taskcopyimagetobuffer:  ', keys3taskcopyimagetobuffer) 
          
        if 'APU' in keys3taskcopyimagetobuffer:
            try:
                control3copytobuffer4xi['APU'] = copy3imagetobuffer4apu(task4copyimagetobuffer3xi['APU'])
                message3print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1A/33) of copy3imagetobuffer4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi) 
                    # {'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005EB71D0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6956>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6952>}}

            except:
                pass     
        if 'BPU' in keys3taskcopyimagetobuffer:
            try:
                control3copytobuffer4xi['BPU'] = copy3imagetobuffer4bpu(task4copyimagetobuffer3xi['BPU'])
                message3print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'CPU' in keys3taskcopyimagetobuffer:
            try:
                control3copytobuffer4xi['CPU'] = copy3imagetobuffer4cpu(task4copyimagetobuffer3xi['CPU'])
                message3print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'DPU' in keys3taskcopyimagetobuffer:
            try:
                control3copytobuffer4xi['DPU'] = copy3imagetobuffer4dpu(task4copyimagetobuffer3xi['DPU'])
                message3print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'EPU' in keys3taskcopyimagetobuffer:
            try:
                control3copytobuffer4xi['EPU'] = copy3imagetobuffer4epu(task4copyimagetobuffer3xi['EPU'])
                message3print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'FPU' in keys3taskcopyimagetobuffer:
            try:
                control3copytobuffer4xi['FPU'] = copy3imagetobuffer4fpu(task4copyimagetobuffer3xi['FPU'])
                message3print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'GPU' in keys3taskcopyimagetobuffer:
            try:
                control3copytobuffer4xi['GPU'] = copy3imagetobuffer4gpu(task4copyimagetobuffer3xi['GPU'])
                message3print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'HPU' in keys3taskcopyimagetobuffer:
            try:
                control3copytobuffer4xi['HPU'] = copy3imagetobuffer4hpu(task4copyimagetobuffer3xi['HPU'])
                message3print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #             
            except:
                pass
        if 'IPU' in keys3taskcopyimagetobuffer:    
            try:
                control3copytobuffer4xi['IPU'] = copy3imagetobuffer4ipu(task4copyimagetobuffer3xi['IPU'])
                message3print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'JPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['JPU'] = copy3imagetobuffer4jpu(task4copyimagetobuffer3xi['JPU'])
                message3print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'KPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['KPU'] = copy3imagetobuffer4kpu(task4copyimagetobuffer3xi['KPU'])
                message3print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'LPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['LPU'] = copy3imagetobuffer4lpu(task4copyimagetobuffer3xi['LPU'])
                message3print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'MPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['MPU'] = copy3imagetobuffer4mpu(task4copyimagetobuffer3xi['MPU'])
                message3print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'NPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['NPU'] = copy3imagetobuffer4npu(task4copyimagetobuffer3xi['NPU'])
                message3print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'OPU' in keys3taskcopyimagetobuffer:                    
            try:
                control3copytobuffer4xi['OPU'] = copy3imagetobuffer4opu(task4copyimagetobuffer3xi['OPU'])
                message3print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'PPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['PPU'] = copy3imagetobuffer4ppu(task4copyimagetobuffer3xi['PPU'])
                message3print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'QPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['QPU'] = copy3imagetobuffer4qpu(task4copyimagetobuffer3xi['QPU'])
                message3print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'RPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['RPU'] = copy3imagetobuffer4rpu(task4copyimagetobuffer3xi['RPU'])
                message3print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'SPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['SPU'] = copy3imagetobuffer4spu(task4copyimagetobuffer3xi['SPU'])
                message3print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'TPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['TPU'] = copy3imagetobuffer4tpu(task4copyimagetobuffer3xi['TPU'])
                message3print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'UPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['UPU'] = copy3imagetobuffer4upu(task4copyimagetobuffer3xi['UPU'])
                message3print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'VPU' in keys3taskcopyimagetobuffer:                    
            try:
                control3copytobuffer4xi['VPU'] = copy3imagetobuffer4vpu(task4copyimagetobuffer3xi['VPU'])
                message3print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'WPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['WPU'] = copy3imagetobuffer4wpu(task4copyimagetobuffer3xi['WPU'])
                message3print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'XPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['XPU'] = copy3imagetobuffer4xpu(task4copyimagetobuffer3xi['XPU'])
                message3print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'YPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['YPU'] = copy3imagetobuffer4ypu(task4copyimagetobuffer3xi['YPU'])
                message3print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'ZPU' in keys3taskcopyimagetobuffer:                     
            try:
                control3copytobuffer4xi['ZPU'] = copy3imagetobuffer4zpu(task4copyimagetobuffer3xi['ZPU'])
                message3print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
               
    except:
        message3print = "{(Step 1Z/70) yielded" + "; control3copytobuffer4xi-yielded-by-copy3imagetobuffer4xi: " + str(control3copytobuffer4xi) + "; time: " + time4xi() + "}"                
        print4xi(class3print, method3print, message3print)  
        code3nack  = code3nack + '1Z-'     
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    message3print = "{(Step 70A/70) set" + "; code3ack-set-by-copy3imagetobuffer4xi: " + str(code3ack) + "; time: " + time4xi() + "}"  
    print4xi(class3print, method3print, message3print)                                                             
    # 
     
    message3print = "{(Step 70B/70) set" + "; code3nack-set-by-copy3imagetobuffer4xi: " + str(code3nack) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             
    #   
        
    message3print = "{(Step 70C/70) returning" + "; control3copytobuffer4xi-returning-by-copy3imagetobuffer4xi: " + str(control3copytobuffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             
    # 
    if debug is True:
        print('(Step 33/33) of copy3imagetobuffer4xi - RETURNING CONTROL3COPYIMAGETOBUFFER4XI:  ', control3copytobuffer4xi) 
            
    return control3copytobuffer4xi
        
                    
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "copy3buffertoimage4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: COPY3BUFFERTOIMAGE4XI FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 80A/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY3BUFFERTOIMAGE4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   response4copy3buffertoimage      = {} 
#   task4copy3buffertoimage        = {}                                                                                    
#   queue4copybuffertoimage          = {} 
#   channel4copybuffertoimage3publish = {} 
#   channel4copybuffertoimage3consume = {} 
#   try:
#       task4copy3buffertoimage = {} 
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':
#               task4copy3buffertoimage [key3pu]  = {}
#                                               
#       response4copy3buffertoimage = copy3buffertoimage4xi(task4copy3buffertoimage)
#       
#       print('(Step 80B/700) OF IMAGE3D4XI5TEST - GOT RESPONSE4COPY3BUFFERTOIMAGE4XI3IMAGE ', response4copy3buffertoimage)
#       # 
#   except:
#       print('(Step 80Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY3BUFFERTOIMAGE4XI ', time4xi())
#                
#   print('(Step 80C/700) OF IMAGE3D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR COPY3BUFFERTOIMAGE4XI ', time4xi())               
#   try: 
#       queue4copybuffertoimage          = {}
#       channel4copybuffertoimage3publish = {} 
#       channel4copybuffertoimage3consume = {}
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':   
#               queue4copybuffertoimage [key3pu] = response4copy3buffertoimage [key3pu] ['QUEUE']
#               print(key3pu, ' SET QUEUE TO : ', queue4copybuffertoimage [key3pu])
#                channel4copybuffertoimage3publish [key3pu] = response4copy3buffertoimage [key3pu] ['PUBLISHERCHANNEL']
#               print(key3pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4copybuffertoimage3publish [key3pu])
#    
#               channel4copybuffertoimage3consume [key3pu] = response4copy3buffertoimage [key3pu]['CONSUMERCHANNEL']
#               print(key3pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4copybuffertoimage3consume [key3pu])
#               # 
#               # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4F98>
#               # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7160>
#               # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7156>
#               # GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4AC8>
#               # GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7128>
#               # GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7124>
#               # APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4A58>
#               # APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7096>
#               # APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7092> 
#                       
#   except:
#       print('(Step 80Z2/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR COPY3BUFFERTOIMAGE4XI ', time4xi())   
#
#">

# -------------------------------------------------------------------------------------------------   
def copy3buffertoimage4xi(task4copybuffertoimage3xi=None):
    
    '''
    copies buffer to 3D image for XI
    '''
    global platform3xi
    global device3xi
    global context3xi    
    global image3d4xi                                                                                               # 3D-IMAGES
    global info3image4xi  
    global image3dbuffer4xi                                                                                         # BUFFER FOR XI
    
                                                                                
    global control3copybuffertoimage4xi                                                                             # COMMAND AND CONTROL TO COPY BUFFER TO 3D IMAGE WITH XI 
    global state3copybuffertoimage4xi                                                                               # STATE FOR COMMAND AND CONTROL
    global max3copybuffertoimagestate4xi                                                                            # MAX FOR STATE
    global ack3copybuffertoimageinfo4xi                                                                             # ACK FOR IMAGE INFO
    global message3copybuffertoimageget4xi                                                                          # QUEUE GET
    global message3copybuffertoimageput4xi                                                                          # QUEUE PUT
    global message3copybuffertoimagereceive4xi                                                                      # PIPE RECEIVE
    global message3copybuffertoimagesend4xi                                                                         # PIPE SEND   
      
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS JATKA          
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "copy3buffertoimage4xi"
    method3print = "copy3buffertoimage4xi"

    message3print = "{(Step 1A/33) started" + "; copy3buffertoimage4xi-started: " + str(copy3buffertoimage4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                              #  
    # <function copy3buffertoimage4xi at 0x00000000039595C8> 
    
    message3print = "{(Step 1B/33) passed" + "; task4copybuffertoimage3xi-to-copy3buffertoimage4xi: " + str(task4copybuffertoimage3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # 
    if debug is True:
        print("(Step 1B/33) of copy3buffertoimage4xi - PASSED TASK4COPYBUFFERTOIMAGE3XI: ", task4copybuffertoimage3xi)
        # {'GPU': {}, 'ZPU': {}, 'APU': {}}    
    code3ack  = ' '
    code3nack = ' '
    
    if task4copybuffertoimage3xi is None:
        task4copybuffertoimage3xi = {}
    
    # -----------------------------------------------------------------------------------------
    # CREATE 3D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image3d4xi is None:
            image3d4xi = create3image4xi()                                                                          # INITIALIZE IMAGE FOR XI 
            message3print = "{(Step 1C/70) created" + "; image3d4xi-created-by-copy3buffertoimage4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        else:
            message3print = "{(Step 1D/70) skipped" + "; create3image4xi-skipped-by-copy3buffertoimage4xi: " + str(copy3buffertoimage4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # skipped                                 
    except:
        try:
            image3d4xi = create3image4xi()
            message3print = "{(Step 1E/70) set" + "; image3d4xi-set-by-copy3buffertoimage4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        except:
            image3d4xi = {}
            message3print = "{(Step 1Z/70) yielded" + "; image3d4xi-yielded-by-copy3buffertoimage4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control3copytobuffer4xi = {}
    try:         
        keys3taskcopybuffertoimage = task4copybuffertoimage3xi.keys()
        if debug is True:
            print('(Step 1/33) of copy3buffertoimage4xi - KEYS3TASKCOPYBUFFERTOIMAGE:  ', keys3taskcopybuffertoimage) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
            
        if 'APU' in keys3taskcopybuffertoimage:
            try:
                control3copytobuffer4xi['APU'] = copy3buffertoimage4apu()
                message3print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1A/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['APU']) 
                    # {'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005F414E0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7096>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7092>}}

            except:
                pass     
        if 'BPU' in keys3taskcopybuffertoimage:
            try:
                control3copytobuffer4xi['BPU'] = copy3buffertoimage4bpu()
                message3print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1B/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['BPU']) 
                    # 
            except:
                pass     
            
        if 'CPU' in keys3taskcopybuffertoimage:
            try:
                control3copytobuffer4xi['CPU'] = copy3buffertoimage4cpu()
                message3print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1C/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['CPU']) 
                    # 
            except:
                pass     
            
        if 'DPU' in keys3taskcopybuffertoimage:
            try:
                control3copytobuffer4xi['DPU'] = copy3buffertoimage4dpu()
                message3print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
                if debug is True:
                    print('(Step 1D/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['DPU']) 
                    # 
            except:
                pass               
        if 'EPU' in keys3taskcopybuffertoimage:
            try:
                control3copytobuffer4xi['EPU'] = copy3buffertoimage4epu()
                message3print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
                if debug is True:
                    print('(Step 1E/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['EPU']) 
                    # 
            except:
                pass               
        if 'FPU' in keys3taskcopybuffertoimage:
            try:
                control3copytobuffer4xi['FPU'] = copy3buffertoimage4fpu()
                message3print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
                if debug is True:
                    print('(Step 1F/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['FPU']) 
                    # 
            except:
                pass               
        if 'GPU' in keys3taskcopybuffertoimage:
            try:
                control3copytobuffer4xi['GPU'] = copy3buffertoimage4gpu()
                message3print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
                if debug is True:
                    print('(Step 1G/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['GPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4AC8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7128>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7124>}

            except:
                pass               
        if 'HPU' in keys3taskcopybuffertoimage:
            try:
                control3copytobuffer4xi['HPU'] = copy3buffertoimage4hpu()
                message3print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #             
                if debug is True:
                    print('(Step 1H/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['HPU']) 
                    # 
            except:
                pass
        if 'IPU' in keys3taskcopybuffertoimage:    
            try:
                control3copytobuffer4xi['IPU'] = copy3buffertoimage4ipu()
                message3print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1I/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['IPU']) 
                    # 
            except:
                pass
        if 'JPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['JPU'] = copy3buffertoimage4jpu()
                message3print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1J/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['JPU']) 
                    # 
            except:
                pass
        if 'KPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['KPU'] = copy3buffertoimage4kpu()
                message3print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1K/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['KPU']) 
                    # 
            except:
                pass
        if 'LPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['LPU'] = copy3buffertoimage4lpu()
                message3print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1L/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['LPU']) 
                    # 
            except:
                pass
        if 'MPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['MPU'] = copy3buffertoimage4mpu()
                message3print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1M/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['MPU']) 
                    # 
            except:
                pass
        if 'NPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['NPU'] = copy3buffertoimage4npu()
                message3print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1N/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['NPU']) 
                    # 
            except:
                pass
        if 'OPU' in keys3taskcopybuffertoimage:                    
            try:
                control3copytobuffer4xi['OPU'] = copy3buffertoimage4opu()
                message3print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1O/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['OPU']) 
                    # 
            except:
                pass
        if 'PPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['PPU'] = copy3buffertoimage4ppu()
                message3print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1P/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['PPU']) 
                    # 
            except:
                pass
        if 'QPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['QPU'] = copy3buffertoimage4qpu()
                message3print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1Q/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['QPU']) 
                    # 
            except:
                pass
        if 'RPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['RPU'] = copy3buffertoimage4rpu()
                message3print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1R/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['RPU']) 
                    # 
            except:
                pass
        if 'SPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['SPU'] = copy3buffertoimage4spu()
                message3print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1S/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['SPU']) 
                    # 
            except:
                pass
        if 'TPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['TPU'] = copy3buffertoimage4tpu()
                message3print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1T/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['TPU']) 
                    # 
            except:
                pass
        if 'UPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['UPU'] = copy3buffertoimage4upu()
                message3print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1U/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['UPU']) 
                    # 
            except:
                pass
        if 'VPU' in keys3taskcopybuffertoimage:                    
            try:
                control3copytobuffer4xi['VPU'] = copy3buffertoimage4vpu()
                message3print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1V/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['VPU']) 
                    # 
            except:
                pass
        if 'WPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['WPU'] = copy3buffertoimage4wpu()
                message3print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1W/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['WPU']) 
                    # 
            except:
                pass
        if 'XPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['XPU'] = copy3buffertoimage4xpu()
                message3print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1X/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['XPU']) 
                    # 
            except:
                pass
        if 'YPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['YPU'] = copy3buffertoimage4ypu()
                message3print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1Y/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['YPU']) 
                    # 
            except:
                pass
        if 'ZPU' in keys3taskcopybuffertoimage:                     
            try:
                control3copytobuffer4xi['ZPU'] = copy3buffertoimage4zpu()
                message3print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get3imageinfo: " + str(control3copytobuffer4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1Z/33) of copy3buffertoimage4xi - control3copytobuffer4xi:  ', control3copytobuffer4xi ['ZPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4F98>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7160>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7156>}

            except:
                pass
               
    except:
        message3print = "{(Step 1Z/70) yielded" + "; control3copytobuffer4xi-yielded-by-copy3buffertoimage4xi: " + str(control3copytobuffer4xi) + "; time: " + time4xi() + "}"                
        print4xi(class3print, method3print, message3print)  
        code3nack  = code3nack + '1Z-'     
        print("(Step 1Z/70) of control3copytobuffer4xi *** FAILED BY-COPY3BUFFERTOIMAGE4XI: ", control3copytobuffer4xi)
        
            
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    if debug is True:
        print("(Step 70A/70) of control3copytobuffer4xi - TRYING RETURN DEBUG WITH CONTROL3COPYTOBUFFER4XI: ", control3copytobuffer4xi)
    try: 
        message3print = "{(Step 70B/70) set" + "; code3ack-set-by-copy3buffertoimage4xi: " + str(code3ack) + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                             
        # 
     
        message3print = "{(Step 70C/70) set" + "; code3nack-set-by-copy3buffertoimage4xi: " + str(code3nack) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                             
        #   
            
        message3print = "{(Step 70D/70) returning" + "; control3copytobuffer4xi-returning-by-copy3buffertoimage4xi: " + str(control3copytobuffer4xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                             
        # 
        if debug is True:
            print('(Step 33/33) of copy3buffertoimage4xi - RETURNING CONTROL3COPYBUFFERTOIMAGE4XI:  ', control3copytobuffer4xi)
            # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4AC8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7128>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7124>}, 
            #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4F98>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7160>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7156>}, 
            #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4A58>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7096>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7092>}}
 
    except:
        print("(Step 70Z/70) of control3copytobuffer4xi *** FAILED TO DEBUG RETURN *** ", time4xi())
                    
    return control3copytobuffer4xi
        
                    
                    
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "read3image4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: READ FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND - STATE 0                  
#   # ---------------------------------------------------------------------------------------------    
#   print('(Step 16C/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH READ3IMAGE4XI ', time4xi())        
#   try: 
#       task4read3image = {} 
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':
#               task4read3image[key3pu]  = {}    # PROCESSING UNIT SELECTED
#           else:
#               pass                             # SKIPPED PROCESSING UNIT
#           
#       
#       response4read3image = read3image4xi(task4read3image)
#       
#       keys3readresponse = response4read3image.keys()
#       for key3readresponse in sorted(keys3readresponse):
#           kb3detail = response4read3image[key3readresponse]
#           keys3detail = kb3detail.keys()
#           for key3detail in keys3detail: 
#               print(key3readresponse, key3detail, kb3detail[key3detail])
#               #1:
#               # {'DPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD390>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5840>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5836>},
#               #  'EPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD4A8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5872>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5868>}, 
#               #  'BPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF99E8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5776>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5772>},
#               #  'CPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF9898>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5808>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5804>},
#               #  'VPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E019E8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6420>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6416>},
#               #  'RPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E014A8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6292>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6288>},
#               #  'WPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01B38>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6452>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6448>},
#               #  'SPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E015F8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6324>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6320>},
#               #  'PPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01208>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6228>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6224>},
#               #  'QPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01358>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6260>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6256>},
#               #  'KPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDB38>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6064>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6060>},
#               #  'YPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01DD8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6516>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6512>},
#               #  'LPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDC88>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6096>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6092>},
#               #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01F28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6548>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6544>}, 
#               #  'HPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD7F0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5968>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5964>},
#               #  'FPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD5C0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5904>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5900>}, 
#               #  'TPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01748>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6356>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6352>},
#               #  'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD6D8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5936>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5932>}, 
#               #  'UPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01898>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6388>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6384>}, 
#               #  'XPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01C88>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6484>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6480>},
#               #  'OPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDEF0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6196>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6192>},
#               #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF9860>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5744>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5740>},
#               #  'MPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDDD8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6128>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6124>},
#               #  'IPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD908>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6000>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5996>},
#               #  'NPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDF28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6164>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6160>},
#               #  'JPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDA20>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6032>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6028>}}
#               #2 
#               #APU QUEUE <queue4xi.Queue4Xi object at 0x0000000005E87C18>
#               #APU PUBLISHERCHANNEL <read-write PipeConnection, handle 6552>
#               #APU CONSUMERCHANNEL <read-write PipeConnection, handle 6548>
#   except:
#       print('(Step 16Z4/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH READ3IMAGE4XI ', time4xi())
#       
 
# -------------------------------------------------------------------------------------------------   
def read3image4xi(task4readimage3xi=None):

    '''
    reads 3D images for XI
    '''
    global platform3xi
    global device3xi
    global context3xi
    global image3d4xi                                                     # 3D-IMAGES 
    global info3image4xi 
    global control3readimage4xi                                           # COMMAND AND CONTROL FOR 3D IMAGE FOR XIS 
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "read3image4xi"
    method3print = "read3image4xi"

    message3print = "{(Step 1A/33) started" + "; read3image4xi-started: " + str(read3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                                     #  
    # <function read3image4xi at 0x00000000039595C8> 
    
    message3print = "{(Step 1B/33) passed" + "; task4readimage3xi-to-read3image4xi: " + str(task4readimage3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # 
     
    if task4readimage3xi is None:
        task4readimage3xi = {}
               
    code3ack  = ' '
    code3nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # CREATE 3D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image3d4xi is None:
            image3d4xi = create3image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message3print = "{(Step 1C/70) created" + "; image3d4xi-created-by-read3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        else:
            message3print = "{(Step 1D/70) skipped" + "; create3image4xi-skipped-by-read3image4xi: " + str(read3image4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # skipped                                 
    except:
        try:
            image3d4xi = create3image4xi()
            message3print = "{(Step 1E/70) set" + "; image3d4xi-set-by-read3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        except:
            image3d4xi = {}
            message3print = "{(Step 1Z/70) yielded" + "; image3d4xi-yielded-by-read3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control3readimage4xi = {}
    try:         
        keys3taskreadimage = task4readimage3xi.keys()
        if debug is True:
            print('(Step 1/33) of read3image4xi - keys3taskreadimage:  ', keys3taskreadimage) 
          
        if 'APU' in keys3taskreadimage:
            try:
                control3readimage4xi['APU'] = read3image4apu(task4readimage3xi['APU'])
                message3print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1A/33) of read3image4xi - control3readimage4xi:  ', control3readimage4xi['APU']) 
                
            except:
                pass     
        if 'BPU' in keys3taskreadimage:
            try:
                control3readimage4xi['BPU'] = read3image4bpu(task4readimage3xi['BPU'])
                message3print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'CPU' in keys3taskreadimage:
            try:
                control3readimage4xi['CPU'] = read3image4cpu(task4readimage3xi['CPU'])
                message3print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'DPU' in keys3taskreadimage:
            try:
                control3readimage4xi['DPU'] = read3image4dpu(task4readimage3xi['DPU'])
                message3print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'EPU' in keys3taskreadimage:
            try:
                control3readimage4xi['EPU'] = read3image4epu(task4readimage3xi['EPU'])
                message3print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'FPU' in keys3taskreadimage:
            try:
                control3readimage4xi['FPU'] = read3image4fpu(task4readimage3xi['FPU'])
                message3print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'GPU' in keys3taskreadimage:
            try:
                control3readimage4xi['GPU'] = read3image4gpu(task4readimage3xi['GPU'])
                message3print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'HPU' in keys3taskreadimage:
            try:
                control3readimage4xi['HPU'] = read3image4hpu(task4readimage3xi['HPU'])
                message3print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #             
            except:
                pass
        if 'IPU' in keys3taskreadimage:    
            try:
                control3readimage4xi['IPU'] = read3image4ipu(task4readimage3xi['IPU'])
                message3print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'JPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['JPU'] = read3image4jpu(task4readimage3xi['JPU'])
                message3print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'KPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['KPU'] = read3image4kpu(task4readimage3xi['KPU'])
                message3print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'LPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['LPU'] = read3image4lpu(task4readimage3xi['LPU'])
                message3print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'MPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['MPU'] = read3image4mpu(task4readimage3xi['MPU'])
                message3print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'NPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['NPU'] = read3image4npu(task4readimage3xi['NPU'])
                message3print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'OPU' in keys3taskreadimage:                    
            try:
                control3readimage4xi['OPU'] = read3image4opu(task4readimage3xi['OPU'])
                message3print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'PPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['PPU'] = read3image4ppu(task4readimage3xi['PPU'])
                message3print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'QPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['QPU'] = read3image4qpu(task4readimage3xi['QPU'])
                message3print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'RPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['RPU'] = read3image4rpu(task4readimage3xi['RPU'])
                message3print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'SPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['SPU'] = read3image4spu(task4readimage3xi['SPU'])
                message3print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'TPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['TPU'] = read3image4tpu(task4readimage3xi['TPU'])
                message3print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'UPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['UPU'] = read3image4upu(task4readimage3xi['UPU'])
                message3print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'VPU' in keys3taskreadimage:                    
            try:
                control3readimage4xi['VPU'] = read3image4vpu(task4readimage3xi['VPU'])
                message3print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'WPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['WPU'] = read3image4wpu(task4readimage3xi['WPU'])
                message3print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'XPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['XPU'] = read3image4xpu(task4readimage3xi['XPU'])
                message3print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'YPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['YPU'] = read3image4ypu(task4readimage3xi['YPU'])
                message3print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'ZPU' in keys3taskreadimage:                     
            try:
                control3readimage4xi['ZPU'] = read3image4zpu(task4readimage3xi['ZPU'])
                message3print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get3imageinfo: " + str(control3readimage4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
               
    except:
        message3print = "{(Step 1Z/70) yielded" + "; control3readimage4xi-yielded-by-read3image4xi: " + str(control3readimage4xi) + "; time: " + time4xi() + "}"                
        print4xi(class3print, method3print, message3print)  
        code3nack  = code3nack + '1Z-'     
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    message3print = "{(Step 70A/70) set" + "; code3ack-set-by-read3image4xi: " + str(code3ack) + "; time: " + time4xi() + "}"  
    print4xi(class3print, method3print, message3print)                                                             
    # 
     
    message3print = "{(Step 70B/70) set" + "; code3nack-set-by-read3image4xi: " + str(code3nack) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             
    #   
        
    message3print = "{(Step 70C/70) returning" + "; control3readimage4xi-returning-by-read3image4xi: " + str(control3readimage4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             
    # 
    if debug is True:
        print('(Step 33/33) of read3image4xi - RETURNING CONTROL3READIMAGE4XI:  ', control3readimage4xi) 
        
    return control3readimage4xi
                    
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "map3image4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: MAP FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 92A/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH MAP3IMAGE4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   response4map3image      = {} 
#   task4map3image        = {}                                                                                    
#   queue4map          = {} 
#   channel4map3publish = {} 
#   channel4map3consume = {} 
#   try:
#       task4map3image = {} 
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':
#               task4map3image [key3pu]  = {}
#                                               
#       response4map3image = map3image4xi(task4map3image)
#       
#       print('(Step 92B/700) OF IMAGE3D4XI5TEST - GOT RESPONSE4MAP3IMAGE ', response4map3image)
#       # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E678D0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7228>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7224>}, 
#       #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E6E128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7260>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7256>}, 
#       #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E67F28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7196>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7192>}}
#       print('(Step 9CB/700) OF IMAGE3D4XI5TEST - CONTINUES AFTER GETTING RESPONSE4MAP3IMAGE ', time4xi())   
#   except:
#       print('(Step 92Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH MAP3IMAGE4XI ', time4xi())
#                
#   print('(Step 92C/700) OF IMAGE3D4XI5TEST - TRYING TO INITIALIZE QUEUE FOR MAP ', time4xi())               
#   try: 
#       queue4map          = {}
#   except:
#       print('(Step 92Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO INITIALIZE QUEUES FOR MAP ', time4xi()) 
#   try:            
#       channel4map3publish = {}
#   except:
#       print('(Step 92Z2/700) OF IMAGE3D4XI5TEST *** FAILED TO INITIALIZE PUBLISHING CHANNELS FOR MAP ', time4xi()) 
#    try:    
#       channel4map3consume = {}
#   except:    
#       print('(Step 92Z5/700) OF IMAGE3D4XI5TEST *** FAILED TO INITIALIZE CONSUMING CHANNELS FOR MAP ', time4xi())
#   try:         
#       for key3pu in keys3pu:
#           try:
#               if KB3CC [key3pu] == 'ACK':
#                   try:   
#                       queue4map [key3pu] = response4map3image [key3pu] ['QUEUE']
#                       print(key3pu, ' SET QUEUE TO : ', queue4map [key3pu])
#                       # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046588>
#                       # GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046400>
#                       # APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046390>
#                   except:
#                       print('(Step 92Z6/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
#                   try:    
#                       channel4map3publish [key3pu] = response4map3image [key3pu] ['PUBLISHERCHANNEL']
#                       print(key3pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4map3publish [key3pu])
#                       # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7256>
#                       # GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7224>
#                       # APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7192>
#                                          
#                   except:
#                       print('(Step 92Z7/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
#                   try:            
#                       channel4map3consume [key3pu] = response4map3image [key3pu]['CONSUMERCHANNEL']
#                       print(key3pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4map3consume [key3pu])
#                       # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7252>
#                       # GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7220>
#                       # APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7188>
#                   except:
#                       print('(Step 92Z8/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi())     
#           except:
#               print('(Step 92Z9/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi())             
#   except:
#       print('(Step 92Z10/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
#                                           
#">

# -------------------------------------------------------------------------------------------------   
def map3image4xi(task4mapimage3xi=None):
    # 
    '''
    maps 3D images for XI
    '''

    global image3d4xi                                                                                              # 3D-IMAGES
    global control3mapimage4xi                                                                                     # COMMAND AND CONTROL FOR 3D IMAGE FOR XIS 
 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "map3image4xi"
    method3print = "map3image4xi"

    message3print = "{(Step 1A/33) started" + "; map3image4xi-started: " + str(map3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                                     #  
    # 
    
    message3print = "{(Step 1B/33) passed" + "; task4mapimage3xi-to-map3image4xi: " + str(task4mapimage3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # 
    
    if task4mapimage3xi is None:
        task4mapimage3xi = {}
            
    code3ack  = ' '
    code3nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # CREATE 3D IMAGE4XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image3d4xi is None:
            image3d4xi = create3image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message3print = "{(Step 1C/70) created" + "; image3d4xi-created-by-map3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        else:
            message3print = "{(Step 1D/70) skipped" + "; create3image4xi-skipped-by-map3image4xi: " + str(map3image4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #                                
    except:
        try:
            image3d4xi = create3image4xi()
            message3print = "{(Step 1E/70) set" + "; image3d4xi-set-by-map3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        except:
            image3d4xi = {}
            message3print = "{(Step 1Z/70) yielded" + "; image3d4xi-yielded-by-map3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + '1Z-' 
    
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control3mapimage4xi = {}
    try:         
        keys3taskmapimage = task4mapimage3xi.keys()
        if debug is True:
            print('(Step 1/33) of map3image4xi - keys3taskmapimage:  ', keys3taskmapimage) 
            # dict_keys(['GPU', 'ZPU', 'APU']
            
        if 'APU' in keys3taskmapimage:
            try:
                control3mapimage4xi['APU'] = map3image4apu()
                message3print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1A/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['APU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x00000000060E2588>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7192>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7188>}


            except:
                pass     
        if 'BPU' in keys3taskmapimage:
            try:
                control3mapimage4xi['BPU'] = map3image4bpu()
                message3print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1B/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['BPU']) 
                    # 
            except:
                pass     
            
        if 'CPU' in keys3taskmapimage:
            try:
                control3mapimage4xi['CPU'] = map3image4cpu()
                message3print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1C/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['CPU']) 
                    # 
            except:
                pass     
            
        if 'DPU' in keys3taskmapimage:
            try:
                control3mapimage4xi['DPU'] = map3image4dpu()
                message3print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
                if debug is True:
                    print('(Step 1D/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['DPU']) 
                    # 
            except:
                pass               
        if 'EPU' in keys3taskmapimage:
            try:
                control3mapimage4xi['EPU'] = map3image4epu()
                message3print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
                if debug is True:
                    print('(Step 1E/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['EPU']) 
                    # 
            except:
                pass               
        if 'FPU' in keys3taskmapimage:
            try:
                control3mapimage4xi['FPU'] = map3image4fpu()
                message3print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
                if debug is True:
                    print('(Step 1F/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['FPU']) 
                    # 
            except:
                pass               
        if 'GPU' in keys3taskmapimage:
            try:
                control3mapimage4xi['GPU'] = map3image4gpu()
                message3print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
                if debug is True:
                    print('(Step 1G/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['GPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x00000000060E25F8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7224>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7220>}

            except:
                pass               
        if 'HPU' in keys3taskmapimage:
            try:
                control3mapimage4xi['HPU'] = map3image4hpu()
                message3print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #             
                if debug is True:
                    print('(Step 1H/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['HPU']) 
                    # 
            except:
                pass
        if 'IPU' in keys3taskmapimage:    
            try:
                control3mapimage4xi['IPU'] = map3image4ipu()
                message3print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1I/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['IPU']) 
                    # 
            except:
                pass
        if 'JPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['JPU'] = map3image4jpu()
                message3print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1J/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['JPU']) 
                    # 
            except:
                pass
        if 'KPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['KPU'] = map3image4kpu()
                message3print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1K/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['KPU']) 
                    # 
            except:
                pass
        if 'LPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['LPU'] = map3image4lpu()
                message3print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1L/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['LPU']) 
                    # 
            except:
                pass
        if 'MPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['MPU'] = map3image4mpu()
                message3print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1M/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['MPU']) 
                    # 
            except:
                pass
        if 'NPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['NPU'] = map3image4npu()
                message3print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1N/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['NPU']) 
                    # 
            except:
                pass
        if 'OPU' in keys3taskmapimage:                    
            try:
                control3mapimage4xi['OPU'] = map3image4opu()
                message3print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1O/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['OPU']) 
                    # 
            except:
                pass
        if 'PPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['PPU'] = map3image4ppu()
                message3print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1P/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['PPU']) 
                    # 
            except:
                pass
        if 'QPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['QPU'] = map3image4qpu()
                message3print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1Q/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['QPU']) 
                    #                 
            except:
                pass
        if 'RPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['RPU'] = map3image4rpu()
                message3print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1R/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['RPU']) 
                    # 
            except:
                pass
        if 'SPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['SPU'] = map3image4spu()
                message3print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1S/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['SPU']) 
                    # 
            except:
                pass
        if 'TPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['TPU'] = map3image4tpu()
                message3print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1T/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['TPU']) 
                    # 
            except:
                pass
        if 'UPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['UPU'] = map3image4upu()
                message3print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1U/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['UPU']) 
                    # 
            except:
                pass
        if 'VPU' in keys3taskmapimage:                    
            try:
                control3mapimage4xi['VPU'] = map3image4vpu()
                message3print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1V/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['VPU']) 
                    # 
            except:
                pass
        if 'WPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['WPU'] = map3image4wpu()
                message3print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1W/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['WPU']) 
                    # 
            except:
                pass
        if 'XPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['XPU'] = map3image4xpu()
                message3print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1X/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['XPU']) 
                    # 
            except:
                pass
        if 'YPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['YPU'] = map3image4ypu()
                message3print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1Y/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['YPU']) 
                    # 
            except:
                pass
        if 'ZPU' in keys3taskmapimage:                     
            try:
                control3mapimage4xi['ZPU'] = map3image4zpu()
                message3print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get3imageinfo: " + str(control3mapimage4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1Z/33) of map3image4xi - control3mapimage4xi:  ', control3mapimage4xi['ZPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x00000000060E2780>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7256>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7252>}

            except:
                pass
               
    except:
        message3print = "{(Step 1Z/70) yielded" + "; control3mapimage4xi-yielded-by-map3image4xi: " + str(control3mapimage4xi) + "; time: " + time4xi() + "}"                
        print4xi(class3print, method3print, message3print)  
        code3nack  = code3nack + '1Z-'     
 
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    try:
        message3print = "{(Step 70A/70) set" + "; code3ack-set-by-map3image4xi: " + str(code3ack) + "; time: " + time4xi() + "}"  
        print4xi(class3print, method3print, message3print)                                                             
        # 
        message3print = "{(Step 70B/70) set" + "; code3nack-set-by-map3image4xi: " + str(code3nack) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                             
        # 
            
        message3print = "{(Step 70C/70) returning" + "; control3mapimage4xi-returning-by-map3image4xi: " + str(control3mapimage4xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                             
        # 
        if debug is True:
            print('(Step 33A/33) of map3image4xi - RETURNING CONTROL3MAPIMAGE4XI:  ', control3mapimage4xi) 
            # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E678D0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7228>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7224>}, 
            #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E6E128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7260>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7256>}, 
            #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E67F28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7196>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7192>}}
            
            print('(Step 33A33) of map3image4xi - PASSED (Step 33A/33) ', time4xi())
            print('(Step 33B33) of map3image4xi - PASSED (Step 33B/33) ', time4xi())
            print('(Step 33C33) of map3image4xi - PASSED (Step 33C/33) ', time4xi())
            print('(Step 33D33) of map3image4xi - PASSED (Step 33D/33) ', time4xi())
            print('(Step 33E33) of map3image4xi - PASSED (Step 33E/33) ', time4xi())
            print('(Step 33F33) of map3image4xi - PASSED (Step 33F/33) ', time4xi())
            print('(Step 33G33) of map3image4xi - PASSED (Step 33G/33) ', time4xi())
            print('(Step 33H33) of map3image4xi - PASSED (Step 33H/33) ', time4xi())
            print('(Step 33I33) of map3image4xi - PASSED (Step 33I/33) ', time4xi())
            print('(Step 33J33) of map3image4xi - PASSED (Step 33J/33) ', time4xi())
            print('(Step 33K33) of map3image4xi - PASSED (Step 33K/33) ', time4xi())
            print('(Step 33L33) of map3image4xi - PASSED (Step 33L/33) ', time4xi())
            print('(Step 33M33) of map3image4xi - PASSED (Step 33M/33) ', time4xi())
            print('(Step 33N33) of map3image4xi - PASSED (Step 33N/33) ', time4xi())
            print('(Step 33O33) of map3image4xi - PASSED (Step 33O/33) ', time4xi())
            print('(Step 33P33) of map3image4xi - PASSED (Step 33P/33) ', time4xi())
            print('(Step 33Q33) of map3image4xi - PASSED (Step 33Q/33) ', time4xi())
            print('(Step 33R33) of map3image4xi - PASSED (Step 33R/33) ', time4xi())
            print('(Step 33S33) of map3image4xi - PASSED (Step 33S/33) ', time4xi())
            print('(Step 33T33) of map3image4xi - PASSED (Step 33T/33) ', time4xi())
            print('(Step 33U33) of map3image4xi - PASSED (Step 33U/33) ', time4xi())
            print('(Step 33V33) of map3image4xi - PASSED (Step 33V/33) ', time4xi())
            print('(Step 33X33) of map3image4xi - PASSED (Step 33X/33) ', time4xi())
            print('(Step 33Y33) of map3image4xi - PASSED (Step 33Y/33) ', time4xi())
            print('(Step 33Z33) of map3image4xi - PASSED (Step 33Z/33) ', time4xi())
            print('(Step 33W33) of map3image4xi - PASSED (Step 33W/33) ', time4xi())

    except:
        pass
    
    print('(Step 33A233) of map3image4xi - PASSED (Step 33A2/33) ', time4xi())
    print('(Step 33B233) of map3image4xi - PASSED (Step 33B2/33) ', time4xi())
    print('(Step 33C233) of map3image4xi - PASSED (Step 33C2/33) ', time4xi())
    print('(Step 33D233) of map3image4xi - PASSED (Step 33D2/33) ', time4xi())
    print('(Step 33E233) of map3image4xi - PASSED (Step 33E2/33) ', time4xi())
    print('(Step 33F233) of map3image4xi - PASSED (Step 33F2/33) ', time4xi())
    print('(Step 33G233) of map3image4xi - PASSED (Step 33G2/33) ', time4xi())
    print('(Step 33H233) of map3image4xi - PASSED (Step 33H2/33) ', time4xi())
    print('(Step 33I233) of map3image4xi - PASSED (Step 33I2/33) ', time4xi())
    print('(Step 33J233) of map3image4xi - PASSED (Step 33J2/33) ', time4xi())
    print('(Step 33K233) of map3image4xi - PASSED (Step 33K2/33) ', time4xi())
    print('(Step 33L233) of map3image4xi - PASSED (Step 33L2/33) ', time4xi())
    print('(Step 33M233) of map3image4xi - PASSED (Step 33M2/33) ', time4xi())
    print('(Step 33N233) of map3image4xi - PASSED (Step 33N2/33) ', time4xi())
    print('(Step 33O233) of map3image4xi - PASSED (Step 33O2/33) ', time4xi())
    print('(Step 33P233) of map3image4xi - PASSED (Step 33P2/33) ', time4xi())
    print('(Step 33Q233) of map3image4xi - PASSED (Step 33Q2/33) ', time4xi())
    print('(Step 33R233) of map3image4xi - PASSED (Step 33R2/33) ', time4xi())
    print('(Step 33S233) of map3image4xi - PASSED (Step 33S2/33) ', time4xi())
    print('(Step 33T233) of map3image4xi - PASSED (Step 33T2/33) ', time4xi())
    print('(Step 33U233) of map3image4xi - PASSED (Step 33U2/33) ', time4xi())
    print('(Step 33V233) of map3image4xi - PASSED (Step 33V2/33) ', time4xi())
    print('(Step 33X233) of map3image4xi - PASSED (Step 33X2/33) ', time4xi())
    print('(Step 33Y233) of map3image4xi - PASSED (Step 33Y2/33) ', time4xi())
    print('(Step 33Z233) of map3image4xi - PASSED (Step 33Z2/33) ', time4xi())
    print('(Step 33W233) of map3image4xi - PASSED (Step 33W2/33) ', time4xi())
    
    if debug is True:
        print('(Step 33/33) of map3image4xi - RETURN COMMAND NEXT ', time4xi())
        #              
    return control3mapimage4xi
                    
                    
#</function4xi> 

# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre3copyimage4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------------------------------
#   # PHASE I: COPY FUNCTION  TESTS - SIMULATE MANOEUVRE3COPYIMAGE4XI  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
#   # ---------------------------------------------------------------------------------------------------------------------       
#   if ack3simulate4xi is True:
#       print("(Step 42A/700) OF IMAGE3D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE3COPYIMAGE4XI ", time4xi())   
#       try:
#           response3manoeuvre4copy = manoeuvre3copyimage4xi(queue4copy, channel4copy3consume, channel4copy3publish)
#           print("(Step 42B/700) OF IMAGE3D4XI5TEST - PERFORMED MANOEUVRE3COPYIMAGE4XI, RESPONSE3MANOEUVRE4COPY: ", response3manoeuvre4copy)
#           # 
#       except:
#           print("(Step 42Z/700) OF IMAGE3D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE3COPYIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thread    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre3copyimage4xi(queue3copymanoeuvre4xi, consumerchannel3copymanoeuvre4xi, publisherchannel3copymanoeuvre4xi):
    '''
    manoeuvres copy control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state3copy4xi                                                                                           
    global max3copystate4xi                                                                                        
    global ack3copyinfo4xi                                                                                         
    global message3copyget4xi                                 
    global message3copyput4xi
    global message3copyreceive4xi
    global message3copysend4xi
    
    global mission3copy                                                          
    
    global image3d4xi  
    global info3image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre3copyimage4xi - STARTED " , time4xi())
            #  
            print("(Step 0D2/33) of manoeuvre3copyimage4xi - PASSED QUEUE3READMANOEUVRE4XI: " , queue3copymanoeuvre4xi)
            # {'GPU': <queue4xi.Queue4Xi object at 0x0000000006047160>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000006047240>, 'APU': <queue4xi.Queue4Xi object at 0x0000000006047128>}

    
            print("(Step 0D3/33) of manoeuvre3copyimage4xi - PASSED CONSUMERCHANNEL3READMANOEUVRE4XI: " , consumerchannel3copymanoeuvre4xi)
            # {'GPU': <read-write PipeConnection, handle 6844>, 'ZPU': <read-write PipeConnection, handle 6876>, 'APU': <read-write PipeConnection, handle 6812>}

           
            print("(Step 0D4/33) of manoeuvre3copyimage4xi - PASSED PUBLISHERCHANNEL3READMANOEUVRE4XI: " , publisherchannel3copymanoeuvre4xi) 
            # {'GPU': <read-write PipeConnection, handle 6848>, 'ZPU': <read-write PipeConnection, handle 6880>, 'APU': <read-write PipeConnection, handle 6816>}

    
            print("(Step 0D5/33) of manoeuvre3copyimage4xi - USING STATE3READ4XI: " , state3copy4xi) 
            # {}
            
            
        keys3copymanoeuvre = queue3copymanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre3copyimage4xi - SET KEYS3READMANOEUVRE TO: ", keys3copymanoeuvre) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
            
                  
        response3manouvre4copy = {}
    except:
        print("(Step 0Z1/33) of manoeuvre3copyimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class3print  = "manoeuvre3copyimage4xi" 
        method3print = "manoeuvre3copyimage4xi" 
    
        code3ack  = ' '
        code3nack = ' '
        
        message3print = "{(Step 0A/33) started" + "; manoeuvre3copyimage4xi-started: " + str(manoeuvre3copyimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                                     #  
        # 
        
        message3print = "{(Step 0B/33) passed" + "; queue3copymanoeuvre4xi-to-manoeuvre3copyimage4xi: " + str(queue3copymanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0C/33) passed" + "; consumerchannel3copymanoeuvre4xi-to-manoeuvre3copyimage4xi: " + str(consumerchannel3copymanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0D/33) passed" + "; publisherchannel3copymanoeuvre4xi-to-manoeuvre3copyimage4xi: " + str(publisherchannel3copymanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        #   
        
        code3ack  = code3ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre3copyimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre3copyimage4xi - CHECKING MISSION AT STATE3READ4XI: " , state3copy4xi) 
        # {'GPU': 0}
        
         
    try:
        if mission3copy == "NACK":
            mission3copy = "ACK"
            print("(Step M1/33) of manoeuvre3copyimage4xi - SET MISSION3READ TO :  " , mission3copy)       
        else:
            mission3copy = "ACK"
            print("(Step M2/33) of manoeuvre3copyimage4xi - USING MISSION3READ:  " , mission3copy)
            # ACK
            
        if state3copy4xi == {}:    
            for key3copymanoeuvre in keys3copymanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state3copy4xi [key3copymanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3copy4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(state3copy4xi [key3copymanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                                    
                ack3copyinfo4xi [key3copymanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3copyinfo4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(ack3copyinfo4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3copyget4xi [key3copymanoeuvre] = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3copyget4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(message3copyget4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3copyput4xi [key3copymanoeuvre]  = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3copyput4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(message3copyput4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copyreceive4xi [key3copymanoeuvre]  = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3copyreceive4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(message3copyreceive4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copysend4xi [key3copymanoeuvre] = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3copysend4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(message3copysend4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                max3copystate4xi [key3copymanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3copystate4xi-initialized-by-manoeuvre3copyimage4xi to: " + str( max3copystate4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre3copyimage4xi  EXCEPTION: ", time4xi()) 
            mission3copy = "ACK" 
            print("(Step M3/33) of manoeuvre3copyimage4xi  EXCEPTIONAL MISSION3COPY:  " , mission3copy) 
            # ACK 
        if state3copy4xi == {}:                 
            for key3copymanoeuvre in keys3copymanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state3copy4xi [key3copymanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3copy4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(state3copy4xi [key3copymanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                    
                ack3copyinfo4xi [key3copymanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3copyinfo4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(ack3copyinfo4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3copyget4xi [key3copymanoeuvre] = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3copyget4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(message3copyget4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3copyput4xi [key3copymanoeuvre]  = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3copyput4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(message3copyput4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copyreceive4xi [key3copymanoeuvre]  = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3copyreceive4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(message3copyreceive4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copysend4xi [key3copymanoeuvre] = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3copysend4xi-initialized-by-manoeuvre3copyimage4xi to: " + str(message3copysend4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                max3copystate4xi [key3copymanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3copystate4xi-initialized-by-manoeuvre3copyimage4xi to: " + str( max3copystate4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre3copyimage4xi - NEXT PHASE PREPARING AT STATE3READ4XI: " , state3copy4xi) 
        # 
          
    for key3copymanoeuvre in keys3copymanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state3copy4xi [key3copymanoeuvre]  = state3copy4xi [key3copymanoeuvre]  + 1                                                                   
            message3print = "{(Step 0H/33) added" + "; state3copy4xi-added-by-manoeuvre3copyimage4xi: " + str(state3copy4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre3copyimage4xi TO: ", key3copymanoeuvre, " STATE3READ4XI-ADDED TO: " , state3copy4xi [key3copymanoeuvre]) 
                # 1
                
                 
            if state3copy4xi [key3copymanoeuvre] > max3copystate4xi [key3copymanoeuvre]:
                state3copy4xi [key3copymanoeuvre]  = 0
                message3print = "{(Step 0I/33) set" + "; state3copy4xi-set-by-manoeuvre3copyimage4xi to: " + str(state3copy4xi [key3copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre3copyimage4xi TO: ", key3copymanoeuvre, " STATE3READ4XI-ZEROED TO: " , state3copy4xi [key3copymanoeuvre]) 
                    # 
                    
                ack3copyinfo4xi [key3copymanoeuvre] = False
                message3print = "{(Step 0J/33) set" + "; ack3copyinfo4xi-set-by-manoeuvre3copyimage4xi to: " + str(ack3copyinfo4xi [key3copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                
                message3copyget4xi [key3copymanoeuvre] = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0K/33) set" + "; message3copyget4xi-set-by-manoeuvre3copyimage4xi to: " + str(message3copyget4xi [key3copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                
                message3copyput4xi [key3copymanoeuvre]  = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0L/33) set" + "; message3copyput4xi-set-by-manoeuvre3copyimage4xi to: " + str(message3copyput4xi [key3copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3copyreceive4xi [key3copymanoeuvre] = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0M/33) set" + "; message3copyreceive4xi-set-by-manoeuvre3copyimage4xi to: " + str(message3copyreceive4xi [key3copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3copysend4xi [key3copymanoeuvre]    = '<default4xi>default3copy4xi</default4xi>'
                message3print = "{(Step 0N/33) set" + "; message3copysend4xi-set-by-manoeuvre3copyimage4xi to: " + str(message3copysend4xi [key3copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                max3copystate4xi [key3copymanoeuvre] = 3
                message3print = "{(Step 0O/33) initialized" + ";  max3copystate4xi-set-by-manoeuvre3copyimage4xi to: " + str( max3copystate4xi [key3copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre3copyimage4xi FOR : ", key3copymanoeuvre, " CONTINUING WITH STATE3READ4XI: " , state3copy4xi [key3copymanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre3copyimage4xi *** FAILED UPDATING *** " , time4xi()) 
            try:
                print("*** key3copymanoeuvre: " , key3copymanoeuvre)
                # GPU
            except:
                pass
            try:    
                print("*** state3copy4xi: " , state3copy4xi)
                # {'GPU': 1}
            except:
                pass
            try:        
                print("*** ack3copyinfo4xi: " , ack3copyinfo4xi)
                #
            except:
                pass
            try:    
                print("*** message3copyget4xi: " , message3copyget4xi)
                #
            except:
                pass
            try:        
                print("*** message3copyput4xi: " , message3copyput4xi)
                #
            except:
                pass
            try:        
                print("*** message3copyreceive4xi: " , message3copyreceive4xi)
                #
            except:
                pass
            try:        
                print("*** message3copysend4xi: " , message3copysend4xi)
                #
            except:
                pass
            try:        
                print("*** max3copystate4xi: " , max3copystate4xi)
                #
            except:    
                pass
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre3copyimage4xi: CONSIDERING STATE I: " , state3copy4xi)
        # 
        
           
    for key3copymanoeuvre in keys3copymanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state3copy4xi [key3copymanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre3copyimage4xi: ", key3copymanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message3print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre3copyimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3copyreceive4xi [key3copymanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3copyreceive4xi [key3copymanoeuvre]  = consumerchannel3copymanoeuvre4xi [key3copymanoeuvre].recv()
                    message3print = "{(Step 1B/33) received" + "; message3copyreceive4xi-received-by-manoeuvre3copyimage4xi: " + str(message3copyreceive4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre3copyimage4xi: ", key3copymanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message3copyreceive4xi [key3copymanoeuvre])
                        # GPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy3copy4xi</copy4xi>
                         
                    if message3copyreceive4xi [key3copymanoeuvre]  == '<copy4xi>copy3copy4xi</copy4xi>':
                        message3copysend4xi [key3copymanoeuvre]  = '<copy4xi>copy3copy4xi</copy4xi>'
                    else:
                        message3copysend4xi [key3copymanoeuvre]  = '<negative4xi>negative3copy4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3copymanoeuvre4xi [key3copymanoeuvre].send(message3copysend4xi [key3copymanoeuvre])
                    
                    message3print = "{(Step 1C/33) sent" + "; message3copysend4xi-sent-by-manoeuvre3copyimage4xi: " + str(message3copysend4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre3copyimage4xi: ", key3copymanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message3copysend4xi [key3copymanoeuvre])
                        # 
                        
                    
                    code3ack  = code3ack + '1C-'
                except:
                    message3print = "{(Step 1Z/33) failed" + "; message3copyreceive4xi-failed-by-manoeuvre3copyimage4xi: " + str(message3copyreceive4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre3copyimage4xi: ", key3copymanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre3copyimage4xi: ", key3copymanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre3copyimage4xi: CONSIDERING STATE II : " , state3copy4xi)
        #
        
                  
    for key3copymanoeuvre in keys3copymanoeuvre:        
        try:
            if state3copy4xi [key3copymanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre3copyimage4xi - STATE II - ", key3copymanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message3print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre3copyimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3copyreceive4xi [key3copymanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3copyreceive4xi [key3copymanoeuvre]  = consumerchannel3copymanoeuvre4xi [key3copymanoeuvre].recv()
                    
                    message3print = "{(Step 2B/33) received" + "; message3copyreceive4xi-received-by-manoeuvre3copyimage4xi: " + str(message3copyreceive4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre3copyimage4xi - STATE II - FROM ", key3copymanoeuvre, " RECEIVED " , message3copyreceive4xi [key3copymanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready3copy4xi</ready4xi>  
           
                    if message3copyreceive4xi [key3copymanoeuvre]  == '<ready4xi>ready3copy4xi</ready4xi>':
                        message3copysend4xi [key3copymanoeuvre]  = '<ready4xi>ready3copy4xi</ready4xi>'
                    else:
                        message3copysend4xi [key3copymanoeuvre]  = '<negative4xi>negative3copy4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3copymanoeuvre4xi [key3copymanoeuvre].send(message3copysend4xi [key3copymanoeuvre])
                    
                    message3print = "{(Step 2C/33) sent" + "; message3copysend4xi-sent-by-manoeuvre3copyimage4xi: " + str(message3copysend4xi [key3copymanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre3copyimage4xi - STATE II - TO ", key3copymanoeuvre, " SENT " , message3copyreceive4xi [key3copymanoeuvre] )
                        #                       
                    
                    code3ack  = code3ack + '2C-'
                except:
                    message3print = "{(Step 2Z/33) failed" + "; message3copyreceive4xi-failed-by-manoeuvre3copyimage4xi: " + str(message3copyreceive4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '2Z-'
                    print("(Step 1/33) of manoeuvre3copyimage4xi - STATE II - ", key3copymanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre3copyimage4xi - STATE II - ", key3copymanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre3copyimage4xi: CONSIDERING STATE III : " , state3copy4xi)
        # 
            
    for key3copymanoeuvre in keys3copymanoeuvre:
        try:   
            if state3copy4xi [key3copymanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre3copyimage4xi - STATE III - ", key3copymanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info3image4xi [key3copymanoeuvre]  = None
                message3print = "{(Step 3A/70) try" + "; info3image4xi-try-by-manoeuvre3copyimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info3image4xi [key3copymanoeuvre]  = queue3copymanoeuvre4xi [key3copymanoeuvre].get()
                    
                    message3print = "{(Step 3B/33) got" + "; info3image4xi-got-by-manoeuvre3copyimage4xi: " + str(info3image4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre3copyimage4xi - STATE III - ", key3copymanoeuvre, " GOT INFO3IMAGE4XI: " , info3image4xi [key3copymanoeuvre])
                        #  
                    
                    if info3image4xi [key3copymanoeuvre]  is None:
                        code3nack  = code3nack + '3Z1-'
                        ack3copyinfo4xi [key3copymanoeuvre]  = False 
                    else:    
                        code3ack  = code3ack + '3C-'
                        ack3copyinfo4xi [key3copymanoeuvre]  = True
                except:
                    message3print = "{(Step 3Z1/33) failed" + "; queue3copymanoeuvre4xi-failed-by-manoeuvre3copyimage4xi: " + str(queue3copymanoeuvre4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '3Z1-'
                    
                message3copysend4xi [key3copymanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack3copyinfo4xi [key3copymanoeuvre]  is True:
                        message3copysend4xi [key3copymanoeuvre]  = '<ack4xi>ack3imageinfo4xi</ack4xi>'
                    else:
                        message3copysend4xi [key3copymanoeuvre]  = '<nack4xi>nack3imageinfo4xi</nack4xi>'
                    message3print = "{(Step 4B/33) set" + "; message3copysend4xi-set-by-manoeuvre3copyimage4xi to: " + str(message3copysend4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print) 
                    #       
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3copysend4xi-failed-by-manoeuvre3copyimage4xi: " + str(message3copysend4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    
                    code3nack  = code3nack + '4Z1-'    
                try:                
                    message3print = "{(Step 4C/70) using" + "; publisherchannel3copymanoeuvre4xi-calling-by-manoeuvre3copyimage4xi: " + str(publisherchannel3copymanoeuvre4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)    
                    # 
                    message3print = "{{(Step 4D/70) passing" + "; message3copysend4xi-passing-to-send-by-manoeuvre3copyimage4xi: " + str(message3copysend4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)
                    #              
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3copysend4xi-failed-by-manoeuvre3copyimage4xi: " + str(message3copysend4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z2-'                
                try:    
                    publisherchannel3copymanoeuvre4xi [key3copymanoeuvre].send(message3copysend4xi [key3copymanoeuvre] )
                    
                    message3print = "{(Step 4E/33) sent" + "; message3copysend4xi-sent-by-manoeuvre3copyimage4xi: " + str(message3copysend4xi [key3copymanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    #            
                    code3ack  = code3ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre3copyimage4xi - STATE III - ", key3copymanoeuvre, " SENT MESSAGE: " , message3copysend4xi [key3copymanoeuvre])
                        #    
                except:
                    message3print = "{(Step 4Z3/33) failed" + "; message3copysend4xi-failed-by-manoeuvre3copyimage4xi: " + str(message3copysend4xi [key3copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre3copyimage4xi - STATE III - ", key3copymanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre3copyimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state3copy4xi)
            # 
            
            print("(Step 5B/33) of manoeuvre3copyimage4xi - response3manouvre4copy: " , response3manouvre4copy)
            # 
            
            print("(Step 5C/33) of manoeuvre3copyimage4xi - ack3copyinfo4xi: " , ack3copyinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre3copyimage4xi - message3copyget4xi: ", message3copyget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre3copyimage4xi - message3copyput4xi: " , message3copyput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre3copyimage4xi - message3copyreceive4xi: " , message3copyreceive4xi)
            # 
            
            print("(Step 5G/33) of manoeuvre3copyimage4xi - message3copysend4xi: " , message3copysend4xi)
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre3copyimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state3copy4xi)
    
    print("(Step 5B/33) of manoeuvre3copyimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state3copy4xi)    
    try:        
        response3manouvre4copy ['ACK2INFO4XI']        = ack3copyinfo4xi 
        response3manouvre4copy ['MESSAGE2GET4XI']     = message3copyget4xi
        response3manouvre4copy ['MESSAGE2PUT4XI']     = message3copyput4xi
        response3manouvre4copy ['MESSAGE2RECEIVE4XI'] = message3copyreceive4xi
        response3manouvre4copy ['MESSAGE2SEND4XI']    = message3copysend4xi
        response3manouvre4copy ['STATE3MANOEUVRE4XI'] = state3copy4xi
    except:
        print("(Step 5Z2/33) of manoeuvre3copyimage4xi *** FAILED IN PREPARING RETURN KEY3READMANOEUVRE AT STATE: " , state3copy4xi)   
                             
    message3print = "{(Step 33/33) returning" + "; response3manouvre4copy-returning-by-manoeuvre3copyimage4xi: " + str(response3manouvre4copy) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre3copyimage4xi - RETURNING  WITH STATE: " , state3copy4xi, " RESPONSE3MANOUVRE4READ " , response3manouvre4copy)
        #1 
        # 
 
        #2
        #
 
        #3 
        # 

        #4
        #
        

    return response3manouvre4copy           
          
#</function4xi>

# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre3copyimagetobuffer4xi" usage = "
#   # -------------------------------------------------------------------------------------------------------------------------------------
#   # PHASE I: COPY3IMAGETOBUFFER FUNCTION  TESTS - SIMULATE MANOEUVRE3COPYIMAGE4XI  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
#   # -------------------------------------------------------------------------------------------------------------------------------------       
#   if ack3simulate4xi is True:
#       print("(Step 62A/700) OF IMAGE3D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE3COPYIMAGE4XI ", time4xi())   
#       try: 
#           response3manoeuvre4copy = manoeuvre3copyimagetobuffer4xi(queue4copyimagetobuffer, channel4copyimagetobuffer3consume, channel4copyimagetobuffer3publish)
#           print("(Step 62B/700) OF IMAGE3D4XI5TEST - PERFORMED MANOEUVRE3COPYIMAGE4XI, RESPONSE3MANOEUVRE4COPY: ", response3manoeuvre4copy)
#           # 
#       except:
#           print("(Step 62Z/700) OF IMAGE3D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE3COPYIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thread    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre3copyimagetobuffer4xi(queue3copyimagetobuffermanoeuvre4xi, consumerchannel3copyimagetobuffermanoeuvre4xi, publisherchannel3copyimagetobuffermanoeuvre4xi):
    '''
    manoeuvres copyimagetobuffer control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state3copyimagetobuffer4xi                                                                                           
    global max3copyimagetobufferstate4xi                                                                                        
    global ack3copyimagetobufferinfo4xi                                                                                         
    global message3copyimagetobufferget4xi                                 
    global message3copyimagetobufferput4xi
    global message3copyimagetobufferreceive4xi
    global message3copyimagetobuffersend4xi
    
    global mission3copyimagetobuffer                                                          
    
    global image3d4xi  
    global info3image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre3copyimagetobuffer4xi - STARTED " , time4xi())
            # 
            print("(Step 0D2/33) of manoeuvre3copyimagetobuffer4xi - PASSED QUEUE3READMANOEUVRE4XI: " , queue3copyimagetobuffermanoeuvre4xi)
            # 
    
            print("(Step 0D3/33) of manoeuvre3copyimagetobuffer4xi - PASSED CONSUMERCHANNEL3READMANOEUVRE4XI: " , consumerchannel3copyimagetobuffermanoeuvre4xi)
            # 
           
            print("(Step 0D4/33) of manoeuvre3copyimagetobuffer4xi - PASSED PUBLISHERCHANNEL3READMANOEUVRE4XI: " , publisherchannel3copyimagetobuffermanoeuvre4xi) 
            # 
    
            print("(Step 0D5/33) of manoeuvre3copyimagetobuffer4xi - USING STATE3READ4XI: " , state3copyimagetobuffer4xi) 
            #
            
            
        keys3copyimagetobuffermanoeuvre = queue3copyimagetobuffermanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre3copyimagetobuffer4xi - SET KEYS3READMANOEUVRE TO: ", keys3copyimagetobuffermanoeuvre) 
            #
            
                  
        response3manouvre4copyimagetobuffer = {}
    except:
        print("(Step 0Z1/33) of manoeuvre3copyimagetobuffer4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class3print  = "manoeuvre3copyimagetobuffer4xi" 
        method3print = "manoeuvre3copyimagetobuffer4xi" 
    
        code3ack  = ' '
        code3nack = ' '
        
        message3print = "{(Step 0A/33) started" + "; manoeuvre3copyimagetobuffer4xi-started: " + str(manoeuvre3copyimagetobuffer4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                                     #  
        # 
        
        message3print = "{(Step 0B/33) passed" + "; queue3copyimagetobuffermanoeuvre4xi-to-manoeuvre3copyimagetobuffer4xi: " + str(queue3copyimagetobuffermanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0C/33) passed" + "; consumerchannel3copyimagetobuffermanoeuvre4xi-to-manoeuvre3copyimagetobuffer4xi: " + str(consumerchannel3copyimagetobuffermanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0D/33) passed" + "; publisherchannel3copyimagetobuffermanoeuvre4xi-to-manoeuvre3copyimagetobuffer4xi: " + str(publisherchannel3copyimagetobuffermanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        #   
        
        code3ack  = code3ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre3copyimagetobuffer4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre3copyimagetobuffer4xi - CHECKING MISSION AT STATE3READ4XI: " , state3copyimagetobuffer4xi) 
        #
        
         
    try:
        if mission3copyimagetobuffer == "NACK":
            mission3copyimagetobuffer = "ACK"
            print("(Step M1/33) of manoeuvre3copyimagetobuffer4xi - SET MISSION3READ TO :  " , mission3copyimagetobuffer)       
        else:
            mission3copyimagetobuffer = "ACK"
            print("(Step M2/33) of manoeuvre3copyimagetobuffer4xi - USING MISSION3READ:  " , mission3copyimagetobuffer)
            # 
        if state3copyimagetobuffer4xi == {}:    
            for key3copyimagetobuffermanoeuvre in keys3copyimagetobuffermanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3copyimagetobuffer4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                                    
                ack3copyimagetobufferinfo4xi [key3copyimagetobuffermanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3copyimagetobufferinfo4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(ack3copyimagetobufferinfo4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3copyimagetobufferget4xi [key3copyimagetobuffermanoeuvre] = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3copyimagetobufferget4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobufferget4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3copyimagetobufferput4xi [key3copyimagetobuffermanoeuvre]  = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3copyimagetobufferput4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobufferput4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre]  = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3copyimagetobufferreceive4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3copyimagetobuffersend4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                max3copyimagetobufferstate4xi [key3copyimagetobuffermanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3copyimagetobufferstate4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str( max3copyimagetobufferstate4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre3copyimagetobuffer4xi  EXCEPTION: ", time4xi()) 
            mission3copyimagetobuffer = "ACK" 
            print("(Step M3/33) of manoeuvre3copyimagetobuffer4xi  EXCEPTIONAL MISSION3COPYIMAGETOBUFFER:  " , mission3copyimagetobuffer) 
            # 
        if state3copyimagetobuffer4xi == {}:                 
            for key3copyimagetobuffermanoeuvre in keys3copyimagetobuffermanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3copyimagetobuffer4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                    
                ack3copyimagetobufferinfo4xi [key3copyimagetobuffermanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3copyimagetobufferinfo4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(ack3copyimagetobufferinfo4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3copyimagetobufferget4xi [key3copyimagetobuffermanoeuvre] = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3copyimagetobufferget4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobufferget4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3copyimagetobufferput4xi [key3copyimagetobuffermanoeuvre]  = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3copyimagetobufferput4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobufferput4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre]  = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3copyimagetobufferreceive4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3copyimagetobuffersend4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                max3copyimagetobufferstate4xi [key3copyimagetobuffermanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3copyimagetobufferstate4xi-initialized-by-manoeuvre3copyimagetobuffer4xi to: " + str( max3copyimagetobufferstate4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre3copyimagetobuffer4xi - NEXT PHASE PREPARING AT STATE3READ4XI: " , state3copyimagetobuffer4xi) 
        # 
          
    for key3copyimagetobuffermanoeuvre in keys3copyimagetobuffermanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]  = state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]  + 1                                                                   
            message3print = "{(Step 0H/33) added" + "; state3copyimagetobuffer4xi-added-by-manoeuvre3copyimagetobuffer4xi: " + str(state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre3copyimagetobuffer4xi TO: ", key3copyimagetobuffermanoeuvre, " STATE3READ4XI-ADDED TO: " , state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]) 
                #
                
                 
            if state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre] > max3copyimagetobufferstate4xi [key3copyimagetobuffermanoeuvre]:
                state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]  = 0
                message3print = "{(Step 0I/33) set" + "; state3copyimagetobuffer4xi-set-by-manoeuvre3copyimagetobuffer4xi to: " + str(state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre3copyimagetobuffer4xi TO: ", key3copyimagetobuffermanoeuvre, " STATE3READ4XI-ZEROED TO: " , state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]) 
                    # 
                    
                ack3copyimagetobufferinfo4xi [key3copyimagetobuffermanoeuvre] = False
                message3print = "{(Step 0J/33) set" + "; ack3copyimagetobufferinfo4xi-set-by-manoeuvre3copyimagetobuffer4xi to: " + str(ack3copyimagetobufferinfo4xi [key3copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                
                message3copyimagetobufferget4xi [key3copyimagetobuffermanoeuvre] = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0K/33) set" + "; message3copyimagetobufferget4xi-set-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobufferget4xi [key3copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                
                message3copyimagetobufferput4xi [key3copyimagetobuffermanoeuvre]  = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0L/33) set" + "; message3copyimagetobufferput4xi-set-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobufferput4xi [key3copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre] = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0M/33) set" + "; message3copyimagetobufferreceive4xi-set-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre]    = '<default4xi>default3copyimagetobuffer4xi</default4xi>'
                message3print = "{(Step 0N/33) set" + "; message3copyimagetobuffersend4xi-set-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                max3copyimagetobufferstate4xi [key3copyimagetobuffermanoeuvre] = 3
                message3print = "{(Step 0O/33) initialized" + ";  max3copyimagetobufferstate4xi-set-by-manoeuvre3copyimagetobuffer4xi to: " + str( max3copyimagetobufferstate4xi [key3copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre3copyimagetobuffer4xi FOR : ", key3copyimagetobuffermanoeuvre, " CONTINUING WITH STATE3READ4XI: " , state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre3copyimagetobuffer4xi *** FAILED UPDATING *** " , time4xi())
            print("key3copyimagetobuffermanoeuvre: " , key3copyimagetobuffermanoeuvre)
            # 
            print("state3copyimagetobuffer4xi: " , state3copyimagetobuffer4xi)
            #
            print("ack3copyimagetobufferinfo4xi: " , ack3copyimagetobufferinfo4xi)
            #
            print("message3copyimagetobufferget4xi: " , message3copyimagetobufferget4xi)
            #
            print("message3copyimagetobufferput4xi: " , message3copyimagetobufferput4xi)
            #
            print("message3copyimagetobufferreceive4xi: " , message3copyimagetobufferreceive4xi)
            #
            print("message3copyimagetobuffersend4xi: " , message3copyimagetobuffersend4xi)
            #
            print("max3copyimagetobufferstate4xi: " , max3copyimagetobufferstate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre3copyimagetobuffer4xi: CONSIDERING STATE I: " , state3copyimagetobuffer4xi)
        # 
        
           
    for key3copyimagetobuffermanoeuvre in keys3copyimagetobuffermanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre3copyimagetobuffer4xi: ", key3copyimagetobuffermanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message3print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre3copyimagetobuffer4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre]  = consumerchannel3copyimagetobuffermanoeuvre4xi [key3copyimagetobuffermanoeuvre].recv()
                    message3print = "{(Step 1B/33) received" + "; message3copyimagetobufferreceive4xi-received-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre3copyimagetobuffer4xi: ", key3copyimagetobuffermanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre])
                        # GPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy3copyimagetobuffer4xi</copy4xi> 
                         
                    if message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre]  == '<copy4xi>copy3copyimagetobuffer4xi</copy4xi>':
                        message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre]  = '<copy4xi>copy3copyimagetobuffer4xi</copy4xi>'
                    else:
                        message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre]  = '<negative4xi>negative3copyimagetobuffer4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3copyimagetobuffermanoeuvre4xi [key3copyimagetobuffermanoeuvre].send(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre])
                    
                    message3print = "{(Step 1C/33) sent" + "; message3copyimagetobuffersend4xi-sent-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre3copyimagetobuffer4xi: ", key3copyimagetobuffermanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre])
                        # 
                        
                    
                    code3ack  = code3ack + '1C-'
                except:
                    message3print = "{(Step 1Z/33) failed" + "; message3copyimagetobufferreceive4xi-failed-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre3copyimagetobuffer4xi: ", key3copyimagetobuffermanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre3copyimagetobuffer4xi: ", key3copyimagetobuffermanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre3copyimagetobuffer4xi: CONSIDERING STATE II : " , state3copyimagetobuffer4xi)
        #
        
                  
    for key3copyimagetobuffermanoeuvre in keys3copyimagetobuffermanoeuvre:        
        try:
            if state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre3copyimagetobuffer4xi - STATE II - ", key3copyimagetobuffermanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message3print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre3copyimagetobuffer4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre]  = consumerchannel3copyimagetobuffermanoeuvre4xi [key3copyimagetobuffermanoeuvre].recv()
                    
                    message3print = "{(Step 2B/33) received" + "; message3copyimagetobufferreceive4xi-received-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre3copyimagetobuffer4xi - STATE II - FROM ", key3copyimagetobuffermanoeuvre, " RECEIVED " , message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre] )
                        # <ready4xi>ready3copyimagetobuffer4xi</ready4xi>  
           
                    if message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre]  == '<ready4xi>ready3copyimagetobuffer4xi</ready4xi>':
                        message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre]  = '<ready4xi>ready3copyimagetobuffer4xi</ready4xi>'
                    else:
                        message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre]  = '<negative4xi>negative3copyimagetobuffery4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3copyimagetobuffermanoeuvre4xi [key3copyimagetobuffermanoeuvre].send(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre])
                    
                    message3print = "{(Step 2C/33) sent" + "; message3copyimagetobuffersend4xi-sent-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre3copyimagetobuffer4xi - STATE II - TO ", key3copyimagetobuffermanoeuvre, " SENT " , message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre] )
                        #                       
                    
                    code3ack  = code3ack + '2C-'
                except:
                    message3print = "{(Step 2Z/33) failed" + "; message3copyimagetobufferreceive4xi-failed-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobufferreceive4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '2Z-'
                    print("(Step 1/33) of manoeuvre3copyimagetobuffer4xi - STATE II - ", key3copyimagetobuffermanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre3copyimagetobuffer4xi - STATE II - ", key3copyimagetobuffermanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre3copyimagetobuffer4xi: CONSIDERING STATE III : " , state3copyimagetobuffer4xi)
        # 
            
    for key3copyimagetobuffermanoeuvre in keys3copyimagetobuffermanoeuvre:
        try:   
            if state3copyimagetobuffer4xi [key3copyimagetobuffermanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre3copyimagetobuffer4xi - STATE III - ", key3copyimagetobuffermanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info3image4xi [key3copyimagetobuffermanoeuvre]  = None
                message3print = "{(Step 3A/70) try" + "; info3image4xi-try-by-manoeuvre3copyimagetobuffer4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info3image4xi [key3copyimagetobuffermanoeuvre]  = queue3copyimagetobuffermanoeuvre4xi [key3copyimagetobuffermanoeuvre].get()
                    
                    message3print = "{(Step 3B/33) got" + "; info3image4xi-got-by-manoeuvre3copyimagetobuffer4xi: " + str(info3image4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre3copyimagetobuffer4xi - STATE III - ", key3copyimagetobuffermanoeuvre, " GOT INFO3IMAGE4XI: " , info3image4xi [key3copyimagetobuffermanoeuvre])
                        #  
                    
                    if info3image4xi [key3copyimagetobuffermanoeuvre]  is None:
                        code3nack  = code3nack + '3Z1-'
                        ack3copyimagetobufferinfo4xi [key3copyimagetobuffermanoeuvre]  = False 
                    else:    
                        code3ack  = code3ack + '3C-'
                        ack3copyimagetobufferinfo4xi [key3copyimagetobuffermanoeuvre]  = True
                except:
                    message3print = "{(Step 3Z1/33) failed" + "; queue3copyimagetobuffermanoeuvre4xi-failed-by-manoeuvre3copyimagetobuffer4xi: " + str(queue3copyimagetobuffermanoeuvre4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '3Z1-'
                    
                message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack3copyimagetobufferinfo4xi [key3copyimagetobuffermanoeuvre]  is True:
                        message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre]  = '<ack4xi>ack3imageinfo4xi</ack4xi>'
                    else:
                        message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre]  = '<nack4xi>nack3imageinfo4xi</nack4xi>'
                    message3print = "{(Step 4B/33) set" + "; message3copyimagetobuffersend4xi-set-by-manoeuvre3copyimagetobuffer4xi to: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print) 
                    #       
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3copyimagetobuffersend4xi-failed-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    
                    code3nack  = code3nack + '4Z1-'    
                try:                
                    message3print = "{(Step 4C/70) using" + "; publisherchannel3copyimagetobuffermanoeuvre4xi-calling-by-manoeuvre3copyimagetobuffer4xi: " + str(publisherchannel3copyimagetobuffermanoeuvre4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)    
                    # 
                    message3print = "{{(Step 4D/70) passing" + "; message3copyimagetobuffersend4xi-passing-to-send-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)
                    #              
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3copyimagetobuffersend4xi-failed-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z2-'                
                try:    
                    publisherchannel3copyimagetobuffermanoeuvre4xi [key3copyimagetobuffermanoeuvre].send(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] )
                    
                    message3print = "{(Step 4E/33) sent" + "; message3copyimagetobuffersend4xi-sent-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    #            
                    code3ack  = code3ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre3copyimagetobuffer4xi - STATE III - ", key3copyimagetobuffermanoeuvre, " SENT MESSAGE: " , message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre])
                        #    
                except:
                    message3print = "{(Step 4Z3/33) failed" + "; message3copyimagetobuffersend4xi-failed-by-manoeuvre3copyimagetobuffer4xi: " + str(message3copyimagetobuffersend4xi [key3copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre3copyimagetobuffer4xi - STATE III - ", key3copyimagetobuffermanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre3copyimagetobuffer4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state3copyimagetobuffer4xi)
            # 
            
            print("(Step 5B/33) of manoeuvre3copyimagetobuffer4xi - response3manouvre4copyimagetobuffer: " , response3manouvre4copyimagetobuffer)
            # 
            
            print("(Step 5C/33) of manoeuvre3copyimagetobuffer4xi - ack3copyimagetobufferinfo4xi: " , ack3copyimagetobufferinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre3copyimagetobuffer4xi - message3copyimagetobufferget4xi: ", message3copyimagetobufferget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre3copyimagetobuffer4xi - message3copyimagetobufferput4xi: " , message3copyimagetobufferput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre3copyimagetobuffer4xi - message3copyimagetobufferreceive4xi: " , message3copyimagetobufferreceive4xi)
            # 
            
            print("(Step 5G/33) of manoeuvre3copyimagetobuffer4xi - message3copyimagetobuffersend4xi: " , message3copyimagetobuffersend4xi)
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre3copyimagetobuffer4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state3copyimagetobuffer4xi)
    
    print("(Step 5B/33) of manoeuvre3copyimagetobuffer4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state3copyimagetobuffer4xi)    
    try:        
        response3manouvre4copyimagetobuffer ['ACK2INFO4XI']        = ack3copyimagetobufferinfo4xi 
        response3manouvre4copyimagetobuffer ['MESSAGE2GET4XI']     = message3copyimagetobufferget4xi
        response3manouvre4copyimagetobuffer ['MESSAGE2PUT4XI']     = message3copyimagetobufferput4xi
        response3manouvre4copyimagetobuffer ['MESSAGE2RECEIVE4XI'] = message3copyimagetobufferreceive4xi
        response3manouvre4copyimagetobuffer ['MESSAGE2SEND4XI']    = message3copyimagetobuffersend4xi
        response3manouvre4copyimagetobuffer ['STATE3MANOEUVRE4XI'] = state3copyimagetobuffer4xi
    except:
        print("(Step 5Z2/33) of manoeuvre3copyimagetobuffer4xi *** FAILED IN PREPARING RETURN KEY3READMANOEUVRE AT STATE: " , state3copyimagetobuffer4xi)   
                             
    message3print = "{(Step 33/33) returning" + "; response3manouvre4copyimagetobuffer-returning-by-manoeuvre3copyimagetobuffer4xi: " + str(response3manouvre4copyimagetobuffer) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre3copyimagetobuffer4xi - RETURNING  WITH STATE: " , state3copyimagetobuffer4xi, " RESPONSE3MANOUVRE4READ " , response3manouvre4copyimagetobuffer)
        #1 
        # 
 
        #2
        #
 
        #3 
        # 

        #4
        #
        

    return response3manouvre4copyimagetobuffer           
          
#</function4xi>

# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre3copybuffertoimage4xi" usage = "
#   # -------------------------------------------------------------------------------------------------------------------------------------
#   # PHASE I: COPY3BUFFERTOIMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE3COPYIMAGE4XI  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
#   # -------------------------------------------------------------------------------------------------------------------------------------       
#   if ack3simulate4xi is True:
#       print("(Step 82A/700) OF IMAGE3D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE3COPYIMAGE4XI ", time4xi())   
#       try: 
#           response3manoeuvre4copy = manoeuvre3copybuffertoimage4xi(queue4copyimagetobuffer, channel4copybuffertoimage3consume, channel4copybuffertoimage3publish)
#           print("(Step 82B/700) OF IMAGE3D4XI5TEST - PERFORMED MANOEUVRE3COPYIMAGE4XI, RESPONSE3MANOEUVRE4COPY: ", response3manoeuvre4copy)
#           # 
#       except:
#           print("(Step 82Z/700) OF IMAGE3D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE3COPYIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thread    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre3copybuffertoimage4xi(queue3copybuffertoimagemanoeuvre4xi, consumerchannel3copybuffertoimagemanoeuvre4xi, publisherchannel3copybuffertoimagemanoeuvre4xi):
    '''
    manoeuvres copybuffertoimage control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state3copybuffertoimage4xi                                                                                           
    global max3copybuffertoimagestate4xi                                                                                        
    global ack3copybuffertoimageinfo4xi                                                                                         
    global message3copybuffertoimageget4xi                                 
    global message3copybuffertoimageput4xi
    global message3copybuffertoimagereceive4xi
    global message3copybuffertoimagesend4xi
    
    global mission3copybuffertoimage                                                          
    
    global image3d4xi  
    global info3image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre3copybuffertoimage4xi - STARTED " , time4xi())
            # 
            print("(Step 0D2/33) of manoeuvre3copybuffertoimage4xi - PASSED QUEUE3READMANOEUVRE4XI: " , queue3copybuffertoimagemanoeuvre4xi)
            # 
    
            print("(Step 0D3/33) of manoeuvre3copybuffertoimage4xi - PASSED CONSUMERCHANNEL3READMANOEUVRE4XI: " , consumerchannel3copybuffertoimagemanoeuvre4xi)
            # 
           
            print("(Step 0D4/33) of manoeuvre3copybuffertoimage4xi - PASSED PUBLISHERCHANNEL3READMANOEUVRE4XI: " , publisherchannel3copybuffertoimagemanoeuvre4xi) 
            # 
    
            print("(Step 0D5/33) of manoeuvre3copybuffertoimage4xi - USING STATE3READ4XI: " , state3copybuffertoimage4xi) 
            #
            
            
        keys3copybuffertoimagemanoeuvre = queue3copybuffertoimagemanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre3copybuffertoimage4xi - SET KEYS3READMANOEUVRE TO: ", keys3copybuffertoimagemanoeuvre) 
            #
            
                  
        response3manouvre4copybuffertoimage = {}
    except:
        print("(Step 0Z1/33) of manoeuvre3copybuffertoimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class3print  = "manoeuvre3copybuffertoimage4xi" 
        method3print = "manoeuvre3copybuffertoimage4xi" 
    
        code3ack  = ' '
        code3nack = ' '
        
        message3print = "{(Step 0A/33) started" + "; manoeuvre3copybuffertoimage4xi-started: " + str(manoeuvre3copybuffertoimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                                     #  
        # 
        
        message3print = "{(Step 0B/33) passed" + "; queue3copybuffertoimagemanoeuvre4xi-to-manoeuvre3copybuffertoimage4xi: " + str(queue3copybuffertoimagemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0C/33) passed" + "; consumerchannel3copybuffertoimagemanoeuvre4xi-to-manoeuvre3copybuffertoimage4xi: " + str(consumerchannel3copybuffertoimagemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0D/33) passed" + "; publisherchannel3copybuffertoimagemanoeuvre4xi-to-manoeuvre3copybuffertoimage4xi: " + str(publisherchannel3copybuffertoimagemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        #   
        
        code3ack  = code3ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre3copybuffertoimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre3copybuffertoimage4xi - CHECKING MISSION AT STATE3READ4XI: " , state3copybuffertoimage4xi) 
        #
        
         
    try:
        if mission3copybuffertoimage == "NACK":
            mission3copybuffertoimage = "ACK"
            print("(Step M1/33) of manoeuvre3copybuffertoimage4xi - SET MISSION3READ TO :  " , mission3copybuffertoimage)       
        else:
            mission3copybuffertoimage = "ACK"
            print("(Step M2/33) of manoeuvre3copybuffertoimage4xi - USING MISSION3READ:  " , mission3copybuffertoimage)
            # 
        if state3copybuffertoimage4xi == {}:    
            for key3copybuffertoimagemanoeuvre in keys3copybuffertoimagemanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3copybuffertoimage4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                                    
                ack3copybuffertoimageinfo4xi [key3copybuffertoimagemanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3copybuffertoimageinfo4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(ack3copybuffertoimageinfo4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3copybuffertoimageget4xi [key3copybuffertoimagemanoeuvre] = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3copybuffertoimageget4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimageget4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3copybuffertoimageput4xi [key3copybuffertoimagemanoeuvre]  = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3copybuffertoimageput4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimageput4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre]  = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3copybuffertoimagereceive4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3copybuffertoimagesend4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                max3copybuffertoimagestate4xi [key3copybuffertoimagemanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3copybuffertoimagestate4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str( max3copybuffertoimagestate4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre3copybuffertoimage4xi  EXCEPTION: ", time4xi()) 
            mission3copybuffertoimage = "ACK" 
            print("(Step M3/33) of manoeuvre3copybuffertoimage4xi ** EXCEPTIONAL COPYBUFFERTOIMAGE:  " , mission3copybuffertoimage) 
            # 
        if state3copybuffertoimage4xi == {}:                 
            for key3copybuffertoimagemanoeuvre in keys3copybuffertoimagemanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3copybuffertoimage4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                    
                ack3copybuffertoimageinfo4xi [key3copybuffertoimagemanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3copybuffertoimageinfo4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(ack3copybuffertoimageinfo4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3copybuffertoimageget4xi [key3copybuffertoimagemanoeuvre] = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3copybuffertoimageget4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimageget4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3copybuffertoimageput4xi [key3copybuffertoimagemanoeuvre]  = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3copybuffertoimageput4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimageput4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre]  = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3copybuffertoimagereceive4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3copybuffertoimagesend4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                max3copybuffertoimagestate4xi [key3copybuffertoimagemanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3copybuffertoimagestate4xi-initialized-by-manoeuvre3copybuffertoimage4xi to: " + str( max3copybuffertoimagestate4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre3copybuffertoimage4xi - NEXT PHASE PREPARING AT STATE3READ4XI: " , state3copybuffertoimage4xi) 
        # 
          
    for key3copybuffertoimagemanoeuvre in keys3copybuffertoimagemanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]  = state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]  + 1                                                                   
            message3print = "{(Step 0H/33) added" + "; state3copybuffertoimage4xi-added-by-manoeuvre3copybuffertoimage4xi: " + str(state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre3copybuffertoimage4xi TO: ", key3copybuffertoimagemanoeuvre, " STATE3READ4XI-ADDED TO: " , state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]) 
                #
                
                 
            if state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre] > max3copybuffertoimagestate4xi [key3copybuffertoimagemanoeuvre]:
                state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]  = 0
                message3print = "{(Step 0I/33) set" + "; state3copybuffertoimage4xi-set-by-manoeuvre3copybuffertoimage4xi to: " + str(state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre3copybuffertoimage4xi TO: ", key3copybuffertoimagemanoeuvre, " STATE3READ4XI-ZEROED TO: " , state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]) 
                    # 
                    
                ack3copybuffertoimageinfo4xi [key3copybuffertoimagemanoeuvre] = False
                message3print = "{(Step 0J/33) set" + "; ack3copybuffertoimageinfo4xi-set-by-manoeuvre3copybuffertoimage4xi to: " + str(ack3copybuffertoimageinfo4xi [key3copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                
                message3copybuffertoimageget4xi [key3copybuffertoimagemanoeuvre] = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0K/33) set" + "; message3copybuffertoimageget4xi-set-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimageget4xi [key3copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                
                message3copybuffertoimageput4xi [key3copybuffertoimagemanoeuvre]  = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0L/33) set" + "; message3copybuffertoimageput4xi-set-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimageput4xi [key3copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre] = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0M/33) set" + "; message3copybuffertoimagereceive4xi-set-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre]    = '<default4xi>default3copybuffertoimage4xi</default4xi>'
                message3print = "{(Step 0N/33) set" + "; message3copybuffertoimagesend4xi-set-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                max3copybuffertoimagestate4xi [key3copybuffertoimagemanoeuvre] = 3
                message3print = "{(Step 0O/33) initialized" + ";  max3copybuffertoimagestate4xi-set-by-manoeuvre3copybuffertoimage4xi to: " + str( max3copybuffertoimagestate4xi [key3copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre3copybuffertoimage4xi FOR : ", key3copybuffertoimagemanoeuvre, " CONTINUING WITH STATE3READ4XI: " , state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre3copybuffertoimage4xi *** FAILED UPDATING *** " , time4xi())
            print("key3copybuffertoimagemanoeuvre: " , key3copybuffertoimagemanoeuvre)
            # 
            print("state3copybuffertoimage4xi: " , state3copybuffertoimage4xi)
            #
            print("ack3copybuffertoimageinfo4xi: " , ack3copybuffertoimageinfo4xi)
            #
            print("message3copybuffertoimageget4xi: " , message3copybuffertoimageget4xi)
            #
            print("message3copybuffertoimageput4xi: " , message3copybuffertoimageput4xi)
            #
            print("message3copybuffertoimagereceive4xi: " , message3copybuffertoimagereceive4xi)
            #
            print("message3copybuffertoimagesend4xi: " , message3copybuffertoimagesend4xi)
            #
            print("max3copybuffertoimagestate4xi: " , max3copybuffertoimagestate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre3copybuffertoimage4xi: CONSIDERING STATE I: " , state3copybuffertoimage4xi)
        # 
        
           
    for key3copybuffertoimagemanoeuvre in keys3copybuffertoimagemanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre3copybuffertoimage4xi: ", key3copybuffertoimagemanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message3print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre3copybuffertoimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre]  = consumerchannel3copybuffertoimagemanoeuvre4xi [key3copybuffertoimagemanoeuvre].recv()
                    message3print = "{(Step 1B/33) received" + "; message3copybuffertoimagereceive4xi-received-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre3copybuffertoimage4xi: ", key3copybuffertoimagemanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre])
                        # <copy4xi>copy3copybuffertoimage4xi</copy4xi> 
                         
                    if message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre]  == '<copy4xi>copy3copybuffertoimage4xi</copy4xi>':
                        message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre]  = '<copy4xi>copy3copybuffertoimage4xi</copy4xi>'
                    else:
                        message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre]  = '<negative4xi>negative3copybuffertoimage4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3copybuffertoimagemanoeuvre4xi [key3copybuffertoimagemanoeuvre].send(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre])
                    
                    message3print = "{(Step 1C/33) sent" + "; message3copybuffertoimagesend4xi-sent-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre3copybuffertoimage4xi: ", key3copybuffertoimagemanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre])
                        # 
                        
                    
                    code3ack  = code3ack + '1C-'
                except:
                    message3print = "{(Step 1Z/33) failed" + "; message3copybuffertoimagereceive4xi-failed-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre3copybuffertoimage4xi: ", key3copybuffertoimagemanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre3copybuffertoimage4xi: ", key3copybuffertoimagemanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre3copybuffertoimage4xi: CONSIDERING STATE II : " , state3copybuffertoimage4xi)
        #
        
                  
    for key3copybuffertoimagemanoeuvre in keys3copybuffertoimagemanoeuvre:        
        try:
            if state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre3copybuffertoimage4xi - STATE II - ", key3copybuffertoimagemanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message3print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre3copybuffertoimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre]  = consumerchannel3copybuffertoimagemanoeuvre4xi [key3copybuffertoimagemanoeuvre].recv()
                    
                    message3print = "{(Step 2B/33) received" + "; message3copybuffertoimagereceive4xi-received-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre3copybuffertoimage4xi - STATE II - FROM ", key3copybuffertoimagemanoeuvre, " RECEIVED " , message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready3copybuffertoimage4xi</ready4xi>
           
                    if message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre]  == '<ready4xi>ready3copybuffertoimage4xi</ready4xi>':
                        message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre]  = '<ready4xi>ready3copybuffertoimage4xi</ready4xi>'
                    else:
                        message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre]  = '<negative4xi>negative3copybuffertoimagey4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3copybuffertoimagemanoeuvre4xi [key3copybuffertoimagemanoeuvre].send(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre])
                    
                    message3print = "{(Step 2C/33) sent" + "; message3copybuffertoimagesend4xi-sent-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre3copybuffertoimage4xi - STATE II - TO ", key3copybuffertoimagemanoeuvre, " SENT " , message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre] )
                        #                       
                    
                    code3ack  = code3ack + '2C-'
                except:
                    message3print = "{(Step 2Z/33) failed" + "; message3copybuffertoimagereceive4xi-failed-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagereceive4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '2Z-'
                    print("(Step 1/33) of manoeuvre3copybuffertoimage4xi - STATE II - ", key3copybuffertoimagemanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre3copybuffertoimage4xi - STATE II - ", key3copybuffertoimagemanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre3copybuffertoimage4xi: CONSIDERING STATE III : " , state3copybuffertoimage4xi)
        # 
            
    for key3copybuffertoimagemanoeuvre in keys3copybuffertoimagemanoeuvre:
        try:   
            if state3copybuffertoimage4xi [key3copybuffertoimagemanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre3copybuffertoimage4xi - STATE III - ", key3copybuffertoimagemanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info3image4xi [key3copybuffertoimagemanoeuvre]  = None
                message3print = "{(Step 3A/70) try" + "; info3image4xi-try-by-manoeuvre3copybuffertoimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info3image4xi [key3copybuffertoimagemanoeuvre]  = queue3copybuffertoimagemanoeuvre4xi [key3copybuffertoimagemanoeuvre].get()
                    
                    message3print = "{(Step 3B/33) got" + "; info3image4xi-got-by-manoeuvre3copybuffertoimage4xi: " + str(info3image4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre3copybuffertoimage4xi - STATE III - ", key3copybuffertoimagemanoeuvre, " GOT INFO3IMAGE4XI: " , info3image4xi [key3copybuffertoimagemanoeuvre])
                        #  
                    
                    if info3image4xi [key3copybuffertoimagemanoeuvre]  is None:
                        code3nack  = code3nack + '3Z1-'
                        ack3copybuffertoimageinfo4xi [key3copybuffertoimagemanoeuvre]  = False 
                    else:    
                        code3ack  = code3ack + '3C-'
                        ack3copybuffertoimageinfo4xi [key3copybuffertoimagemanoeuvre]  = True
                except:
                    message3print = "{(Step 3Z1/33) failed" + "; queue3copybuffertoimagemanoeuvre4xi-failed-by-manoeuvre3copybuffertoimage4xi: " + str(queue3copybuffertoimagemanoeuvre4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '3Z1-'
                    
                message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack3copybuffertoimageinfo4xi [key3copybuffertoimagemanoeuvre]  is True:
                        message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre]  = '<ack4xi>ack3imageinfo4xi</ack4xi>'
                    else:
                        message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre]  = '<nack4xi>nack3imageinfo4xi</nack4xi>'
                    message3print = "{(Step 4B/33) set" + "; message3copybuffertoimagesend4xi-set-by-manoeuvre3copybuffertoimage4xi to: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print) 
                    #       
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3copybuffertoimagesend4xi-failed-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    
                    code3nack  = code3nack + '4Z1-'    
                try:                
                    message3print = "{(Step 4C/70) using" + "; publisherchannel3copybuffertoimagemanoeuvre4xi-calling-by-manoeuvre3copybuffertoimage4xi: " + str(publisherchannel3copybuffertoimagemanoeuvre4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)    
                    # 
                    message3print = "{{(Step 4D/70) passing" + "; message3copybuffertoimagesend4xi-passing-to-send-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)
                    #              
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3copybuffertoimagesend4xi-failed-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z2-'                
                try:    
                    publisherchannel3copybuffertoimagemanoeuvre4xi [key3copybuffertoimagemanoeuvre].send(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] )
                    
                    message3print = "{(Step 4E/33) sent" + "; message3copybuffertoimagesend4xi-sent-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    #            
                    code3ack  = code3ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre3copybuffertoimage4xi - STATE III - ", key3copybuffertoimagemanoeuvre, " SENT MESSAGE: " , message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre])
                        #    
                except:
                    message3print = "{(Step 4Z3/33) failed" + "; message3copybuffertoimagesend4xi-failed-by-manoeuvre3copybuffertoimage4xi: " + str(message3copybuffertoimagesend4xi [key3copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre3copybuffertoimage4xi - STATE III - ", key3copybuffertoimagemanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre3copybuffertoimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state3copybuffertoimage4xi)
            # 
            
            print("(Step 5B/33) of manoeuvre3copybuffertoimage4xi - response3manouvre4copybuffertoimage: " , response3manouvre4copybuffertoimage)
            # 
            
            print("(Step 5C/33) of manoeuvre3copybuffertoimage4xi - ack3copybuffertoimageinfo4xi: " , ack3copybuffertoimageinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre3copybuffertoimage4xi - message3copybuffertoimageget4xi: ", message3copybuffertoimageget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre3copybuffertoimage4xi - message3copybuffertoimageput4xi: " , message3copybuffertoimageput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre3copybuffertoimage4xi - message3copybuffertoimagereceive4xi: " , message3copybuffertoimagereceive4xi)
            # 
            
            print("(Step 5G/33) of manoeuvre3copybuffertoimage4xi - message3copybuffertoimagesend4xi: " , message3copybuffertoimagesend4xi)
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre3copybuffertoimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state3copybuffertoimage4xi)
    
    print("(Step 5B/33) of manoeuvre3copybuffertoimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state3copybuffertoimage4xi)    
    try:        
        response3manouvre4copybuffertoimage ['ACK2INFO4XI']        = ack3copybuffertoimageinfo4xi 
        response3manouvre4copybuffertoimage ['MESSAGE2GET4XI']     = message3copybuffertoimageget4xi
        response3manouvre4copybuffertoimage ['MESSAGE2PUT4XI']     = message3copybuffertoimageput4xi
        response3manouvre4copybuffertoimage ['MESSAGE2RECEIVE4XI'] = message3copybuffertoimagereceive4xi
        response3manouvre4copybuffertoimage ['MESSAGE2SEND4XI']    = message3copybuffertoimagesend4xi
        response3manouvre4copybuffertoimage ['STATE3MANOEUVRE4XI'] = state3copybuffertoimage4xi
    except:
        print("(Step 5Z2/33) of manoeuvre3copybuffertoimage4xi *** FAILED IN PREPARING RETURN KEY3READMANOEUVRE AT STATE: " , state3copybuffertoimage4xi)   
                             
    message3print = "{(Step 33/33) returning" + "; response3manouvre4copybuffertoimage-returning-by-manoeuvre3copybuffertoimage4xi: " + str(response3manouvre4copybuffertoimage) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre3copybuffertoimage4xi - RETURNING  WITH STATE: " , state3copybuffertoimage4xi, " RESPONSE3MANOUVRE4READ " , response3manouvre4copybuffertoimage)
        #{'GPU': 1, 'ZPU': 1, 'APU': 1}  RESPONSE3MANOUVRE4READ  
        #      {'MESSAGE2RECEIVE4XI': {'GPU': '<copy4xi>copy3copybuffertoimage4xi</copy4xi>', 'ZPU': '<copy4xi>copy3copybuffertoimage4xi</copy4xi>', 'APU': '<copy4xi>copy3copybuffertoimage4xi</copy4xi>'}, 
        #       'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 'MESSAGE2GET4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'}, 
        #       'STATE3MANOEUVRE4XI': {'GPU': 1, 'ZPU': 1, 'APU': 1}, 
        #       'MESSAGE2SEND4XI': {'GPU': '<roger4xi>roger3copybuffertoimage4xi</roger4xi>', 'ZPU': '<roger4xi>roger3copybuffertoimage4xi</roger4xi>', 'APU': '<roger4xi>roger3copybuffertoimage4xi</roger4xi>'}, 
        #       'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'}}

 
        #2 {'GPU': 2, 'ZPU': 2, 'APU': 2}  RESPONSE3MANOUVRE4READ  
        # {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready3copybuffertoimage4xi</ready4xi>', 'ZPU': '<ready4xi>ready3copybuffertoimage4xi</ready4xi>', 'APU': '<ready4xi>ready3copybuffertoimage4xi</ready4xi>'}, 
        # 'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        # 'MESSAGE2GET4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'}, 
        # 'STATE3MANOEUVRE4XI': {'GPU': 2, 'ZPU': 2, 'APU': 2}, 
        # 'MESSAGE2SEND4XI': {'GPU': '<ready4xi>ready3copybuffertoimage4xi</ready4xi>', 'ZPU': '<ready4xi>ready3copybuffertoimage4xi</ready4xi>', 'APU': '<ready4xi>ready3copybuffertoimage4xi</ready4xi>'}, 
        # 'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'}}


        #3 
        #{'GPU': 3, 'ZPU': 3, 'APU': 3}  RESPONSE3MANOUVRE4READ  
        #  {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready3copybuffertoimage4xi</ready4xi>', 'ZPU': '<ready4xi>ready3copybuffertoimage4xi</ready4xi>', 'APU': '<ready4xi>ready3copybuffertoimage4xi</ready4xi>'}, 
        #   'ACK2INFO4XI': {'GPU': True, 'ZPU': True, 'APU': True}, 
        #   'MESSAGE2GET4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'}, 
        #   'STATE3MANOEUVRE4XI': {'GPU': 3, 'ZPU': 3, 'APU': 3}, 
        #   'MESSAGE2SEND4XI': {'GPU': '<ack4xi>ack3imageinfo4xi</ack4xi>', 'ZPU': '<ack4xi>ack3imageinfo4xi</ack4xi>', 'APU': '<ack4xi>ack3imageinfo4xi</ack4xi>'}, 
        #   'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'}}
 

        #4
        #{'GPU': 0, 'ZPU': 0, 'APU': 0}  RESPONSE3MANOUVRE4READ  
        # {'MESSAGE2RECEIVE4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'},
        #  'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        #  'MESSAGE2GET4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'}, 
        #  'STATE3MANOEUVRE4XI': {'GPU': 0, 'ZPU': 0, 'APU': 0}, 
        #  'MESSAGE2SEND4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'}, 
        #  'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default3copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default3copybuffertoimage4xi</default4xi>'}}

        

    return response3manouvre4copybuffertoimage           
          
#</function4xi>



# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre3readimage4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------------------------------------
#   # PHASE I: READ FUNCTION  TESTS - SIMULATE MANOEUVRE3READIMAGE4XI THREAD - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
#   # ---------------------------------------------------------------------------------------------------------------------------       
#   if ack3simulate4xi is True:
#       print("(Step 18A/700) OF IMAGE3D4XI5TEST - TRYING TO PASS PARAMETERS TO MANOEUVRE3READIMAGE4XI ", time4xi()) 
#       response3manoeuvre4read = {}
#       try:
#          # -----------------------------------------------------------------------------------------
#          # NOTE: DICTIONARY PARAMETERS MUST BE GIVEN TO VIRTUAL PROCESSING UNIT XI FUNCTION !
#          # -----------------------------------------------------------------------------------------
#          print("(Step 18B/700) OF IMAGE3D4XI5TEST - PASSING QUEUE3READ4XI ", queue4read)
#          # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005D64B00>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005D649B0>, 'APU': <queue4xi.Queue4Xi object at 0x0000000005D64748>}
#          # 
#          print("(Step 18C/700) OF IMAGE3D4XI5TEST - CHANNEL3READCONSUME4XI ", channel4read3consume)
#          # {'GPU': <read-write PipeConnection, handle 6580>, 'ZPU': <read-write PipeConnection, handle 6612>, 'APU': <read-write PipeConnection, handle 6548>}.
#          print("(Step 18D/700) OF IMAGE3D4XI5TEST - CHANNEL3READPUBLISH4XI ", channel4read3publish)
#          # {'GPU': <read-write PipeConnection, handle 6584>, 'ZPU': <read-write PipeConnection, handle 6616>, 'APU': <read-write PipeConnection, handle 6552>}
#       except:
#          print("(Step 18Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO PASS PARAMETERS TO MANOEUVRE3READIMAGE4XI ", time4xi()) 
#          
#       print("(Step 18E/700) OF IMAGE3D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE3READIMAGE4XI ", manoeuvre3readimage4xi)             
#       response3manoeuvre4read = {}
#       try:     
#          response3manoeuvre4read = manoeuvre3readimage4xi(queue4read, channel4read3consume, channel4read3publish)
#          print("(Step 18F/700) OF IMAGE3D4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE3READIMAGE4XI ", manoeuvre3readimage4xi)
#          # <function manoeuvre3readimage4xi at 0x000000000597A048>
#       except:
#           print("(Step 18Z2/700) OF IMAGE3D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE3READIMAGE4XI ", manoeuvre3readimage4xi)     
#   else:
#       pass # trust activated thread    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre3readimage4xi(queue3readmanoeuvre4xi, consumerchannel3readmanoeuvre4xi, publisherchannel3readmanoeuvre4xi):
    '''
    manoeuvres read control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state3read4xi                                                                                           
    global max3readstate4xi                                                                                        
    global ack3readinfo4xi                                                                                         
    global message3readget4xi                                 
    global message3readput4xi
    global message3readreceive4xi
    global message3readsend4xi
    
    global mission3read                                                          # MISSION TO READ
    
    global image3d4xi  
    global info3image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre3readimage4xi - STARTED " , time4xi())
            # 04:28:06 11/03/11 Pacific Daylight Time
            print("(Step 0D2/33) of manoeuvre3readimage4xi - PASSED QUEUE3READMANOEUVRE4XI: " , queue3readmanoeuvre4xi)
            # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005DFBEF0>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005DFBCC0>, 'APU': <queue4xi.Queue4Xi object at 0x0000000005DFBB38>}
    
            print("(Step 0D3/33) of manoeuvre3readimage4xi - PASSED CONSUMERCHANNEL3READMANOEUVRE4XI: " , consumerchannel3readmanoeuvre4xi)
            # {'GPU': <read-write PipeConnection, handle 6580>, 'ZPU': <read-write PipeConnection, handle 6612>, 'APU': <read-write PipeConnection, handle 6548>}
           
            print("(Step 0D4/33) of manoeuvre3readimage4xi - PASSED PUBLISHERCHANNEL3READMANOEUVRE4XI: " , publisherchannel3readmanoeuvre4xi) 
            # {'GPU': <read-write PipeConnection, handle 6584>, 'ZPU': <read-write PipeConnection, handle 6616>, 'APU': <read-write PipeConnection, handle 6552>}
    
            print("(Step 0D5/33) of manoeuvre3readimage4xi - USING STATE3READ4XI: " , state3read4xi) 
            #1 {'GPU': 1, 'ZPU': 1, 'APU': 1}  
            
            
        keys3readmanoeuvre = queue3readmanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre3readimage4xi - SET KEYS3READMANOEUVRE TO: ", keys3readmanoeuvre) 
            #1 dict_keys(['GPU', 'ZPU', 'APU'])
            #
                  
        response3manouvre4read = {}
    except:
        print("(Step 0Z1/33) of manoeuvre3readimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class3print  = "manoeuvre3readimage4xi" 
        method3print = "manoeuvre3readimage4xi" 
    
        code3ack  = ' '
        code3nack = ' '
        
        message3print = "{(Step 0A/33) started" + "; manoeuvre3readimage4xi-started: " + str(manoeuvre3readimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                                     #  
        # 
        
        message3print = "{(Step 0B/33) passed" + "; queue3readmanoeuvre4xi-to-manoeuvre3readimage4xi: " + str(queue3readmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0C/33) passed" + "; consumerchannel3readmanoeuvre4xi-to-manoeuvre3readimage4xi: " + str(consumerchannel3readmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0D/33) passed" + "; publisherchannel3readmanoeuvre4xi-to-manoeuvre3readimage4xi: " + str(publisherchannel3readmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        #   
        
        code3ack  = code3ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre3readimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre3readimage4xi - CHECKING MISSION AT STATE3READ4XI: " , state3read4xi) 
        #1 {}
         
    try:
        if mission3read == "NACK":
            mission3read = "ACK"
            print("(Step M1/33) of manoeuvre3readimage4xi - SET MISSION3READ TO :  " , mission3read)       
        else:
            mission3read = "ACK"
            print("(Step M2/33) of manoeuvre3readimage4xi - USING MISSION3READ:  " , mission3read)
            # 
        if state3read4xi == {}:    
            for key3readmanoeuvre in keys3readmanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state3read4xi [key3readmanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3read4xi-initialized-by-manoeuvre3readimage4xi to: " + str(state3read4xi [key3readmanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                    
                ack3readinfo4xi [key3readmanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3readinfo4xi-initialized-by-manoeuvre3readimage4xi to: " + str(ack3readinfo4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # False
                    
                message3readget4xi [key3readmanoeuvre] = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3readget4xi-initialized-by-manoeuvre3readimage4xi to: " + str(message3readget4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # <default4xi>default3read4xi</default4xi>
                    
                message3readput4xi [key3readmanoeuvre]  = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3readput4xi-initialized-by-manoeuvre3readimage4xi to: " + str(message3readput4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # <default4xi>default3read4xi</default4xi>
                    
                message3readreceive4xi [key3readmanoeuvre]  = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3readreceive4xi-initialized-by-manoeuvre3readimage4xi to: " + str(message3readreceive4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # <default4xi>default3read4xi</default4xi>
                    
                message3readsend4xi [key3readmanoeuvre] = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3readsend4xi-initialized-by-manoeuvre3readimage4xi to: " + str(message3readsend4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # <default4xi>default3read4xi</default4xi>
                    
                max3readstate4xi [key3readmanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3readstate4xi-initialized-by-manoeuvre3readimage4xi to: " + str( max3readstate4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre3readimage4xi  EXCEPTION: ", time4xi()) 
            mission3read = "ACK" 
            print("(Step M3/33) of manoeuvre3readimage4xi  EXCEPTIONAL MISSION3READ:  " , mission3read) 
            # 
        if state3read4xi == {}:                 
            for key3readmanoeuvre in keys3readmanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state3read4xi [key3readmanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3read4xi-initialized-by-manoeuvre3readimage4xi to: " + str(state3read4xi [key3readmanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                    
                ack3readinfo4xi [key3readmanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3readinfo4xi-initialized-by-manoeuvre3readimage4xi to: " + str(ack3readinfo4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # False
                    
                message3readget4xi [key3readmanoeuvre] = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3readget4xi-initialized-by-manoeuvre3readimage4xi to: " + str(message3readget4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # <default4xi>default3read4xi</default4xi>
                    
                message3readput4xi [key3readmanoeuvre]  = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3readput4xi-initialized-by-manoeuvre3readimage4xi to: " + str(message3readput4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # <default4xi>default3read4xi</default4xi>
                    
                message3readreceive4xi [key3readmanoeuvre]  = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3readreceive4xi-initialized-by-manoeuvre3readimage4xi to: " + str(message3readreceive4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # <default4xi>default3read4xi</default4xi>
                    
                message3readsend4xi [key3readmanoeuvre] = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3readsend4xi-initialized-by-manoeuvre3readimage4xi to: " + str(message3readsend4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # <default4xi>default3read4xi</default4xi>
                    
                max3readstate4xi [key3readmanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3readstate4xi-initialized-by-manoeuvre3readimage4xi to: " + str( max3readstate4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre3readimage4xi - NEXT PHASE PREPARING AT STATE3READ4XI: " , state3read4xi) 
        # {'GPU': 1, 'ZPU': 1, 'APU': 1}
        # {'GPU': 2, 'ZPU': 2, 'APU': 2}
        # {'GPU': 3, 'ZPU': 3, 'APU': 3}    
    for key3readmanoeuvre in keys3readmanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state3read4xi [key3readmanoeuvre]  = state3read4xi [key3readmanoeuvre]  + 1                                                                   
            message3print = "{(Step 0H/33) added" + "; state3read4xi-added-by-manoeuvre3readimage4xi: " + str(state3read4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre3readimage4xi TO: ", key3readmanoeuvre, " STATE3READ4XI-ADDED TO: " , state3read4xi [key3readmanoeuvre]) 
                #1 TO:  APU  STATE3READ4XI-ADDED TO:  1; TO:  ZPU  STATE3READ4XI-ADDED TO:  1;  TO:  APU  STATE3READ4XI-ADDED TO:  1
                #2 TO:  APU  STATE3READ4XI-ADDED TO:  2; TO:  ZPU  STATE3READ4XI-ADDED TO:  2;  TO:  APU  STATE3READ4XI-ADDED TO:  2
                 
            if state3read4xi [key3readmanoeuvre] > max3readstate4xi [key3readmanoeuvre]:
                state3read4xi [key3readmanoeuvre]  = 0
                message3print = "{(Step 0I/33) set" + "; state3read4xi-set-by-manoeuvre3readimage4xi to: " + str(state3read4xi [key3readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 0
                if debug is True:
                    print("(Step 0I/33) of manoeuvre3readimage4xi TO: ", key3readmanoeuvre, " STATE3READ4XI-ZEROED TO: " , state3read4xi [key3readmanoeuvre]) 
                    # GPU  STATE3READ4XI-ZEROED TO:  0; ZPU  STATE3READ4XI-ZEROED TO:  0; APU  STATE3READ4XI-ZEROED TO:  0
                ack3readinfo4xi [key3readmanoeuvre] = False
                message3print = "{(Step 0J/33) set" + "; ack3readinfo4xi-set-by-manoeuvre3readimage4xi to: " + str(ack3readinfo4xi [key3readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # False
                
                message3readget4xi [key3readmanoeuvre] = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0K/33) set" + "; message3readget4xi-set-by-manoeuvre3readimage4xi to: " + str(message3readget4xi [key3readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # <default4xi>default3read4xi</default4xi>
                
                message3readput4xi [key3readmanoeuvre]  = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0L/33) set" + "; message3readput4xi-set-by-manoeuvre3readimage4xi to: " + str(message3readput4xi [key3readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # <default4xi>default3read4xi</default4xi>
                
                message3readreceive4xi [key3readmanoeuvre] = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0M/33) set" + "; message3readreceive4xi-set-by-manoeuvre3readimage4xi to: " + str(message3readreceive4xi [key3readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # <default4xi>default3read4xi</default4xi>
                
                message3readsend4xi [key3readmanoeuvre]    = '<default4xi>default3read4xi</default4xi>'
                message3print = "{(Step 0N/33) set" + "; message3readsend4xi-set-by-manoeuvre3readimage4xi to: " + str(message3readsend4xi [key3readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # <default4xi>default3read4xi</default4xi>
                
                max3readstate4xi [key3readmanoeuvre] = 3
                message3print = "{(Step 0O/33) initialized" + ";  max3readstate4xi-set-by-manoeuvre3readimage4xi to: " + str( max3readstate4xi [key3readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre3readimage4xi FOR : ", key3readmanoeuvre, " CONTINUING WITH STATE3READ4XI: " , state3read4xi [key3readmanoeuvre])
                # FOR :  APU  CONTINUING WITH STATE3READ4XI:  1           
        except:
            print("(Step 0z1/33) of manoeuvre3readimage4xi *** FAILED UPDATING *** " , time4xi())
            print("key3readmanoeuvre: " , key3readmanoeuvre)
            # 
            print("state3read4xi: " , state3read4xi)
            #
            print("ack3readinfo4xi: " , ack3readinfo4xi)
            #
            print("message3readget4xi: " , message3readget4xi)
            #
            print("message3readput4xi: " , message3readput4xi)
            #
            print("message3readreceive4xi: " , message3readreceive4xi)
            #
            print("message3readsend4xi: " , message3readsend4xi)
            #
            print("max3readstate4xi: " , max3readstate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre3readimage4xi: CONSIDERING STATE I: " , state3read4xi)
        # CONSIDERING STATE I:  {'GPU': 1, 'ZPU': 1, 'APU': 1}
           
    for key3readmanoeuvre in keys3readmanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state3read4xi [key3readmanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre3readimage4xi: ", key3readmanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # APU  - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK  23:43:53 11/02/11 Pacific Daylight Time
                    
                message3print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre3readimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3readreceive4xi [key3readmanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3readreceive4xi [key3readmanoeuvre]  = consumerchannel3readmanoeuvre4xi [key3readmanoeuvre].recv()
                    message3print = "{(Step 1B/33) received" + "; message3readreceive4xi-received-by-manoeuvre3readimage4xi: " + str(message3readreceive4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre3readimage4xi: ", key3readmanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message3readreceive4xi [key3readmanoeuvre])
                        # GPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy3read4xi</copy4xi>; 
                        # ZPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy3read4xi</copy4xi>
                        # APU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy3read4xi</copy4xi>
                        #         
                    if message3readreceive4xi [key3readmanoeuvre]  == '<copy4xi>copy3read4xi</copy4xi>':
                        message3readsend4xi [key3readmanoeuvre]  = '<copy4xi>copy3read4xi</copy4xi>'
                    else:
                        message3readsend4xi [key3readmanoeuvre]  = '<negative4xi>negative3read4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3readmanoeuvre4xi [key3readmanoeuvre].send(message3readsend4xi [key3readmanoeuvre])
                    
                    message3print = "{(Step 1C/33) sent" + "; message3readsend4xi-sent-by-manoeuvre3readimage4xi: " + str(message3readsend4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # <roger4xi>roger3read4xi</roger4xi>
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre3readimage4xi: ", key3readmanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message3readsend4xi [key3readmanoeuvre])
                        # GPU  - STATE I - SENT MESSAGE VIA PIPE:  <roger4xi>roger3read4xi</roger4xi>
                        # ZPU  - STATE I - SENT MESSAGE VIA PIPE:  <roger4xi>roger3read4xi</roger4xi>
                        # APU  - STATE I - SENT MESSAGE VIA PIPE:  <roger4xi>roger3read4xi</roger4xi>
                        # 
                    
                    code3ack  = code3ack + '1C-'
                except:
                    message3print = "{(Step 1Z/33) failed" + "; message3readreceive4xi-failed-by-manoeuvre3readimage4xi: " + str(message3readreceive4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre3readimage4xi: ", key3readmanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre3readimage4xi: ", key3readmanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre3readimage4xi: CONSIDERING STATE II : " , state3read4xi)
        #1 {'GPU': 1, 'ZPU': 1, 'APU': 1}
        #2 {'GPU': 2, 'ZPU': 2, 'APU': 2} 
                  
    for key3readmanoeuvre in keys3readmanoeuvre:        
        try:
            if state3read4xi [key3readmanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre3readimage4xi - STATE II - ", key3readmanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #             
                message3print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre3readimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3readreceive4xi [key3readmanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3readreceive4xi [key3readmanoeuvre]  = consumerchannel3readmanoeuvre4xi [key3readmanoeuvre].recv()
                    
                    message3print = "{(Step 2B/33) received" + "; message3readreceive4xi-received-by-manoeuvre3readimage4xi: " + str(message3readreceive4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # <ready4xi>ready3read4xi</ready4xi> 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre3readimage4xi - STATE II - FROM ", key3readmanoeuvre, " RECEIVED " , message3readreceive4xi [key3readmanoeuvre] )
                        # <ready4xi>ready3read4xi</ready4xi>  
           
                    if message3readreceive4xi [key3readmanoeuvre]  == '<ready4xi>ready3read4xi</ready4xi>':
                        message3readsend4xi [key3readmanoeuvre]  = '<ready4xi>ready3read4xi</ready4xi>'
                    else:
                        message3readsend4xi [key3readmanoeuvre]  = '<negative4xi>negative3ready4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3readmanoeuvre4xi [key3readmanoeuvre].send(message3readsend4xi [key3readmanoeuvre])
                    
                    message3print = "{(Step 2C/33) sent" + "; message3readsend4xi-sent-by-manoeuvre3readimage4xi: " + str(message3readsend4xi [key3readmanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # <ready4xi>ready3read4xi</ready4xi>
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre3readimage4xi - STATE II - TO ", key3readmanoeuvre, " SENT " , message3readreceive4xi [key3readmanoeuvre] )
                        #                       
                    
                    code3ack  = code3ack + '2C-'
                except:
                    message3print = "{(Step 2Z/33) failed" + "; message3readreceive4xi-failed-by-manoeuvre3readimage4xi: " + str(message3readreceive4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '2Z-'
                    print("(Step 1/33) of manoeuvre3readimage4xi - STATE II - ", key3readmanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre3readimage4xi - STATE II - ", key3readmanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre3readimage4xi: CONSIDERING STATE III : " , state3read4xi)
        # {'GPU': 1, 'ZPU': 1, 'APU': 1}; {'GPU': 2, 'ZPU': 2, 'APU': 2}; {'GPU': 3, 'ZPU': 3, 'APU': 3}
        #           
    for key3readmanoeuvre in keys3readmanoeuvre:
        try:   
            if state3read4xi [key3readmanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre3readimage4xi - STATE III - ", key3readmanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info3image4xi [key3readmanoeuvre]  = None
                message3print = "{(Step 3A/70) try" + "; info3image4xi-try-by-manoeuvre3readimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info3image4xi [key3readmanoeuvre]  = queue3readmanoeuvre4xi [key3readmanoeuvre].get()
                    
                    message3print = "{(Step 3B/33) got" + "; info3image4xi-got-by-manoeuvre3readimage4xi: " + str(info3image4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre3readimage4xi - STATE III - ", key3readmanoeuvre, " GOT INFO3IMAGE4XI: " , info3image4xi [key3readmanoeuvre])
                        # ..//..//..//..//..//web//images//png//dragonxi.png    
                    
                    if info3image4xi [key3readmanoeuvre]  is None:
                        code3nack  = code3nack + '3Z1-'
                        ack3readinfo4xi [key3readmanoeuvre]  = False 
                    else:    
                        code3ack  = code3ack + '3C-'
                        ack3readinfo4xi [key3readmanoeuvre]  = True
                except:
                    message3print = "{(Step 3Z1/33) failed" + "; queue3readmanoeuvre4xi-failed-by-manoeuvre3readimage4xi: " + str(queue3readmanoeuvre4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '3Z1-'
                    
                message3readsend4xi [key3readmanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack3readinfo4xi [key3readmanoeuvre]  is True:
                        message3readsend4xi [key3readmanoeuvre]  = '<ack4xi>ack3imageinfo4xi</ack4xi>'
                    else:
                        message3readsend4xi [key3readmanoeuvre]  = '<nack4xi>nack3imageinfo4xi</nack4xi>'
                    message3print = "{(Step 4B/33) set" + "; message3readsend4xi-set-by-manoeuvre3readimage4xi to: " + str(message3readsend4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print) 
                    # <ack4xi>ack3imageinfo4xi</ack4xi>       
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3readsend4xi-failed-by-manoeuvre3readimage4xi: " + str(message3readsend4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    
                    code3nack  = code3nack + '4Z1-'    
                try:                
                    message3print = "{(Step 4C/70) using" + "; publisherchannel3readmanoeuvre4xi-calling-by-manoeuvre3readimage4xi: " + str(publisherchannel3readmanoeuvre4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)    
                    # <read-write PipeConnection, handle 412>
                    message3print = "{{(Step 4D/70) passing" + "; message3readsend4xi-passing-to-send-by-manoeuvre3readimage4xi: " + str(message3readsend4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)
                    #              
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3readsend4xi-failed-by-manoeuvre3readimage4xi: " + str(message3readsend4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z2-'                
                try:    
                    publisherchannel3readmanoeuvre4xi [key3readmanoeuvre].send(message3readsend4xi [key3readmanoeuvre] )
                    
                    message3print = "{(Step 4E/33) sent" + "; message3readsend4xi-sent-by-manoeuvre3readimage4xi: " + str(message3readsend4xi [key3readmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # <ack4xi>ack3imageinfo4xi</ack4xi>            
                    code3ack  = code3ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre3readimage4xi - STATE III - ", key3readmanoeuvre, " SENT MESSAGE: " , message3readsend4xi [key3readmanoeuvre])
                        #    
                except:
                    message3print = "{(Step 4Z3/33) failed" + "; message3readsend4xi-failed-by-manoeuvre3readimage4xi: " + str(message3readsend4xi [key3readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre3readimage4xi - STATE III - ", key3readmanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre3readimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state3read4xi)
            # {'GPU': 1, 'ZPU': 1, 'APU': 1} 
            
            print("(Step 5B/33) of manoeuvre3readimage4xi - response3manouvre4read: " , response3manouvre4read)
            # {}
            
            print("(Step 5C/33) of manoeuvre3readimage4xi - ack3readinfo4xi: " , ack3readinfo4xi)
            # {'GPU': False, 'ZPU': False, 'APU': False}
            
            print("(Step 5D/33) of manoeuvre3readimage4xi - message3readget4xi: ", message3readget4xi)
            # {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}
            
            print("(Step 5E/33) of manoeuvre3readimage4xi - message3readput4xi: " , message3readput4xi)
            # {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}
            
            print("(Step 5F/33) of manoeuvre3readimage4xi - message3readreceive4xi: " , message3readreceive4xi)
            # {'GPU': '<copy4xi>copy3read4xi</copy4xi>', 'ZPU': '<copy4xi>copy3read4xi</copy4xi>', 'APU': '<copy4xi>copy3read4xi</copy4xi>'}
            
            print("(Step 5G/33) of manoeuvre3readimage4xi - message3readsend4xi: " , message3readsend4xi)
            # {'GPU': '<roger4xi>roger3read4xi</roger4xi>', 'ZPU': '<roger4xi>roger3read4xi</roger4xi>', 'APU': '<roger4xi>roger3read4xi</roger4xi>'}
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre3readimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state3read4xi)
    
    print("(Step 5B/33) of manoeuvre3readimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state3read4xi)    
    try:        
        response3manouvre4read ['ACK2INFO4XI']        = ack3readinfo4xi 
        response3manouvre4read ['MESSAGE2GET4XI']     = message3readget4xi
        response3manouvre4read ['MESSAGE2PUT4XI']     = message3readput4xi
        response3manouvre4read ['MESSAGE2RECEIVE4XI'] = message3readreceive4xi
        response3manouvre4read ['MESSAGE2SEND4XI']    = message3readsend4xi
        response3manouvre4read ['STATE3MANOEUVRE4XI'] = state3read4xi
    except:
        print("(Step 5Z2/33) of manoeuvre3readimage4xi *** FAILED IN PREPARING RETURN KEY3READMANOEUVRE AT STATE: " , state3read4xi)   
                             
    message3print = "{(Step 33/33) returning" + "; response3manouvre4read-returning-by-manoeuvre3readimage4xi: " + str(response3manouvre4read) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre3readimage4xi - RETURNING  WITH STATE: " , state3read4xi, " RESPONSE3MANOUVRE4READ " , response3manouvre4read)
        #1 
        # {'GPU': 1, 'ZPU': 1, 'APU': 1} RESPONSE3MANOUVRE4READ  
        #   {'MESSAGE2RECEIVE4XI': {'GPU': '<copy4xi>copy3read4xi</copy4xi>', 'ZPU': '<copy4xi>copy3read4xi</copy4xi>', 'APU': '<copy4xi>copy3read4xi</copy4xi>'}, 
        #    'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        #    'MESSAGE2GET4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}, 
        #    'STATE3MANOEUVRE4XI': {'GPU': 1, 'ZPU': 1, 'APU': 1}, 
        #    'MESSAGE2SEND4XI': {'GPU': '<roger4xi>roger3read4xi</roger4xi>', 'ZPU': '<roger4xi>roger3read4xi</roger4xi>', 'APU': '<roger4xi>roger3read4xi</roger4xi>'}, 
        #    'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}}
 
        #2 {'GPU': 2, 'ZPU': 2, 'APU': 2}  RESPONSE3MANOUVRE4READ  
        #   {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready3read4xi</ready4xi>', 'ZPU': '<ready4xi>ready3read4xi</ready4xi>', 'APU': '<ready4xi>ready3read4xi</ready4xi>'}, 
        #    'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        #    'MESSAGE2GET4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}, 
        #    'STATE3MANOEUVRE4XI': {'GPU': 2, 'ZPU': 2, 'APU': 2}, 
        #    'MESSAGE2SEND4XI': {'GPU': '<ready4xi>ready3read4xi</ready4xi>', 'ZPU': '<ready4xi>ready3read4xi</ready4xi>', 'APU': '<ready4xi>ready3read4xi</ready4xi>'}, 
        #    'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}}
 
        #3 {'GPU': 3, 'ZPU': 3, 'APU': 3}  RESPONSE3MANOUVRE4READ 
        #   {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready3read4xi</ready4xi>', 'ZPU': '<ready4xi>ready3read4xi</ready4xi>', 'APU': '<ready4xi>ready3read4xi</ready4xi>'},
        #    'ACK2INFO4XI': {'GPU': True, 'ZPU': True, 'APU': True}, 
        #    'MESSAGE2GET4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}, 
        #    'STATE3MANOEUVRE4XI': {'GPU': 3, 'ZPU': 3, 'APU': 3}, 
        #    'MESSAGE2SEND4XI': {'GPU': '<ack4xi>ack3imageinfo4xi</ack4xi>', 'ZPU': '<ack4xi>ack3imageinfo4xi</ack4xi>', 'APU': '<ack4xi>ack3imageinfo4xi</ack4xi>'}, 
        #    'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}}

        #0
        #   {'GPU': 0, 'ZPU': 0, 'APU': 0} RESPONSE3MANOUVRE4READ
        #     {'MESSAGE2RECEIVE4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}, 
        #      'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False},
        #      'MESSAGE2GET4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}, 
        #      'STATE3MANOEUVRE4XI': {'GPU': 0, 'ZPU': 0, 'APU': 0}, 
        #      'MESSAGE2SEND4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}, 
        #      'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3read4xi</default4xi>', 'ZPU': '<default4xi>default3read4xi</default4xi>', 'APU': '<default4xi>default3read4xi</default4xi>'}}

    return response3manouvre4read           
          
#</function4xi>


# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre3writeimage4xi" usage = "
#   if ack3simulate4xi is True:
#       print("(Step 18C/700) OF IMAGE3D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE3READIMAGE4XI ", time4xi()) 
#       response3manoeuvre4write = {}
#       try:
#          # -----------------------------------------------------------------------------------------
#          # NOTE: DICTIONARY PARAMETERS MUST BE GIVEN TO VIRTUAL PROCESSING UNIT XI FUNCTION !
#          # -----------------------------------------------------------------------------------------
#          response3manoeuvre4write = manoeuvre3writeimage4xi(queue3write4xi, channel3writeconsume4xi, channel3writepublish4xi)
#          print("(Step 18D/700) OF IMAGE3D4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE3READIMAGE4XI ", manoeuvre3writeimage4xi)
#          # 
#       except:
#           print("(Step 18Z/700) OF IMAGE3D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE3READIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thwrite    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre3writeimage4xi(queue3writemanoeuvre4xi, consumerchannel3writemanoeuvre4xi, publisherchannel3writemanoeuvre4xi):
    '''
    manoeuvres write control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state3write4xi                                                                                           
    global max3writestate4xi                                                                                        
    global ack3writeinfo4xi                                                                                         
    global message3writeget4xi                                 
    global message3writeput4xi
    global message3writereceive4xi
    global message3writesend4xi
    
    global mission3write                                                          
    
    global image3d4xi  
    global info3image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre3writeimage4xi - STARTED " , time4xi())
            # 
            print("(Step 0D2/33) of manoeuvre3writeimage4xi - PASSED QUEUE3READMANOEUVRE4XI: " , queue3writemanoeuvre4xi)
            # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005F6A5F8>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005F6A710>, 'APU': <queue4xi.Queue4Xi object at 0x0000000005F63828>}
            # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005F6A5F8>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005F6A710>, 'APU': <queue4xi.Queue4Xi object at 0x0000000005F63828>}
    
            print("(Step 0D3/33) of manoeuvre3writeimage4xi - PASSED CONSUMERCHANNEL3READMANOEUVRE4XI: " , consumerchannel3writemanoeuvre4xi)
            # {'GPU': <read-write PipeConnection, handle 6716>, 'ZPU': <read-write PipeConnection, handle 6748>, 'APU': <read-write PipeConnection, handle 6684>}
            # 
           
            print("(Step 0D4/33) of manoeuvre3writeimage4xi - PASSED PUBLISHERCHANNEL3READMANOEUVRE4XI: " , publisherchannel3writemanoeuvre4xi) 
            # {'GPU': <read-write PipeConnection, handle 6720>, 'ZPU': <read-write PipeConnection, handle 6752>, 'APU': <read-write PipeConnection, handle 6688>}
            # {'GPU': <read-write PipeConnection, handle 6720>, 'ZPU': <read-write PipeConnection, handle 6752>, 'APU': <read-write PipeConnection, handle 6688>}
    
            print("(Step 0D5/33) of manoeuvre3writeimage4xi - USING STATE3READ4XI: " , state3write4xi) 
            # {}; 
            
            
        keys3writemanoeuvre = queue3writemanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre3writeimage4xi - SET KEYS3READMANOEUVRE TO: ", keys3writemanoeuvre) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
            
                  
        response3manouvre4write = {}
    except:
        print("(Step 0Z1/33) of manoeuvre3writeimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class3print  = "manoeuvre3writeimage4xi" 
        method3print = "manoeuvre3writeimage4xi" 
    
        code3ack  = ' '
        code3nack = ' '
        
        message3print = "{(Step 0A/33) started" + "; manoeuvre3writeimage4xi-started: " + str(manoeuvre3writeimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                                     #  
        # 
        
        message3print = "{(Step 0B/33) passed" + "; queue3writemanoeuvre4xi-to-manoeuvre3writeimage4xi: " + str(queue3writemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0C/33) passed" + "; consumerchannel3writemanoeuvre4xi-to-manoeuvre3writeimage4xi: " + str(consumerchannel3writemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0D/33) passed" + "; publisherchannel3writemanoeuvre4xi-to-manoeuvre3writeimage4xi: " + str(publisherchannel3writemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        #   
        
        code3ack  = code3ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre3writeimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre3writeimage4xi - CHECKING MISSION AT STATE3READ4XI: " , state3write4xi) 
        #
        
         
    try:
        if mission3write == "NACK":
            mission3write = "ACK"
            print("(Step M1/33) of manoeuvre3writeimage4xi - SET MISSION3READ TO :  " , mission3write)       
        else:
            mission3write = "ACK"
            print("(Step M2/33) of manoeuvre3writeimage4xi - USING MISSION3READ:  " , mission3write)
            # 
        if state3write4xi == {}:    
            for key3writemanoeuvre in keys3writemanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state3write4xi [key3writemanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3write4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(state3write4xi [key3writemanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                                    
                ack3writeinfo4xi [key3writemanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3writeinfo4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(ack3writeinfo4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3writeget4xi [key3writemanoeuvre] = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3writeget4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(message3writeget4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3writeput4xi [key3writemanoeuvre]  = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3writeput4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(message3writeput4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3writereceive4xi [key3writemanoeuvre]  = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3writereceive4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(message3writereceive4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3writesend4xi [key3writemanoeuvre] = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3writesend4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(message3writesend4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                #
                
                max3writestate4xi [key3writemanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3writestate4xi-initialized-by-manoeuvre3writeimage4xi to: " + str( max3writestate4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre3writeimage4xi  EXCEPTION: ", time4xi()) 
            mission3write = "ACK" 
            print("(Step M3/33) of manoeuvre3writeimage4xi  EXCEPTIONAL MISSION3WRITE:  " , mission3write) 
            # 
        if state3write4xi == {}:                 
            for key3writemanoeuvre in keys3writemanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state3write4xi [key3writemanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3write4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(state3write4xi [key3writemanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                    
                ack3writeinfo4xi [key3writemanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3writeinfo4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(ack3writeinfo4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3writeget4xi [key3writemanoeuvre] = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3writeget4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(message3writeget4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3writeput4xi [key3writemanoeuvre]  = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3writeput4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(message3writeput4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3writereceive4xi [key3writemanoeuvre]  = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3writereceive4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(message3writereceive4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3writesend4xi [key3writemanoeuvre] = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3writesend4xi-initialized-by-manoeuvre3writeimage4xi to: " + str(message3writesend4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                #

                max3writestate4xi [key3writemanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3writestate4xi-initialized-by-manoeuvre3writeimage4xi to: " + str( max3writestate4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre3writeimage4xi - NEXT PHASE PREPARING AT STATE3READ4XI: " , state3write4xi) 
        # 
          
    for key3writemanoeuvre in keys3writemanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state3write4xi [key3writemanoeuvre]  = state3write4xi [key3writemanoeuvre]  + 1                                                                   
            message3print = "{(Step 0H/33) added" + "; state3write4xi-added-by-manoeuvre3writeimage4xi: " + str(state3write4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre3writeimage4xi TO: ", key3writemanoeuvre, " STATE3READ4XI-ADDED TO: " , state3write4xi [key3writemanoeuvre]) 
                #
                
                 
            if state3write4xi [key3writemanoeuvre] > max3writestate4xi [key3writemanoeuvre]:
                state3write4xi [key3writemanoeuvre]  = 0
                message3print = "{(Step 0I/33) set" + "; state3write4xi-set-by-manoeuvre3writeimage4xi to: " + str(state3write4xi [key3writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre3writeimage4xi TO: ", key3writemanoeuvre, " STATE3READ4XI-ZEROED TO: " , state3write4xi [key3writemanoeuvre]) 
                    # 
                    
                ack3writeinfo4xi [key3writemanoeuvre] = False
                message3print = "{(Step 0J/33) set" + "; ack3writeinfo4xi-set-by-manoeuvre3writeimage4xi to: " + str(ack3writeinfo4xi [key3writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                
                message3writeget4xi [key3writemanoeuvre] = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0K/33) set" + "; message3writeget4xi-set-by-manoeuvre3writeimage4xi to: " + str(message3writeget4xi [key3writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                
                message3writeput4xi [key3writemanoeuvre]  = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0L/33) set" + "; message3writeput4xi-set-by-manoeuvre3writeimage4xi to: " + str(message3writeput4xi [key3writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3writereceive4xi [key3writemanoeuvre] = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0M/33) set" + "; message3writereceive4xi-set-by-manoeuvre3writeimage4xi to: " + str(message3writereceive4xi [key3writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3writesend4xi [key3writemanoeuvre]    = '<default4xi>default3write4xi</default4xi>'
                message3print = "{(Step 0N/33) set" + "; message3writesend4xi-set-by-manoeuvre3writeimage4xi to: " + str(message3writesend4xi [key3writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                #

                max3writestate4xi [key3writemanoeuvre] = 3
                message3print = "{(Step 0O/33) initialized" + ";  max3writestate4xi-set-by-manoeuvre3writeimage4xi to: " + str( max3writestate4xi [key3writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre3writeimage4xi FOR : ", key3writemanoeuvre, " CONTINUING WITH STATE3READ4XI: " , state3write4xi [key3writemanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre3writeimage4xi *** FAILED UPDATING *** " , time4xi())
            print("key3writemanoeuvre: " , key3writemanoeuvre)
            # 
            print("state3write4xi: " , state3write4xi)
            #
            print("ack3writeinfo4xi: " , ack3writeinfo4xi)
            #
            print("message3writeget4xi: " , message3writeget4xi)
            #
            print("message3writeput4xi: " , message3writeput4xi)
            #
            print("message3writereceive4xi: " , message3writereceive4xi)
            #
            print("message3writesend4xi: " , message3writesend4xi)
            #

            print("max3writestate4xi: " , max3writestate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre3writeimage4xi: CONSIDERING STATE I: " , state3write4xi)
        # {'GPU': 1, 'ZPU': 1, 'APU': 1} 
        
           
    for key3writemanoeuvre in keys3writemanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state3write4xi [key3writemanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre3writeimage4xi: ", key3writemanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message3print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre3writeimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3writereceive4xi [key3writemanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3writereceive4xi [key3writemanoeuvre]  = consumerchannel3writemanoeuvre4xi [key3writemanoeuvre].recv()
                    message3print = "{(Step 1B/33) received" + "; message3writereceive4xi-received-by-manoeuvre3writeimage4xi: " + str(message3writereceive4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B1/33) of manoeuvre3writeimage4xi: ", key3writemanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message3writereceive4xi [key3writemanoeuvre])
                        # <copy4xi>copy3write4xi</copy4xi>
                         
                    if message3writereceive4xi [key3writemanoeuvre]  == '<copy4xi>copy3write4xi</copy4xi>':
                        message3writesend4xi [key3writemanoeuvre]  = '<copy4xi>copy3write4xi</copy4xi>'
                        if debug is True:
                            print("FIRST FROM ", key3writemanoeuvre, " - STATE I - RECEIVED FROM MESSAGE3WRITERECEIVE4XI: " , message3writereceive4xi [key3writemanoeuvre])
                            # FROM  GPU  - STATE I - RECEIVED FROM MESSAGE3WRITERECEIVE4XI:  <copy4xi>copy3write4xi</copy4xi>
                            
                            print("FIRST TO ", key3writemanoeuvre, " - STATE I - SET MESSAGE3WRITESEND4XI TO: " , message3writesend4xi [key3writemanoeuvre])
                            # TO  GPU  - STATE I - SET MESSAGE3WRITESEND4XI TO:  <copy4xi>copy3write4xi</copy4xi>
                    else:
                        message3writesend4xi [key3writemanoeuvre]  = '<negative4xi>negative3write4xi</<negative4xi>'
                        if debug is True:
                            print("SECOND FROM ", key3writemanoeuvre, " - STATE I - RECEIVED FROM MESSAGE3WRITERECEIVE4XI: " , message3writereceive4xi [key3writemanoeuvre])
                            #
                            
                            print("SECOND TO ", key3writemanoeuvre, " - STATE I - SET MESSAGE3WRITESEND4Xi TO: " , message3writesend4xi [key3writemanoeuvre])
                            # 
                            
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                

                    publisherchannel3writemanoeuvre4xi [key3writemanoeuvre].send(message3writesend4xi [key3writemanoeuvre])
                    
                    message3print = "{(Step 1C/33) sent" + "; message3writesend4xi-sent-by-manoeuvre3writeimage4xi: " + str(message3writesend4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre3writeimage4xi: ", key3writemanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message3writesend4xi [key3writemanoeuvre])
                        # ZPU, GPU AND APU  - STATE I - SENT MESSAGE VIA PIPE:  <roger4xi>roger3write4xi</roger4xi>
                        
                    
                    code3ack  = code3ack + '1C-'
                except:
                    message3print = "{(Step 1Z/33) failed" + "; message3writereceive4xi-failed-by-manoeuvre3writeimage4xi: " + str(message3writereceive4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre3writeimage4xi: ", key3writemanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre3writeimage4xi: ", key3writemanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre3writeimage4xi: CONSIDERING STATE II : " , state3write4xi)
        # {'GPU': 2, 'ZPU': 2, 'APU': 2}
        
                  
    for key3writemanoeuvre in keys3writemanoeuvre:        
        try:
            if state3write4xi [key3writemanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre3writeimage4xi - STATE II - ", key3writemanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message3print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre3writeimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3writereceive4xi [key3writemanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE  
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3writereceive4xi [key3writemanoeuvre]  = consumerchannel3writemanoeuvre4xi [key3writemanoeuvre].recv()
                    
                    message3print = "{(Step 2B/33) received" + "; message3writereceive4xi-received-by-manoeuvre3writeimage4xi: " + str(message3writereceive4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre3writeimage4xi - STATE II - FROM ", key3writemanoeuvre, " RECEIVED " , message3writereceive4xi [key3writemanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready3write4xi</ready4xi>
                        # FROM  ZPU  RECEIVED  <ready4xi>ready3write4xi</ready4xi>
                        # FROM  APU  RECEIVED  <ready4xi>ready3write4xi</ready4xi>  
           
                    if message3writereceive4xi [key3writemanoeuvre]  == '<ready4xi>ready3write4xi</ready4xi>':
                        message3writesend4xi [key3writemanoeuvre]  = '<ready4xi>ready3write4xi</ready4xi>'

                    else:
                        message3writesend4xi [key3writemanoeuvre]  = '<negative4xi>negative3write4xi</<negative4xi>'

                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                

                    publisherchannel3writemanoeuvre4xi [key3writemanoeuvre].send(message3writesend4xi [key3writemanoeuvre])
                    
                    message3print = "{(Step 2C/33) sent" + "; message3writesend4xi-sent-by-manoeuvre3writeimage4xi: " + str(message3writesend4xi [key3writemanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre3writeimage4xi - STATE II - TO ", key3writemanoeuvre, " SENT " , message3writereceive4xi [key3writemanoeuvre] )
                        #                   
                    
                    code3ack  = code3ack + '2C-'
                except:
                    message3print = "{(Step 2Z/33) failed" + "; message3writereceive4xi-failed-by-manoeuvre3writeimage4xi: " + str(message3writereceive4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '2Z-'
                    print("(Step 1/33) of manoeuvre3writeimage4xi - STATE II - ", key3writemanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre3writeimage4xi - STATE II - ", key3writemanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre3writeimage4xi: CONSIDERING STATE III : " , state3write4xi)
        # 
            
    for key3writemanoeuvre in keys3writemanoeuvre:
        try:   
            if state3write4xi [key3writemanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre3writeimage4xi - STATE III - ", key3writemanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info3image4xi [key3writemanoeuvre]  = None
                message3print = "{(Step 3A/70) try" + "; info3image4xi-try-by-manoeuvre3writeimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info3image4xi [key3writemanoeuvre]  = queue3writemanoeuvre4xi [key3writemanoeuvre].get()
                    
                    message3print = "{(Step 3B/33) got" + "; info3image4xi-got-by-manoeuvre3writeimage4xi: " + str(info3image4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre3writeimage4xi - STATE III - ", key3writemanoeuvre, " GOT INFO3IMAGE4XI: " , info3image4xi [key3writemanoeuvre])
                        #  
                    
                    if info3image4xi [key3writemanoeuvre]  is None:
                        code3nack  = code3nack + '3Z1-'
                        ack3writeinfo4xi [key3writemanoeuvre]  = False 
                    else:    
                        code3ack  = code3ack + '3C-'
                        ack3writeinfo4xi [key3writemanoeuvre]  = True
                except:
                    message3print = "{(Step 3Z1/33) failed" + "; queue3writemanoeuvre4xi-failed-by-manoeuvre3writeimage4xi: " + str(queue3writemanoeuvre4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '3Z1-'
                    
                message3writesend4xi [key3writemanoeuvre]  = ' '

                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack3writeinfo4xi [key3writemanoeuvre] is True:
                        message3writesend4xi [key3writemanoeuvre]  = '<ack4xi>ack3imageinfo4xi</ack4xi>'

                    else:
                        message3writesend4xi [key3writemanoeuvre]  = '<nack4xi>nack3imageinfo4xi</nack4xi>'

                    message3print = "{(Step 4B/33) set" + "; message3writesend4xi-set-by-manoeuvre3writeimage4xi to: " + str(message3writesend4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print) 
                    #       
                except:

                    message3print = "{(Step 4Z1/33) failed" + "; message3writesend4xi-failed-by-manoeuvre3writeimage4xi: " + str(message3writesend4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    
                    code3nack  = code3nack + '4Z1-'    
                try:                
                    message3print = "{(Step 4C/70) using" + "; publisherchannel3writemanoeuvre4xi-calling-by-manoeuvre3writeimage4xi: " + str(publisherchannel3writemanoeuvre4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)    
                    # 
                    message3print = "{{(Step 4D/70) passing" + "; message3writesend4xi-passing-to-send-by-manoeuvre3writeimage4xi: " + str(message3writesend4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)
                    # 
       
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3writesend4xi-failed-by-manoeuvre3writeimage4xi: " + str(message3writesend4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z2-'                
                try:
    
                    publisherchannel3writemanoeuvre4xi [key3writemanoeuvre].send(message3writesend4xi [key3writemanoeuvre] )
                    
                    message3print = "{(Step 4E/33) sent" + "; message3writesend4xi-sent-by-manoeuvre3writeimage4xi: " + str(message3writesend4xi [key3writemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    #            
                    code3ack  = code3ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre3writeimage4xi - STATE III - ", key3writemanoeuvre, " SENT MESSAGE: " , message3writesend4xi [key3writemanoeuvre])
                        #    
                except:

                    message3print = "{(Step 4Z3/33) failed" + "; message3writesend4xi-failed-by-manoeuvre3writeimage4xi: " + str(message3writesend4xi [key3writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre3writeimage4xi - STATE III - ", key3writemanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre3writeimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state3write4xi)
            # {'GPU': 2, 'ZPU': 2, 'APU': 2}
            
            print("(Step 5B/33) of manoeuvre3writeimage4xi - response3manouvre4write: " , response3manouvre4write)
            # 
            
            print("(Step 5C/33) of manoeuvre3writeimage4xi - ack3writeinfo4xi: " , ack3writeinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre3writeimage4xi - message3writeget4xi: ", message3writeget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre3writeimage4xi - message3writeput4xi: " , message3writeput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre3writeimage4xi - message3writereceive4xi: " , message3writereceive4xi)
            # 

            
            print("(Step 5G/33) of manoeuvre3writeimage4xi - message3writesend4xi: " , message3writesend4xi)
            
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre3writeimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state3write4xi)
    
    print("(Step 5B/33) of manoeuvre3writeimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state3write4xi)    
    try:        
        response3manouvre4write ['ACK2INFO4XI']        = ack3writeinfo4xi 
        response3manouvre4write ['MESSAGE2GET4XI']     = message3writeget4xi
        response3manouvre4write ['MESSAGE2PUT4XI']     = message3writeput4xi
        response3manouvre4write ['MESSAGE2RECEIVE4XI'] = message3writereceive4xi
        response3manouvre4write ['MESSAGE2SEND4XI']    = message3writesend4xi
        response3manouvre4write ['STATE3MANOEUVRE4XI'] = state3write4xi
    except:
        print("(Step 5Z2/33) of manoeuvre3writeimage4xi *** FAILED IN PREPARING RETURN KEY3READMANOEUVRE AT STATE: " , state3write4xi)   
                             
    message3print = "{(Step 33/33) returning" + "; response3manouvre4write-returning-by-manoeuvre3writeimage4xi: " + str(response3manouvre4write) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             


    if debug is True: 
        print("(Step 33/33) of manoeuvre3writeimage4xi - RETURNING  WITH STATE: " , state3write4xi, " RESPONSE3MANOUVRE4READ " , response3manouvre4write)
        #1 
        # {'GPU': 1, 'ZPU': 1, 'APU': 1}  RESPONSE3MANOUVRE4READ  
        #         {'MESSAGE2RECEIVE4XI': {'GPU': '<copy4xi>copy3write4xi</copy4xi>', 'ZPU': '<copy4xi>copy3write4xi</copy4xi>', 'APU': '<copy4xi>copy3write4xi</copy4xi>'}, 
        #          'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        #          'MESSAGE2GET4XI': {'GPU': '<default4xi>default3write4xi</default4xi>', 'ZPU': '<default4xi>default3write4xi</default4xi>', 'APU': '<default4xi>default3write4xi</default4xi>'}, 
        #          'STATE3MANOEUVRE4XI': {'GPU': 1, 'ZPU': 1, 'APU': 1}, 
        #          'MESSAGE2SEND4XI': {'GPU': '<roger4xi>roger3write4xi</roger4xi>', 'ZPU': '<roger4xi>roger3write4xi</roger4xi>', 'APU': '<roger4xi>roger3write4xi</roger4xi>'}, 
        #          'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3write4xi</default4xi>', 'ZPU': '<default4xi>default3write4xi</default4xi>', 'APU': '<default4xi>default3write4xi</default4xi>'}}
 
 
        #2 
        # {'GPU': 2, 'ZPU': 2, 'APU': 2}  RESPONSE3MANOUVRE4READ  {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready3write4xi</ready4xi>', 'ZPU': '<ready4xi>ready3write4xi</ready4xi>', 'APU': '<ready4xi>ready3write4xi</ready4xi>'},
        #          'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False},
        #          'MESSAGE2GET4XI': {'GPU': '<default4xi>default3write4xi</default4xi>', 'ZPU': '<default4xi>default3write4xi</default4xi>', 'APU': '<default4xi>default3write4xi</default4xi>'},
        #          'STATE3MANOEUVRE4XI': {'GPU': 2, 'ZPU': 2, 'APU': 2},
        #          'MESSAGE2SEND4XI': {'GPU': '<ready4xi>ready3write4xi</ready4xi>', 'ZPU': '<ready4xi>ready3write4xi</ready4xi>', 'APU': '<ready4xi>ready3write4xi</ready4xi>'},
        #          'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3write4xi</default4xi>', 'ZPU': '<default4xi>default3write4xi</default4xi>', 'APU': '<default4xi>default3write4xi</default4xi>'}}

        #3  
        # {'GPU': 3, 'ZPU': 3, 'APU': 3}  RESPONSE3MANOUVRE4READ  {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready3write4xi</ready4xi>', 'ZPU': '<ready4xi>ready3write4xi</ready4xi>', 'APU': '<ready4xi>ready3write4xi</ready4xi>'},
        #          'ACK2INFO4XI': {'GPU': True, 'ZPU': True, 'APU': True},
        #          'MESSAGE2GET4XI': {'GPU': '<default4xi>default3write4xi</default4xi>', 'ZPU': '<default4xi>default3write4xi</default4xi>', 'APU': '<default4xi>default3write4xi</default4xi>'},
        #          'STATE3MANOEUVRE4XI': {'GPU': 3, 'ZPU': 3, 'APU': 3},
        #          'MESSAGE2SEND4XI': {'GPU': '<ack4xi>ack3imageinfo4xi</ack4xi>', 'ZPU': '<ack4xi>ack3imageinfo4xi</ack4xi>', 'APU': '<ack4xi>ack3imageinfo4xi</ack4xi>'},
        #          'MESSAGE2PUT4XI': {'GPU': '<default4xi>default3write4xi</default4xi>', 'ZPU': '<default4xi>default3write4xi</default4xi>', 'APU': '<default4xi>default3write4xi</default4xi>'}}
 

        #4
        #
        

    return response3manouvre4write           
          
#</function4xi>

# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre3mapimage4xi" usage = "
#   if ack3simulate4xi is True:
#       print("(Step 18C/700) OF IMAGE3D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE3READIMAGE4XI ", time4xi()) 
#       response3manoeuvre4map = {}
#       try:
#          # -----------------------------------------------------------------------------------------
#          # NOTE: DICTIONARY PARAMETERS MUST BE GIVEN TO VIRTUAL PROCESSING UNIT XI FUNCTION !
#          # -----------------------------------------------------------------------------------------
#          response3manoeuvre4map = manoeuvre3mapimage4xi(queue3map4xi, channel3mapconsume4xi, channel3mappublish4xi)
#          print("(Step 18D/700) OF IMAGE3D4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE3READIMAGE4XI ", manoeuvre3mapimage4xi)
#          # 
#       except:
#           print("(Step 18Z/700) OF IMAGE3D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE3READIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thmap    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre3mapimage4xi(queue3mapmanoeuvre4xi, consumerchannel3mapmanoeuvre4xi, publisherchannel3mapmanoeuvre4xi):
    '''
    manoeuvres map control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state3map4xi                                                                                           
    global max3mapstate4xi                                                                                        
    global ack3mapinfo4xi                                                                                         
    global message3mapget4xi                                 
    global message3mapput4xi
    global message3mapreceive4xi
    global message3mapsend4xi
    
    global mission3map                                                          
    
    global image3d4xi  
    global info3image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre3mapimage4xi - STARTED " , time4xi())
            # 
            print("(Step 0D2/33) of manoeuvre3mapimage4xi - PASSED QUEUE3READMANOEUVRE4XI: " , queue3mapmanoeuvre4xi)
            # 
    
            print("(Step 0D3/33) of manoeuvre3mapimage4xi - PASSED CONSUMERCHANNEL3READMANOEUVRE4XI: " , consumerchannel3mapmanoeuvre4xi)
            # 
           
            print("(Step 0D4/33) of manoeuvre3mapimage4xi - PASSED PUBLISHERCHANNEL3READMANOEUVRE4XI: " , publisherchannel3mapmanoeuvre4xi) 
            # 
    
            print("(Step 0D5/33) of manoeuvre3mapimage4xi - USING STATE3READ4XI: " , state3map4xi) 
            #
            
            
        keys3mapmanoeuvre = queue3mapmanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre3mapimage4xi - SET KEYS3READMANOEUVRE TO: ", keys3mapmanoeuvre) 
            #
            
                  
        response3manouvre4map = {}
    except:
        print("(Step 0Z1/33) of manoeuvre3mapimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class3print  = "manoeuvre3mapimage4xi" 
        method3print = "manoeuvre3mapimage4xi" 
    
        code3ack  = ' '
        code3nack = ' '
        
        message3print = "{(Step 0A/33) started" + "; manoeuvre3mapimage4xi-started: " + str(manoeuvre3mapimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                                     #  
        # 
        
        message3print = "{(Step 0B/33) passed" + "; queue3mapmanoeuvre4xi-to-manoeuvre3mapimage4xi: " + str(queue3mapmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0C/33) passed" + "; consumerchannel3mapmanoeuvre4xi-to-manoeuvre3mapimage4xi: " + str(consumerchannel3mapmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        # 
        
        message3print = "{(Step 0D/33) passed" + "; publisherchannel3mapmanoeuvre4xi-to-manoeuvre3mapimage4xi: " + str(publisherchannel3mapmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                              
        #   
        
        code3ack  = code3ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre3mapimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre3mapimage4xi - CHECKING MISSION AT STATE3READ4XI: " , state3map4xi) 
        #
        
         
    try:
        if mission3map == "NACK":
            mission3map = "ACK"
            print("(Step M1/33) of manoeuvre3mapimage4xi - SET MISSION3READ TO :  " , mission3map)       
        else:
            mission3map = "ACK"
            print("(Step M2/33) of manoeuvre3mapimage4xi - USING MISSION3READ:  " , mission3map)
            # 
        if state3map4xi == {}:    
            for key3mapmanoeuvre in keys3mapmanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state3map4xi [key3mapmanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3map4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(state3map4xi [key3mapmanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                                    
                ack3mapinfo4xi [key3mapmanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3mapinfo4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(ack3mapinfo4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3mapget4xi [key3mapmanoeuvre] = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3mapget4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(message3mapget4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3mapput4xi [key3mapmanoeuvre]  = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3mapput4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(message3mapput4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3mapreceive4xi [key3mapmanoeuvre]  = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3mapreceive4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(message3mapreceive4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3mapsend4xi [key3mapmanoeuvre] = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3mapsend4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(message3mapsend4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                max3mapstate4xi [key3mapmanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3mapstate4xi-initialized-by-manoeuvre3mapimage4xi to: " + str( max3mapstate4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre3mapimage4xi  EXCEPTION: ", time4xi()) 
            mission3map = "ACK" 
            print("(Step M3/33) of manoeuvre3mapimage4xi  EXCEPTIONAL MISSION3MAP:  " , mission3map) 
            # 
        if state3map4xi == {}:                 
            for key3mapmanoeuvre in keys3mapmanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state3map4xi [key3mapmanoeuvre]   = 0
                message3print = "{(Step 0Z1/33) initialized" + "; state3map4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(state3map4xi [key3mapmanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                # 
                    
                ack3mapinfo4xi [key3mapmanoeuvre] = False
                message3print = "{(Step 0Z2/33) initialized" + "; ack3mapinfo4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(ack3mapinfo4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                    
                message3mapget4xi [key3mapmanoeuvre] = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0Z3/33) initialized" + "; message3mapget4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(message3mapget4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                    
                message3mapput4xi [key3mapmanoeuvre]  = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0Z4/33) initialized" + "; message3mapput4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(message3mapput4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3mapreceive4xi [key3mapmanoeuvre]  = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0Z5/33) initialized" + "; message3mapreceive4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(message3mapreceive4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                message3mapsend4xi [key3mapmanoeuvre] = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0Z6/33) initialized" + "; message3mapsend4xi-initialized-by-manoeuvre3mapimage4xi to: " + str(message3mapsend4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                    
                max3mapstate4xi [key3mapmanoeuvre] = 3
                message3print = "{(Step 0Z7/33) initialized" + ";  max3mapstate4xi-initialized-by-manoeuvre3mapimage4xi to: " + str( max3mapstate4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre3mapimage4xi - NEXT PHASE PREPARING AT STATE3READ4XI: " , state3map4xi) 
        # 
          
    for key3mapmanoeuvre in keys3mapmanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state3map4xi [key3mapmanoeuvre]  = state3map4xi [key3mapmanoeuvre]  + 1                                                                   
            message3print = "{(Step 0H/33) added" + "; state3map4xi-added-by-manoeuvre3mapimage4xi: " + str(state3map4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre3mapimage4xi TO: ", key3mapmanoeuvre, " STATE3READ4XI-ADDED TO: " , state3map4xi [key3mapmanoeuvre]) 
                #
                
                 
            if state3map4xi [key3mapmanoeuvre] > max3mapstate4xi [key3mapmanoeuvre]:
                state3map4xi [key3mapmanoeuvre]  = 0
                message3print = "{(Step 0I/33) set" + "; state3map4xi-set-by-manoeuvre3mapimage4xi to: " + str(state3map4xi [key3mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre3mapimage4xi TO: ", key3mapmanoeuvre, " STATE3READ4XI-ZEROED TO: " , state3map4xi [key3mapmanoeuvre]) 
                    # 
                    
                ack3mapinfo4xi [key3mapmanoeuvre] = False
                message3print = "{(Step 0J/33) set" + "; ack3mapinfo4xi-set-by-manoeuvre3mapimage4xi to: " + str(ack3mapinfo4xi [key3mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                                     
                # 
                
                message3mapget4xi [key3mapmanoeuvre] = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0K/33) set" + "; message3mapget4xi-set-by-manoeuvre3mapimage4xi to: " + str(message3mapget4xi [key3mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)                                               
                # 
                
                message3mapput4xi [key3mapmanoeuvre]  = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0L/33) set" + "; message3mapput4xi-set-by-manoeuvre3mapimage4xi to: " + str(message3mapput4xi [key3mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3mapreceive4xi [key3mapmanoeuvre] = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0M/33) set" + "; message3mapreceive4xi-set-by-manoeuvre3mapimage4xi to: " + str(message3mapreceive4xi [key3mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                message3mapsend4xi [key3mapmanoeuvre]    = '<default4xi>default3map4xi</default4xi>'
                message3print = "{(Step 0N/33) set" + "; message3mapsend4xi-set-by-manoeuvre3mapimage4xi to: " + str(message3mapsend4xi [key3mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)              
                # 
                
                max3mapstate4xi [key3mapmanoeuvre] = 3
                message3print = "{(Step 0O/33) initialized" + ";  max3mapstate4xi-set-by-manoeuvre3mapimage4xi to: " + str( max3mapstate4xi [key3mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre3mapimage4xi FOR : ", key3mapmanoeuvre, " CONTINUING WITH STATE3READ4XI: " , state3map4xi [key3mapmanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre3mapimage4xi *** FAILED UPDATING *** " , time4xi())
            print("key3mapmanoeuvre: " , key3mapmanoeuvre)
            # 
            print("state3map4xi: " , state3map4xi)
            #
            print("ack3mapinfo4xi: " , ack3mapinfo4xi)
            #
            print("message3mapget4xi: " , message3mapget4xi)
            #
            print("message3mapput4xi: " , message3mapput4xi)
            #
            print("message3mapreceive4xi: " , message3mapreceive4xi)
            #
            print("message3mapsend4xi: " , message3mapsend4xi)
            #
            print("max3mapstate4xi: " , max3mapstate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre3mapimage4xi: CONSIDERING STATE I: " , state3map4xi)
        # 
        
           
    for key3mapmanoeuvre in keys3mapmanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state3map4xi [key3mapmanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre3mapimage4xi: ", key3mapmanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message3print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre3mapimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3mapreceive4xi [key3mapmanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3mapreceive4xi [key3mapmanoeuvre]  = consumerchannel3mapmanoeuvre4xi [key3mapmanoeuvre].recv()
                    message3print = "{(Step 1B/33) received" + "; message3mapreceive4xi-received-by-manoeuvre3mapimage4xi: " + str(message3mapreceive4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre3mapimage4xi: ", key3mapmanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message3mapreceive4xi [key3mapmanoeuvre])
                        # GPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy3mapimage4xi</copy4xi>
                         
                    if message3mapreceive4xi [key3mapmanoeuvre]  == '<copy4xi>copy3mapimage4xi</copy4xi>':
                        message3mapsend4xi [key3mapmanoeuvre]  = '<copy4xi>copy3mapimage4xi</copy4xi>'
                    else:
                        message3mapsend4xi [key3mapmanoeuvre]  = '<negative4xi>negative3map4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3mapmanoeuvre4xi [key3mapmanoeuvre].send(message3mapsend4xi [key3mapmanoeuvre])
                    
                    message3print = "{(Step 1C/33) sent" + "; message3mapsend4xi-sent-by-manoeuvre3mapimage4xi: " + str(message3mapsend4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre3mapimage4xi: ", key3mapmanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message3mapsend4xi [key3mapmanoeuvre])
                        # 
                        
                    
                    code3ack  = code3ack + '1C-'
                except:
                    message3print = "{(Step 1Z/33) failed" + "; message3mapreceive4xi-failed-by-manoeuvre3mapimage4xi: " + str(message3mapreceive4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre3mapimage4xi: ", key3mapmanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre3mapimage4xi: ", key3mapmanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre3mapimage4xi: CONSIDERING STATE II : " , state3map4xi)
        #
        
                  
    for key3mapmanoeuvre in keys3mapmanoeuvre:        
        try:
            if state3map4xi [key3mapmanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre3mapimage4xi - STATE II - ", key3mapmanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message3print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre3mapimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                message3mapreceive4xi [key3mapmanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message3mapreceive4xi [key3mapmanoeuvre]  = consumerchannel3mapmanoeuvre4xi [key3mapmanoeuvre].recv()
                    
                    message3print = "{(Step 2B/33) received" + "; message3mapreceive4xi-received-by-manoeuvre3mapimage4xi: " + str(message3mapreceive4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True: 
                        print("(Step 2B/33) of manoeuvre3mapimage4xi - STATE II - FROM ", key3mapmanoeuvre, " RECEIVED " , message3mapreceive4xi [key3mapmanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready3mapimage4xi</ready4xi>
           
                    if message3mapreceive4xi [key3mapmanoeuvre]  == '<ready4xi>ready3mapimage4xi</ready4xi>':
                        message3mapsend4xi [key3mapmanoeuvre]  = '<ready4xi>ready3mapimage4xi</ready4xi>'
                    else:
                        message3mapsend4xi [key3mapmanoeuvre]  = '<negative4xi>negative3map4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel3mapmanoeuvre4xi [key3mapmanoeuvre].send(message3mapsend4xi [key3mapmanoeuvre])
                    
                    message3print = "{(Step 2C/33) sent" + "; message3mapsend4xi-sent-by-manoeuvre3mapimage4xi: " + str(message3mapsend4xi [key3mapmanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre3mapimage4xi - STATE II - TO ", key3mapmanoeuvre, " SENT " , message3mapreceive4xi [key3mapmanoeuvre] )
                        #                       
                    
                    code3ack  = code3ack + '2C-'
                except:
                    message3print = "{(Step 2Z/33) failed" + "; message3mapreceive4xi-failed-by-manoeuvre3mapimage4xi: " + str(message3mapreceive4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '2Z-'
                    print("(Step 1/33) of manoeuvre3mapimage4xi - STATE II - ", key3mapmanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre3mapimage4xi - STATE II - ", key3mapmanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre3mapimage4xi: CONSIDERING STATE III : " , state3map4xi)
        # 
            
    for key3mapmanoeuvre in keys3mapmanoeuvre:
        try:   
            if state3map4xi [key3mapmanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre3mapimage4xi - STATE III - ", key3mapmanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info3image4xi [key3mapmanoeuvre]  = None
                message3print = "{(Step 3A/70) try" + "; info3image4xi-try-by-manoeuvre3mapimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info3image4xi [key3mapmanoeuvre]  = queue3mapmanoeuvre4xi [key3mapmanoeuvre].get()
                    
                    message3print = "{(Step 3B/33) got" + "; info3image4xi-got-by-manoeuvre3mapimage4xi: " + str(info3image4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre3mapimage4xi - STATE III - ", key3mapmanoeuvre, " GOT INFO3IMAGE4XI: " , info3image4xi [key3mapmanoeuvre])
                        #  
                    
                    if info3image4xi [key3mapmanoeuvre]  is None:
                        code3nack  = code3nack + '3Z1-'
                        ack3mapinfo4xi [key3mapmanoeuvre]  = False 
                    else:    
                        code3ack  = code3ack + '3C-'
                        ack3mapinfo4xi [key3mapmanoeuvre]  = True
                except:
                    message3print = "{(Step 3Z1/33) failed" + "; queue3mapmanoeuvre4xi-failed-by-manoeuvre3mapimage4xi: " + str(queue3mapmanoeuvre4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '3Z1-'
                    
                message3mapsend4xi [key3mapmanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack3mapinfo4xi [key3mapmanoeuvre]  is True:
                        message3mapsend4xi [key3mapmanoeuvre]  = '<ack4xi>ack3imageinfo4xi</ack4xi>'
                    else:
                        message3mapsend4xi [key3mapmanoeuvre]  = '<nack4xi>nack3imageinfo4xi</nack4xi>'
                    message3print = "{(Step 4B/33) set" + "; message3mapsend4xi-set-by-manoeuvre3mapimage4xi to: " + str(message3mapsend4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print) 
                    #       
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3mapsend4xi-failed-by-manoeuvre3mapimage4xi: " + str(message3mapsend4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    
                    code3nack  = code3nack + '4Z1-'    
                try:                
                    message3print = "{(Step 4C/70) using" + "; publisherchannel3mapmanoeuvre4xi-calling-by-manoeuvre3mapimage4xi: " + str(publisherchannel3mapmanoeuvre4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)    
                    # 
                    message3print = "{{(Step 4D/70) passing" + "; message3mapsend4xi-passing-to-send-by-manoeuvre3mapimage4xi: " + str(message3mapsend4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)
                    #              
                except:
                    message3print = "{(Step 4Z1/33) failed" + "; message3mapsend4xi-failed-by-manoeuvre3mapimage4xi: " + str(message3mapsend4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z2-'                
                try:    
                    publisherchannel3mapmanoeuvre4xi [key3mapmanoeuvre].send(message3mapsend4xi [key3mapmanoeuvre] )
                    
                    message3print = "{(Step 4E/33) sent" + "; message3mapsend4xi-sent-by-manoeuvre3mapimage4xi: " + str(message3mapsend4xi [key3mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)          
                    #            
                    code3ack  = code3ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre3mapimage4xi - STATE III - ", key3mapmanoeuvre, " SENT MESSAGE: " , message3mapsend4xi [key3mapmanoeuvre])
                        #    
                except:
                    message3print = "{(Step 4Z3/33) failed" + "; message3mapsend4xi-failed-by-manoeuvre3mapimage4xi: " + str(message3mapsend4xi [key3mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class3print, method3print, message3print)             
                    code3nack  = code3nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre3mapimage4xi - STATE III - ", key3mapmanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre3mapimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state3map4xi)
            # 
            
            print("(Step 5B/33) of manoeuvre3mapimage4xi - response3manouvre4map: " , response3manouvre4map)
            # 
            
            print("(Step 5C/33) of manoeuvre3mapimage4xi - ack3mapinfo4xi: " , ack3mapinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre3mapimage4xi - message3mapget4xi: ", message3mapget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre3mapimage4xi - message3mapput4xi: " , message3mapput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre3mapimage4xi - message3mapreceive4xi: " , message3mapreceive4xi)
            # 
            
            print("(Step 5G/33) of manoeuvre3mapimage4xi - message3mapsend4xi: " , message3mapsend4xi)
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre3mapimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state3map4xi)
    
    print("(Step 5B/33) of manoeuvre3mapimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state3map4xi)    
    try:        
        response3manouvre4map ['ACK2INFO4XI']        = ack3mapinfo4xi 
        response3manouvre4map ['MESSAGE2GET4XI']     = message3mapget4xi
        response3manouvre4map ['MESSAGE2PUT4XI']     = message3mapput4xi
        response3manouvre4map ['MESSAGE2RECEIVE4XI'] = message3mapreceive4xi
        response3manouvre4map ['MESSAGE2SEND4XI']    = message3mapsend4xi
        response3manouvre4map ['STATE3MANOEUVRE4XI'] = state3map4xi
    except:
        print("(Step 5Z2/33) of manoeuvre3mapimage4xi *** FAILED IN PREPARING RETURN KEY3READMANOEUVRE AT STATE: " , state3map4xi)   
                             
    message3print = "{(Step 33/33) returning" + "; response3manouvre4map-returning-by-manoeuvre3mapimage4xi: " + str(response3manouvre4map) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre3mapimage4xi - RETURNING  WITH STATE: " , state3map4xi, " RESPONSE3MANOUVRE4READ " , response3manouvre4map)
        #1 
        # 
 
        #2
        #
 
        #3 
        # 

        #4
        #
        

    return response3manouvre4map           
          
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "write3image4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: WRITE FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 28A/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH WRITE3IMAGE4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   respon4write3image      = {} 
#   task4write3image        = {}                                                                                    # WE ONLY WANT TO ESTABLISH CONTROL AND CONTROL FIRST
#   queue4write          = {} 
#   channel4write3publish = {} 
#   channel4write3consume = {} 
#   try:
#       task4write3image = {} 
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':
#               task4write3image [key3pu]  = {}
#                                               
#       response4write3image = write3image4xi(task4write3image)
#       
#       print('(Step 28B/700) OF IMAGE3D4XI5TEST - GOT RESPONSE4WRITE3IMAGE ', response4write3image)
#       # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DC0B00>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6720>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6716>}, 
#       #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DC0C18>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6752>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6748>}, 
#       #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DC05C0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6688>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6684>}}
#     except:
#       print('(Step 28Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH WRITE3IMAGE4XI ', time4xi())
#                
#   print('(Step 28C/700) OF IMAGE3D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR WRITE ', time4xi())               
#   try: 
#       queue4write          = {}
#       channel4write3publish = {} 
#       channel4write3consume = {}
#       for key3pu in keys3pu:
#           if KB3CC [key3pu] == 'ACK':   
#               queue4write [key3pu] = response4write3image [key3pu] ['QUEUE']
#               print(key3pu, ' SET QUEUE TO : ', queue4write [key3pu])
#               # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005D65A58>; 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005D65B70>; 'APU': <queue4xi.Queue4Xi object at 0x0000000005D65518>} 
#               
#               channel4write3publish [key3pu] = response4write3image [key3pu] ['PUBLISHERCHANNEL']
#               print(key3pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4write3publish [key3pu])
#               # <read-write PipeConnection, handle 6688>
#                       
#               channel4write3consume [key3pu] = response4write3image [key3pu]['CONSUMERCHANNEL']
#               print(key3pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4write3consume [key3pu])
#               # <read-write PipeConnection, handle 6684>
#                       
#   except:
#       print('(Step 28Z2/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR WRITE ', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def write3image4xi(task4imagewrite3xi=None): 

    '''
    writes 3D images for XI
    '''
    global platform3xi
    global device3xi
    global context3xi    
    global image3d4xi                                                      # 3D-IMAGES 
    global info3image4xi 
    global control3writeimage4xi                                           # COMMAND AND CONTROL FOR 3D IMAGE FOR XIS 
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "write3image4xi"
    method3print = "write3image4xi"

    message3print = "{(Step 1A/33) started" + "; write3image4xi-started: " + str(write3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                                     #  
    # 
    
    message3print = "{(Step 1B/33) passed" + "; task4imagewrite3xi-to-write3image4xi: " + str(task4imagewrite3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # 
    
    if task4imagewrite3xi is None:
        task4imagewrite3xi = {}
            
    code3ack  = ' '
    code3nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # CREATE 3D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image3d4xi is None:
            image3d4xi = create3image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message3print = "{(Step 1C/70) created" + "; image3d4xi-created-by-write3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        else:
            message3print = "{(Step 1D/70) skipped" + "; create3image4xi-skipped-by-write3image4xi: " + str(write3image4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            # skipped                                 
    except:
        try:
            image3d4xi = create3image4xi()
            message3print = "{(Step 1E/70) set" + "; image3d4xi-set-by-write3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)
            #             
        except:
            image3d4xi = {}
            message3print = "{(Step 1Z/70) yielded" + "; image3d4xi-yielded-by-write3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)  
            code3nack  = code3nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control3writeimage4xi = {}
    try:         
        keys3taskimagewrite = task4imagewrite3xi.keys()
        if debug is True:
            print('(Step 1/33) of write3image4xi - keys3taskimagewrite:  ', keys3taskimagewrite) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
            
        if 'APU' in keys3taskimagewrite:
            try:
                control3writeimage4xi['APU'] = write3image4apu(task4imagewrite3xi['APU'])
                message3print = "{(Step 1CA/33) got" + "; apuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1A/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['APU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005CE9048>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6552>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6548>}

            except:
                pass     
        if 'BPU' in keys3taskimagewrite:
            try:
                control3writeimage4xi['BPU'] = write3image4bpu(task4imagewrite3xi['BPU'])
                message3print = "{(Step 1CB/33) got" + "; bpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1B/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['APU']) 
                    # 
            except:
                pass     
            
        if 'CPU' in keys3taskimagewrite:
            try:
                control3writeimage4xi['CPU'] = write3image4cpu(task4imagewrite3xi['CPU'])
                message3print = "{(Step 1CC/33) got" + "; cpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1C/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['CPU']) 
                    # 
            except:
                pass     
            
        if 'DPU' in keys3taskimagewrite:
            try:
                control3writeimage4xi['DPU'] = write3image4dpu(task4imagewrite3xi['DPU'])
                message3print = "{(Step 1CD/33) got" + "; dpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1D/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['DPU']) 
                    #       
            except:
                pass               
        if 'EPU' in keys3taskimagewrite:
            try:
                control3writeimage4xi['EPU'] = write3image4epu(task4imagewrite3xi['EPU'])
                message3print = "{(Step 1CE/33) got" + "; epuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1E/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['EPU']) 
                    #       
            except:
                pass               
        if 'FPU' in keys3taskimagewrite:
            try:
                control3writeimage4xi['FPU'] = write3image4fpu(task4imagewrite3xi['FPU'])
                message3print = "{(Step 1CF/33) got" + "; fpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1F/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['FPU']) 
                    #       
            except:
                pass               
        if 'GPU' in keys3taskimagewrite:
            try:
                control3writeimage4xi['GPU'] = write3image4gpu(task4imagewrite3xi['GPU'])
                message3print = "{(Step 1CG/33) got" + "; gpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1G/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['GPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF7DD8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6584>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6580>}
      
            except:
                pass               
        if 'HPU' in keys3taskimagewrite:
            try:
                control3writeimage4xi['HPU'] = write3image4hpu(task4imagewrite3xi['HPU'])
                message3print = "{(Step 1CH/33) got" + "; hpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1H/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['HPU']) 
                    #              
            except:
                pass
        if 'IPU' in keys3taskimagewrite:    
            try:
                control3writeimage4xi['IPU'] = write3image4ipu(task4imagewrite3xi['IPU'])
                message3print = "{(Step 1CI/33) got" + "; ipuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1I/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['IPU']) 
                    # 
            except:
                pass
        if 'JPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['JPU'] = write3image4jpu(task4imagewrite3xi['JPU'])
                message3print = "{(Step 1CJ/33) got" + "; jpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1J/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['JPU']) 
                    # 
            except:
                pass
        if 'KPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['KPU'] = write3image4kpu(task4imagewrite3xi['KPU'])
                message3print = "{(Step 1CK/33) got" + "; kpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1K/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['KPU']) 
                    # 
            except:
                pass
        if 'LPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['LPU'] = write3image4lpu(task4imagewrite3xi['LPU'])
                message3print = "{(Step 1CL/33) got" + "; lpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1L/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['LPU']) 
                    # 
            except:
                pass
        if 'MPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['MPU'] = write3image4mpu(task4imagewrite3xi['MPU'])
                message3print = "{(Step 1CM/33) got" + "; mpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1M/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['MPU']) 
                    # 
            except:
                pass
        if 'NPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['NPU'] = write3image4npu(task4imagewrite3xi['NPU'])
                message3print = "{(Step 1CN/33) got" + "; npuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'OPU' in keys3taskimagewrite:                    
            try:
                control3writeimage4xi['OPU'] = write3image4opu(task4imagewrite3xi['OPU'])
                message3print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1N/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['NPU']) 
                    # 
            except:
                pass
        if 'PPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['PPU'] = write3image4ppu(task4imagewrite3xi['PPU'])
                message3print = "{(Step 1CP/33) got" + "; ppuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'QPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['QPU'] = write3image4qpu(task4imagewrite3xi['QPU'])
                message3print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1P/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['PPU']) 
                    # 
            except:
                pass
        if 'RPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['RPU'] = write3image4rpu(task4imagewrite3xi['RPU'])
                message3print = "{(Step 1CR/33) got" + "; rpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1R/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['RPU']) 
                    # 
            except:
                pass
        if 'SPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['SPU'] = write3image4spu(task4imagewrite3xi['SPU'])
                message3print = "{(Step 1CS/33) got" + "; spuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1S/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['SPU']) 
                    # 
            except:
                pass
        if 'TPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['TPU'] = write3image4tpu(task4imagewrite3xi['TPU'])
                message3print = "{(Step 1CT/33) got" + "; tpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1T/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['TPU']) 
                    # 
            except:
                pass
        if 'UPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['UPU'] = write3image4upu(task4imagewrite3xi['UPU'])
                message3print = "{(Step 1CU/33) got" + "; upuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1U/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['UPU']) 
                    # 
            except:
                pass
        if 'VPU' in keys3taskimagewrite:                    
            try:
                control3writeimage4xi['VPU'] = write3image4vpu(task4imagewrite3xi['VPU'])
                message3print = "{(Step 1CV/33) got" + "; vpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1V/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['VPU']) 
                    # 
            except:
                pass
        if 'WPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['WPU'] = write3image4wpu(task4imagewrite3xi['WPU'])
                message3print = "{(Step 1CW/33) got" + "; wpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1W/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['WPU']) 
                    # 
            except:
                pass
        if 'XPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['XPU'] = write3image4xpu(task4imagewrite3xi['XPU'])
                message3print = "{(Step 1CX/33) got" + "; xpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1X/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['XPU']) 
                    # 
            except:
                pass
        if 'YPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['YPU'] = write3image4ypu(task4imagewrite3xi['YPU'])
                message3print = "{(Step 1CY/33) got" + "; ypuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1Y/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['YPU']) 
                    # 
            except:
                pass
        if 'ZPU' in keys3taskimagewrite:                     
            try:
                control3writeimage4xi['ZPU'] = write3image4zpu(task4imagewrite3xi['ZPU'])
                message3print = "{(Step 1CZ/33) got" + "; zpuimage-control-got-by-get3imageinfo: " + str(control3writeimage4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1Z/33) of write3image4xi - control3writeimage4xi:  ', control3writeimage4xi['ZPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF7C88>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6616>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6612>}

            except:
                pass
               
    except:
        message3print = "{(Step 1Z/70) yielded" + "; control3writeimage4xi-yielded-by-write3image4xi: " + str(control3writeimage4xi) + "; time: " + time4xi() + "}"                
        print4xi(class3print, method3print, message3print)  
        code3nack  = code3nack + '1Z-'     
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    message3print = "{(Step 70A/70) set" + "; code3ack-set-by-write3image4xi: " + str(code3ack) + "; time: " + time4xi() + "}"  
    print4xi(class3print, method3print, message3print)                                                             
    # 
     
    message3print = "{(Step 70B/70) set" + "; code3nack-set-by-write3image4xi: " + str(code3nack) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             
    #   
        
    message3print = "{(Step 70C/70) returning" + "; control3writeimage4xi-returning-by-write3image4xi: " + str(control3writeimage4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                             
    # 
    
    if debug is True:
        print("(Step 33/33) of manoeuvre3writeimage4xi - RETURNING CONTROL3WRITEIMAGE4XI " , control3writeimage4xi)
        # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005CB3CC0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6580>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6576>}, 
        #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005CB3B70>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6612>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6608>}, 
        #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005CB3908>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6548>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6544>}}

        
    return control3writeimage4xi
                    

                    
#</function4xi> 


 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "release3image4xi" usage = "
#
#   task4release3image  = {}
#   task4release3image ['APU']  = {}
#   task4release3image ['APU'] ['COUNT2REFERENCE'] = 1
#   task4release3image ['ZPU']  = {}
#   task4release3image ['ZPU'] ['COUNT2REFERENCE'] = 1     
#   response4release3image = {}    
#      
#   print('(Step 11A/700) OF IMAGE3D4XI5TEST - TRYING TO RELEASE 3D IMAGE OF XI DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4release3Dimage = release3image4xi(task4release3image)                                                                                             
#       print('(Step 11B/700) OF IMAGE3D4XI5TEST - RELEASED 3D IMAGE OF XI DEVICE ', time4xi())                           
#       keys3response = response4release3Dimage.keys()
#       for key3response in sorted(keys3response):
#           print(key3response, ' : ', response4release3Dimage[key3response])
#           # APU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
#           # BPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE':
#           # ...
#           # ZPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...            
#   except:
#       print('(Step 11Z/700) OF IMAGE3D4XI5TEST *** FAILED TO RELEASE IMAGE OF XI DEVICE ', time4xi())
#                 
#">

# -------------------------------------------------------------------------------------------------   
def release3image4xi(task4release3xi=None):

    '''
    releases image3d4xi
    '''
    global image3d4xi 
    global info3image4xi 

    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "release3image4xi"
    method3print = "release3image4xi" 

    message3print = "{(Step 1A/33) started" + "; release3image4xi-started: " + str(release3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                                     #  
    # <function release3image4xi at 0x0000000003A9E8C8>
    
    message3print = "{(Step 1B/33) passed" + "; task4release3xi-to-release3image4xi: " + str(task4release3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    # {'COUNT2REFERENCE': 1} 

    if task4release3xi is None:
        task4release3xi = {}
             
    code3ack  = ' '
    code3nack = ' '

    if image3d4xi is None:
        image3d4xi = create3image3d4xi()                                                                            
                                
        message3print = "{(Step 1C/33) release" + "; image3d4xi-release-by-release3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        code3ack  = code3ack + '1C-'
    else:
        pass    
        
    keys3release = task4release3xi.keys()

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'APU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step A/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step A1/33) passing" + "; task-passing-to-release3image4apu: " + str(task4release3image['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            
            image3d4xi ['APU'] = release3image4apu(task4release3image['APU'])                                                      # 
             
            message3print = "{(Step A2/33) release" + "; apu-image-release-by-release3image4apu to: " + str(image3d4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            
         
            code3ack  = code3ack + 'A2-'
        else:
            pass    
    except:
        message3print = "{(Step AZ/33) yielded" + "; apu-yielded-by-release3image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'AZ-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'BPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step B/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step B1/33) passing" + "; task-passing-to-release3image4bpu: " + str(task4release3image['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['BPU'] = release3image4bpu(task4release3image['BPU'])                                                      # 
         
            message3print = "{(Step B2/33) release" + "; bpu-image-release-by-release3image4bpu to: " + str(image3d4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'B2-'
        else:
            pass    
    except:
        message3print = "{(Step BZ/33) yielded" + "; bpu-yielded-by-release3image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'BZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'CPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step C/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step C1/33) passing" + "; task-passing-to-release3image4cpu: " + str(task4release3image['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['CPU'] = release3image4cpu(task4release3image['CPU'])                                                      # 
         
            message3print = "{(Step C2/33) release" + "; cpu-image-release-by-release3image4cpu to: " + str(image3d4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'C2-'
        else:
            pass    
    except:
        message3print = "{(Step CZ/33) yielded" + "; cpu-yielded-by-release3image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'CZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'DPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step D/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step D1/33) passing" + "; task-passing-to-release3image4dpu: " + str(task4release3image['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['DPU'] = release3image4dpu(task4release3image['DPU'])                                                      # 
         
            message3print = "{(Step D2/33) release" + "; dpu-image-release-by-release3image4dpu to: " + str(image3d4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'D2-'
        else:
            pass    
    except:
        message3print = "{(Step DZ/33) yielded" + "; dpu-yielded-by-release3image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'DZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'EPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step E/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step E1/33) passing" + "; task-passing-to-release3image4epu: " + str(task4release3image['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['EPU'] = release3image4epu(task4release3image['EPU'])                                                      # 
         
            message3print = "{(Step E2/33) release" + "; epu-image-release-by-release3image4epu to: " + str(image3d4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'E2-'
        else:
            pass    
    except:
        message3print = "{(Step EZ/33) yielded" + "; epu-yielded-by-release3image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'EZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'FPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step F/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step F1/33) passing" + "; task-passing-to-release3image4fpu: " + str(task4release3image['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['FPU'] = release3image4fpu(task4release3image['FPU'])                                                      # 
         
            message3print = "{(Step F2/33) release" + "; fpu-image-release-by-release3image4fpu to: " + str(image3d4xi ['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'F2-'
        else:
            pass    
    except:
        message3print = "{(Step FZ/33) yielded" + "; fpu-yielded-by-release3image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'FZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'GPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step G/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step G1/33) passing" + "; task-passing-to-release3image4gpu: " + str(task4release3image['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['GPU'] = release3image4gpu(task4release3image['GPU'])                                                      # 
         
            message3print = "{(Step G2/33) release" + "; gpu-image-release-by-release3image4gpu to: " + str(image3d4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'G2-'
        else:
            pass    
    except:
        message3print = "{(Step GZ/33) yielded" + "; gpu-yielded-by-release3image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'GZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'HPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step H/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step H1/33) passing" + "; task-passing-to-release3image4hpu: " + str(task4release3image['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['HPU'] = release3image4hpu(task4release3image['HPU'])                                                      # 
         
            message3print = "{(Step H2/33) release" + "; hpu-image-release-by-release3image4hpu to: " + str(image3d4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'H2-'
        else:
            pass    
    except:
        message3print = "{(Step HZ/33) yielded" + "; hpu-yielded-by-release3image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'HZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'IPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step I/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step I1/33) passing" + "; task-passing-to-release3image4ipu: " + str(task4release3image['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['IPU'] = release3image4ipu(task4release3image['IPU'])                                                      # 
         
            message3print = "{(Step I2/33) release" + "; ipu-image-release-by-release3image4ipu to: " + str(image3d4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'I2-'
        else:
            pass    
    except:
        message3print = "{(Step IZ/33) yielded" + "; ipu-yielded-by-release3image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'IZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'JPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step J/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step J1/33) passing" + "; task-passing-to-release3image4jpu: " + str(task4release3image['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['JPU'] = release3image4jpu(task4release3image['JPU'])                                                      # 
         
            message3print = "{(Step J2/33) release" + "; jpu-image-release-by-release3image4jpu to: " + str(image3d4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'J2-'
        else:
            pass    
    except:
        message3print = "{(Step JZ/33) yielded" + "; jpu-yielded-by-release3image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'JZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'KPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step K/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step K1/33) passing" + "; task-passing-to-release3image4kpu: " + str(task4release3image['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['KPU'] = release3image4kpu(task4release3image['KPU'])                                                      # 
         
            message3print = "{(Step K2/33) release" + "; kpu-image-release-by-release3image4kpu to: " + str(image3d4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'K2-'
        else:
            pass    
    except:
        message3print = "{(Step KZ/33) yielded" + "; kpu-yielded-by-release3image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'KZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'LPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step L/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step L1/33) passing" + "; task-passing-to-release3image4lpu: " + str(task4release3image['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['LPU'] = release3image4lpu(task4release3image['LPU'])                                                      # 
         
            message3print = "{(Step L2/33) release" + "; lpu-image-release-by-release3image4lpu to: " + str(image3d4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'L2-'
        else:
            pass    
    except:
        message3print = "{(Step LZ/33) yielded" + "; lpu-yielded-by-release3image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'LZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'MPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step M/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step M1/33) passing" + "; task-passing-to-release3image4mpu: " + str(task4release3image['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['MPU'] = release3image4mpu(task4release3image['MPU'])                                                      # 
         
            message3print = "{(Step M2/33) release" + "; mpu-image-release-by-release3image4mpu to: " + str(image3d4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'M2-'
        else:
            pass    
    except:
        message3print = "{(Step MZ/33) yielded" + "; mpu-yielded-by-release3image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'MZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'NPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step N/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step N1/33) passing" + "; task-passing-to-release3image4npu: " + str(task4release3image['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['NPU'] = release3image4npu(task4release3image['NPU'])                                                      # 
         
            message3print = "{(Step N2/33) release" + "; npu-image-release-by-release3image4npu to: " + str(image3d4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'N2-'
        else:
            pass    
    except:
        message3print = "{(Step NZ/33) yielded" + "; npu-yielded-by-release3image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'NZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'OPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step O/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step O1/33) passing" + "; task-passing-to-release3image4opu: " + str(task4release3image['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['OPU'] = release3image4opu(task4release3image['OPU'])                                                      # 
         
            message3print = "{(Step O2/33) release" + "; opu-image-release-by-release3image4opu to: " + str(image3d4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'O2-'
        else:
            pass    
    except:
        message3print = "{(Step OZ/33) yielded" + "; opu-yielded-by-release3image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'OZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'PPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step P/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step P1/33) passing" + "; task-passing-to-release3image4ppu: " + str(task4release3image['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['PPU'] = release3image4ppu(task4release3image['PPU'])                                                      # 
         
            message3print = "{(Step P2/33) release" + "; ppu-image-release-by-release3image4ppu to: " + str(image3d4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'P2-'
        else:
            pass    
    except:
        message3print = "{(Step PZ/33) yielded" + "; ppu-yielded-by-release3image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'PZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'QPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step Q/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step Q1/33) passing" + "; task-passing-to-release3image4qpu: " + str(task4release3image['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['QPU'] = release3image4qpu(task4release3image['QPU'])                                                      # 
         
            message3print = "{(Step Q2/33) release" + "; qpu-image-release-by-release3image4qpu to: " + str(image3d4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'Q2-'
        else:
            pass    
    except:
        message3print = "{(Step QZ/33) yielded" + "; qpu-yielded-by-release3image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'QZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'RPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step R/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step R1/33) passing" + "; task-passing-to-release3image4rpu: " + str(task4release3image['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['RPU'] = release3image4rpu(task4release3image['RPU'])                                                      # 
         
            message3print = "{(Step R2/33) release" + "; rpu-image-release-by-release3image4rpu to: " + str(image3d4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'R2-'
        else:
            pass    
    except:
        message3print = "{(Step RZ/33) yielded" + "; rpu-yielded-by-release3image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'RZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'SPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step S/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step S1/33) passing" + "; task-passing-to-release3image4spu: " + str(task4release3image['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['SPU'] = release3image4spu(task4release3image['SPU'])                                                      # 
         
            message3print = "{(Step S2/33) release" + "; spu-image-release-by-release3image4spu to: " + str(image3d4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'S2-'
        else:
            pass    
    except:
        message3print = "{(Step SZ/33) yielded" + "; spu-yielded-by-release3image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'SZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'TPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step T/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step T1/33) passing" + "; task-passing-to-release3image4tpu: " + str(task4release3image['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['TPU'] = release3image4tpu(task4release3image['TPU'])                                                      # 
         
            message3print = "{(Step T2/33) release" + "; tpu-image-release-by-release3image4tpu to: " + str(image3d4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'T2-'
        else:
            pass    
    except:
        message3print = "{(Step TZ/33) yielded" + "; tpu-yielded-by-release3image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'TZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'UPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step U/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step U1/33) passing" + "; task-passing-to-release3image4upu: " + str(task4release3image['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['UPU'] = release3image4upu(task4release3image['UPU'])                                                      # 
         
            message3print = "{(Step U2/33) release" + "; upu-image-release-by-release3image4upu to: " + str(image3d4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'U2-'
        else:
            pass    
    except:
        message3print = "{(Step UZ/33) yielded" + "; upu-yielded-by-release3image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'UZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'VPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step V/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step V1/33) passing" + "; task-passing-to-release3image4vpu: " + str(task4release3image['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['VPU'] = release3image4vpu(task4release3image['VPU'])                                                      # 
         
            message3print = "{(Step V2/33) release" + "; vpu-image-release-by-release3image4vpu to: " + str(image3d4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'V2-'
        else:
            pass    
    except:
        message3print = "{(Step VZ/33) yielded" + "; vpu-yielded-by-release3image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'VZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'WPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step W/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step W1/33) passing" + "; task-passing-to-release3image4wpu: " + str(task4release3image['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['WPU'] = release3image4wpu(task4release3image['WPU'])                                                      # 
         
            message3print = "{(Step W2/33) release" + "; wpu-image-release-by-release3image4wpu to: " + str(image3d4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'W2-'
        else:
            pass    
    except:
        message3print = "{(Step WZ/33) yielded" + "; wpu-yielded-by-release3image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'WZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'XPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step X/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step X1/33) passing" + "; task-passing-to-release3image4xpu: " + str(task4release3image['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['XPU'] = release3image4xpu(task4release3image['XPU'])                                                      # 
         
            message3print = "{(Step X2/33) release" + "; xpu-image-release-by-release3image4xpu to: " + str(image3d4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'X2-'
        else:
            pass    
    except:
        message3print = "{(Step XZ/33) yielded" + "; xpu-yielded-by-release3image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'XZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'YPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step Y/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step Y1/33) passing" + "; task-passing-to-release3image4ypu: " + str(task4release3image['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['YPU'] = release3image4ypu(task4release3image['YPU'])                                                      # 
         
            message3print = "{(Step Y2/33) release" + "; ypu-image-release-by-release3image4ypu to: " + str(image3d4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'Y2-'
        else:
            pass    
    except:
        message3print = "{(Step YZ/33) yielded" + "; ypu-yielded-by-release3image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'YZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'ZPU' in keys3release:
            # -----------------------------------------------------------------------------
            # (Step Z/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step Z1/33) passing" + "; task-passing-to-release3image4zpu: " + str(task4release3image['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['ZPU'] = release3image4zpu(task4release3image['ZPU'])                                                      # 
         
            message3print = "{(Step Z2/33) release" + "; zpu-image-release-by-release3image4zpu to: " + str(image3d4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'Z2-'
        else:
            pass    
    except:
        message3print = "{(Step ZZ/33) yielded" + "; zpu-yielded-by-release3image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'ZZ-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message3print = "{(Step 33/33) returning" + "; image3d4xi-returning-by-release3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)
    # 
    if debug is True:
        print('(Step 33/33) of release3image4xi - RETURNING IMAGE3D4XI:  ', image3d4xi) 
        
    return image3d4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain3image4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------
#   # (13) REFERENCE COUNT FOR TWO PROCESSING UNITS RETAINED BY INCREMENTING COUNT WITH 1             
#   # ---------------------------------------------------------------------------------------------    
#   task4retain3image  = {}
#   task4retain3image ['APU']  = {}
#   task4retain3image ['APU'] ['DIMENSION'] = 3 
#   task4retain3image ['APU'] ['COUNT2REFERENCE'] = 1
#   task4retain3image ['ZPU']  = {}
#   task4retain3image ['ZPU'] ['DIMENSION'] = 3 
#   task4retain3image ['ZPU'] ['COUNT2REFERENCE'] = 1    
#    
#   response4retain3Dimage = {}
#   print('(Step 13A/700) OF IMAGE3D4XI5TEST - TRYING TO RETAIN 3D IMAGE OF XI DEVICE ', time4xi())   
#   try:                               
#       response4retain3Dimage = retain3image4xi(task4retain3image)                                                                                                 
#       print('(Step 13B/700) OF IMAGE3D4XI5TEST - RESPONSE4RETAIN3DIMAGE : ', time4xi())                         
#       keys3response = response4retain3Dimage.keys()
#       for key3response in sorted(keys3response):
#           print(key3response, ' : ', len(response4retain3Dimage[key3response]))
#           # APU  :  20
#           # ...
#           # XPU  :  20 <-- length is the same in all processing units
#           # YPU  :  20
#           # ZPU  :  20
#                  
#   except:
#       print('(Step 13Z/700) OF IMAGE3D4XI5TEST *** FAILED TO RETAIN 3D IMAGE OF XI DEVICE ', time4xi())   
#
#">

# -------------------------------------------------------------------------------------------------   
def retain3image4xi(task4retain3xi=None):

    '''
    retains either image3d4xi
    '''
    global image3d4xi 
    global info3image4xi

    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "retain3image4xi"
    method3print = "retain3image4xi"

    message3print = "{(Step 1A/33) started" + "; retain3image4xi-started: " + str(retain3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                                     #  
    # <function retain3image4xi at 0x0000000003A9E948>   
    
    message3print = "{(Step 1B/33) passed" + "; task4retain3xi-to-retain3image4xi: " + str(task4retain3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              
    #
    if task4retain3xi is None:
        task4retain3xi = {}
        
    keys3retain = task4retain3xi    
    
    code3ack  = ' '
    code3nack = ' '
    
    if image3d4xi is None:
        image3d4xi = create3image3d4xi()                                                                            
                                
        message3print = "{(Step 1C/33) retain" + "; image3d4xi-retain-by-retain3image4xi to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        code3ack  = code3ack + '1C-'
    else:
        pass    

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'APU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step A/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step A1/33) passing" + "; task-passing-to-retain3image4apu: " + str(task4retain3image['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['APU'] = retain3image4apu(task4retain3image['APU'])                                                      # 
         
            message3print = "{(Step A2/33) retain" + "; apu-image-retain-by-retain3image4apu to: " + str(image3d4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'AZ-'
        else:
            pass    
    except:
        message3print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-retain3image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'BPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step B/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step B1/33) passing" + "; task-passing-to-retain3image4bpu: " + str(task4retain3image['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['BPU'] = retain3image4bpu(task4retain3image['BPU'])                                                      # 
         
            message3print = "{(Step B2/33) retain" + "; bpu-image-retain-by-retain3image4bpu to: " + str(image3d4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'BZ-'
        else:
            pass    
    except:
        message3print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-retain3image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'CPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step C/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step C1/33) passing" + "; task-passing-to-retain3image4cpu: " + str(task4retain3image['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['CPU'] = retain3image4cpu(task4retain3image['CPU'])                                                      # 
         
            message3print = "{(Step C2/33) retain" + "; cpu-image-retain-by-retain3image4cpu to: " + str(image3d4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'CZ-'
        else:
            pass    
    except:
        message3print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-retain3image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'DPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step D/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step D1/33) passing" + "; task-passing-to-retain3image4dpu: " + str(task4retain3image['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['DPU'] = retain3image4dpu(task4retain3image['DPU'])                                                      # 
         
            message3print = "{(Step D2/33) retain" + "; dpu-image-retain-by-retain3image4dpu to: " + str(image3d4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'DZ-'
        else:
            pass    
    except:
        message3print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-retain3image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'EPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step E/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step E1/33) passing" + "; task-passing-to-retain3image4epu: " + str(task4retain3image['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['EPU'] = retain3image4epu(task4retain3image['EPU'])                                                      # 
         
            message3print = "{(Step E2/33) retain" + "; epu-image-retain-by-retain3image4epu to: " + str(image3d4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'EZ-'
        else:
            pass    
    except:
        message3print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-retain3image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'FPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step F/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step F1/33) passing" + "; task-passing-to-retain3image4fpu: " + str(task4retain3image['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['FPU'] = retain3image4fpu(task4retain3image['FPU'])                                                      # 
         
            message3print = "{(Step F2/33) retain" + "; fpu-image-retain-by-retain3image4fpu to: " + str(image3d4xi ['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'FZ-'
        else:
            pass    
    except:
        message3print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-retain3image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'GPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step G/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step G1/33) passing" + "; task-passing-to-retain3image4gpu: " + str(task4retain3image['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['GPU'] = retain3image4gpu(task4retain3image['GPU'])                                                      # 
         
            message3print = "{(Step G2/33) retain" + "; gpu-image-retain-by-retain3image4gpu to: " + str(image3d4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'GZ-'
        else:
            pass    
    except:
        message3print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-retain3image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'HPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step H/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step H1/33) passing" + "; task-passing-to-retain3image4hpu: " + str(task4retain3image['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['HPU'] = retain3image4hpu(task4retain3image['HPU'])                                                      # 
         
            message3print = "{(Step H2/33) retain" + "; hpu-image-retain-by-retain3image4hpu to: " + str(image3d4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'HZ-'
        else:
            pass    
    except:
        message3print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-retain3image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'IPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step I/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step I1/33) passing" + "; task-passing-to-retain3image4ipu: " + str(task4retain3image['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['IPU'] = retain3image4ipu(task4retain3image['IPU'])                                                      # 
         
            message3print = "{(Step I2/33) retain" + "; ipu-image-retain-by-retain3image4ipu to: " + str(image3d4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'IZ-'
        else:
            pass    
    except:
        message3print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-retain3image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'JPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step J/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step J1/33) passing" + "; task-passing-to-retain3image4jpu: " + str(task4retain3image['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['JPU'] = retain3image4jpu(task4retain3image['JPU'])                                                      # 
         
            message3print = "{(Step J2/33) retain" + "; jpu-image-retain-by-retain3image4jpu to: " + str(image3d4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'JZ-'
        else:
            pass    
    except:
        message3print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-retain3image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'KPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step K/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step K1/33) passing" + "; task-passing-to-retain3image4kpu: " + str(task4retain3image['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['KPU'] = retain3image4kpu(task4retain3image['KPU'])                                                      # 
         
            message3print = "{(Step K2/33) retain" + "; kpu-image-retain-by-retain3image4kpu to: " + str(image3d4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'KZ-'
        else:
            pass    
    except:
        message3print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-retain3image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'LPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step L/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step L1/33) passing" + "; task-passing-to-retain3image4lpu: " + str(task4retain3image['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['LPU'] = retain3image4lpu(task4retain3image['LPU'])                                                      # 
         
            message3print = "{(Step L2/33) retain" + "; lpu-image-retain-by-retain3image4lpu to: " + str(image3d4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'LZ-'
        else:
            pass    
    except:
        message3print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-retain3image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'MPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step M/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step M1/33) passing" + "; task-passing-to-retain3image4mpu: " + str(task4retain3image['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['MPU'] = retain3image4mpu(task4retain3image['MPU'])                                                      # 
         
            message3print = "{(Step M2/33) retain" + "; mpu-image-retain-by-retain3image4mpu to: " + str(image3d4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'MZ-'
        else:
            pass    
    except:
        message3print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-retain3image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'NPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step N/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step N1/33) passing" + "; task-passing-to-retain3image4npu: " + str(task4retain3image['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['NPU'] = retain3image4npu(task4retain3image['NPU'])                                                      # 
         
            message3print = "{(Step N2/33) retain" + "; npu-image-retain-by-retain3image4npu to: " + str(image3d4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'NZ-'
        else:
            pass    
    except:
        message3print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-retain3image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'OPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step O/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step O1/33) passing" + "; task-passing-to-retain3image4opu: " + str(task4retain3image['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['OPU'] = retain3image4opu(task4retain3image['OPU'])                                                      # 
         
            message3print = "{(Step O2/33) retain" + "; opu-image-retain-by-retain3image4opu to: " + str(image3d4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'OZ-'
        else:
            pass    
    except:
        message3print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-retain3image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'PPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step P/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step P1/33) passing" + "; task-passing-to-retain3image4ppu: " + str(task4retain3image['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['PPU'] = retain3image4ppu(task4retain3image['PPU'])                                                      # 
         
            message3print = "{(Step P2/33) retain" + "; ppu-image-retain-by-retain3image4ppu to: " + str(image3d4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'PZ-'
        else:
            pass    
    except:
        message3print = "{(Step PZ1/33) yielded" + "; pu-yielded-by-retain3image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'QPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step Q/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step Q1/33) passing" + "; task-passing-to-retain3image4qpu: " + str(task4retain3image['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['QPU'] = retain3image4qpu(task4retain3image['QPU'])                                                      # 
         
            message3print = "{(Step Q2/33) retain" + "; qpu-image-retain-by-retain3image4qpu to: " + str(image3d4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'QZ-'
        else:
            pass    
    except:
        message3print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-retain3image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'RPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step R/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step R1/33) passing" + "; task-passing-to-retain3image4rpu: " + str(task4retain3image['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['RPU'] = retain3image4rpu(task4retain3image['RPU'])                                                      # 
         
            message3print = "{(Step R2/33) retain" + "; rpu-image-retain-by-retain3image4rpu to: " + str(image3d4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'RZ-'
        else:
            pass    
    except:
        message3print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-retain3image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'SPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step S/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step S1/33) passing" + "; task-passing-to-retain3image4spu: " + str(task4retain3image['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['SPU'] = retain3image4spu(task4retain3image['SPU'])                                                      # 
         
            message3print = "{(Step S2/33) retain" + "; spu-image-retain-by-retain3image4spu to: " + str(image3d4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'SZ-'
        else:
            pass    
    except:
        message3print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-retain3image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'TPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step T/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step T1/33) passing" + "; task-passing-to-retain3image4tpu: " + str(task4retain3image['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['TPU'] = retain3image4tpu(task4retain3image['TPU'])                                                      # 
         
            message3print = "{(Step T2/33) retain" + "; tpu-image-retain-by-retain3image4tpu to: " + str(image3d4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'TZ-'
        else:
            pass    
    except:
        message3print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-retain3image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'UPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step U/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step U1/33) passing" + "; task-passing-to-retain3image4upu: " + str(task4retain3image['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['UPU'] = retain3image4upu(task4retain3image['UPU'])                                                      # 
         
            message3print = "{(Step U2/33) retain" + "; upu-image-retain-by-retain3image4upu to: " + str(image3d4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'UZ-'
        else:
            pass    
    except:
        message3print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-retain3image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'VPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step V/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step V1/33) passing" + "; task-passing-to-retain3image4vpu: " + str(task4retain3image['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['VPU'] = retain3image4vpu(task4retain3image['VPU'])                                                      # 
         
            message3print = "{(Step V2/33) retain" + "; vpu-image-retain-by-retain3image4vpu to: " + str(image3d4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'VZ-'
        else:
            pass    
    except:
        message3print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-retain3image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'WPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step W/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step W1/33) passing" + "; task-passing-to-retain3image4wpu: " + str(task4retain3image['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['WPU'] = retain3image4wpu(task4retain3image['WPU'])                                                      # 
         
            message3print = "{(Step W2/33) retain" + "; wpu-image-retain-by-retain3image4wpu to: " + str(image3d4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'WZ-'
        else:
            pass    
    except:
        message3print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-retain3image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'XPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step X/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step X1/33) passing" + "; task-passing-to-retain3image4xpu: " + str(task4retain3image['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['XPU'] = retain3image4xpu(task4retain3image['XPU'])                                                      # 
         
            message3print = "{(Step X2/33) retain" + "; xpu-image-retain-by-retain3image4xpu to: " + str(image3d4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'XZ-'
        else:
            pass    
    except:
        message3print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-retain3image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'YPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step Y/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step Y1/33) passing" + "; task-passing-to-retain3image4ypu: " + str(task4retain3image['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['YPU'] = retain3image4ypu(task4retain3image['YPU'])                                                      # 
         
            message3print = "{(Step Y2/33) retain" + "; ypu-image-retain-by-retain3image4ypu to: " + str(image3d4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'YZ-'
        else:
            pass    
    except:
        message3print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-retain3image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'ZPU' in keys3retain:
            # -----------------------------------------------------------------------------
            # (Step Z/33) 
            # ----------------------------------------------------------------------------- 
            message3print = "{(Step Z1/33) passing" + "; task-passing-to-retain3image4zpu: " + str(task4retain3image['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
        
            image3d4xi ['ZPU'] = retain3image4zpu(task4retain3image['ZPU'])                                                      # 
         
            message3print = "{(Step Z2/33) retain" + "; zpu-image-retain-by-retain3image4zpu to: " + str(image3d4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
     
            code3ack  = code3ack + 'ZZ-'
        else:
            pass    
    except:
        message3print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-retain3image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message3print = "{(Step 33/33) returning" + "; image3d4xi-returning-by-retain3image4xi: " + str(image3d4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)
    # 
    if debug is True:
        print('(Step 33/33) of retain3image4xi - RETURNING IMAGE3D4XI:  ', image3d4xi) 
    
    return image3d4xi
    
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get3imageinfo4xi" usage = "
#
#   print('(Step 14C/700) OF IMAGE3D4XI5TEST - TRYING TO VERIFY XI KNOWLEDGEBASE ', time4xi())  
#   try:                               
#       task4getinfo3image = {}
#       task4getinfo3image ['APU'] = {}
#       task4getinfo3image ['APU'] ['CALLBACK'] = 0
#       task4getinfo3image ['GPU'] = {}
#       task4getinfo3image ['GPU'] ['CALLBACK'] = 0
#       task4getinfo3image ['XPU'] = {}
#       task4getinfo3image ['XPU'] ['CALLBACK'] = 0          
#       task4getinfo3image ['ZPU'] = {}
#       task4getinfo3image ['ZPU'] ['CALLBACK'] = 0    
#                          
#       response4getinfo3Dimage = get3imageinfo4xi (task4getinfo3image)                                                                                             
#       keys3response = response4getinfo3Dimage.keys()
#       for key3response in sorted(keys3response):
#           print(key3response, ' : ', response4getinfo3Dimage[key3response])
#           # APU  :  {'CALLBACK': <function trace3image4apu at 0x0000000004484C48>}
#           # GPU  :  {'CALLBACK': <function trace3image4gpu at 0x00000000049F1D48>}
#           # XPU  :  {'CALLBACK': <function trace3image4xpu at 0x0000000005693948>}
#           # ZPU  :  {'CALLBACK': <function trace3image4zpu at 0x00000000059090C8>}
#   except:
#       print('(Step 14Z3/700) OF IMAGE3D4XI5TEST *** FAILED TO VERIFY XI KNOWLEDGEBASE ', time4xi()) 
#            
#">

# -------------------------------------------------------------------------------------------------   
def get3imageinfo4xi(task4supportedimageformats3xi=None):

    '''
    gets image3d4xi
    '''
    
    global image3d4xi
    global info3image4xi
    
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "get3imageinfo4xi"
    method3print = "get3imageinfo4xi"

    message3print = "{(Step 0A/33) started" + "; get3imageinfo4xi-started: " + str(get3imageinfo4xi)  + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)
    # <function get3imageinfo4xi at 0x0000000003A9E9C8>                                                              
    
    message3print = "{(Step 0A/33) passed" + "; task4supportedimageformats3xi-passed-to-get3imageinfo4xi: " + str(task4supportedimageformats3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)   
    # 
    
    if task4supportedimageformats3xi is None:
        task4supportedimageformats3xi = {}
        
    keys3supportedimageformats = task4supportedimageformats3xi.keys()
    if debug is True:
        print('(Step 0A/33) of get3imageinfo4xi - keys3supportedimageformats:  ', keys3supportedimageformats)    
        # dict_keys(['GPU', 'ZPU', 'PPU', 'APU'])

        print('(step 0a/33) of get3imageinfo4xi - passed-to-get3imageinfo4xi task4supportedimageformats3xi:  ', task4supportedimageformats3xi)   
        # {'GPU': {'WIDTH': 0, 'DIMENSION': 2, 'HEIGHT': 0}, 
        #  'ZPU': {'WIDTH': 0, 'DIMENSION': 2, 'HEIGHT': 0}, 
        #  'PPU': {'WIDTH': 0, 'DIMENSION': 2, 'HEIGHT': 0}, 
        #  'APU': {'WIDTH': 0, 'DIMENSION': 2, 'HEIGHT': 0}}

    
    
    if image3d4xi is None:
        # -------------------------------------------------------------------------------------
        # TRY TO CREATE           
        # -------------------------------------------------------------------------------------           
        image3d4xi = create3image4xi()
        
        message3print = "{(Step 1B/33) initialized" + "; image3d4xi-initialized-by-get3imageinfo to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)
        #  
    else:
        # -------------------------------------------------------------------------------------
        # USE           
        # -------------------------------------------------------------------------------------         
        info3return = {} 
        
          
        if 'APU' in keys3supportedimageformats:
            try:
                info3return['APU'] = get3imageinfo4apu(task4supportedimageformats3xi['APU'])
                message3print = "{(Step 1C1/33) got" + "; apuimage-got-by-get3imageinfo: " + str(info3return['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1A/33) of get3imageinfo4xi - info3return:  ', info3return) 
                    # {'APU': {'WIDTH': 800, 'HEIGHT': 800}}
            except:
                pass     
        if 'BPU' in keys3supportedimageformats:
            try:
                info3return['BPU'] = get3imageinfo4bpu(task4supportedimageformats3xi['BPU'])
                message3print = "{(Step 1C1/33) got" + "; bpuimage-got-by-get3imageinfo: " + str(info3return['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'CPU' in keys3supportedimageformats:
            try:
                info3return['CPU'] = get3imageinfo4cpu(task4supportedimageformats3xi['CPU'])
                message3print = "{(Step 1C1/33) got" + "; cpuimage-got-by-get3imageinfo: " + str(info3return['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'DPU' in keys3supportedimageformats:
            try:
                info3return['DPU'] = get3imageinfo4dpu(task4supportedimageformats3xi['DPU'])
                message3print = "{(Step 1C1/33) got" + "; dpuimage-got-by-get3imageinfo: " + str(info3return['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'EPU' in keys3supportedimageformats:
            try:
                info3return['EPU'] = get3imageinfo4epu(task4supportedimageformats3xi['EPU'])
                message3print = "{(Step 1C1/33) got" + "; epuimage-got-by-get3imageinfo: " + str(info3return['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'FPU' in keys3supportedimageformats:
            try:
                info3return['FPU'] = get3imageinfo4fpu(task4supportedimageformats3xi['FPU'])
                message3print = "{(Step 1C1/33) got" + "; fpuimage-got-by-get3imageinfo: " + str(info3return['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'GPU' in keys3supportedimageformats:
            try:
                info3return['GPU'] = get3imageinfo4gpu(task4supportedimageformats3xi['GPU'])
                message3print = "{(Step 1C1/33) got" + "; gpuimage-got-by-get3imageinfo: " + str(info3return['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'HPU' in keys3supportedimageformats:
            try:
                info3return['HPU'] = get3imageinfo4hpu(task4supportedimageformats3xi['HPU'])
                message3print = "{(Step 1C1/33) got" + "; hpuimage-got-by-get3imageinfo: " + str(info3return['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #             
            except:
                pass
        if 'IPU' in keys3supportedimageformats:    
            try:
                info3return['IPU'] = get3imageinfo4ipu(task4supportedimageformats3xi['IPU'])
                message3print = "{(Step 1C1/33) got" + "; ipuimage-got-by-get3imageinfo: " + str(info3return['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'JPU' in keys3supportedimageformats:                     
            try:
                info3return['JPU'] = get3imageinfo4jpu(task4supportedimageformats3xi['JPU'])
                message3print = "{(Step 1C1/33) got" + "; jpuimage-got-by-get3imageinfo: " + str(info3return['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'KPU' in keys3supportedimageformats:                     
            try:
                info3return['KPU'] = get3imageinfo4kpu(task4supportedimageformats3xi['KPU'])
                message3print = "{(Step 1C1/33) got" + "; kpuimage-got-by-get3imageinfo: " + str(info3return['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'LPU' in keys3supportedimageformats:                     
            try:
                info3return['LPU'] = get3imageinfo4lpu(task4supportedimageformats3xi['LPU'])
                message3print = "{(Step 1C1/33) got" + "; lpuimage-got-by-get3imageinfo: " + str(info3return['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'MPU' in keys3supportedimageformats:                     
            try:
                info3return['MPU'] = get3imageinfo4mpu(task4supportedimageformats3xi['MPU'])
                message3print = "{(Step 1C1/33) got" + "; mpuimage-got-by-get3imageinfo: " + str(info3return['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'NPU' in keys3supportedimageformats:                     
            try:
                info3return['NPU'] = get3imageinfo4npu(task4supportedimageformats3xi['NPU'])
                message3print = "{(Step 1C1/33) got" + "; npuimage-got-by-get3imageinfo: " + str(info3return['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'OPU' in keys3supportedimageformats:                    
            try:
                info3return['OPU'] = get3imageinfo4opu(task4supportedimageformats3xi['OPU'])
                message3print = "{(Step 1C1/33) got" + "; opuimage-got-by-get3imageinfo: " + str(info3return['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'PPU' in keys3supportedimageformats:                     
            try:
                info3return['PPU'] = get3imageinfo4ppu(task4supportedimageformats3xi['PPU'])
                message3print = "{(Step 1C1/33) got" + "; ppuimage-got-by-get3imageinfo: " + str(info3return['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'QPU' in keys3supportedimageformats:                     
            try:
                info3return['QPU'] = get3imageinfo4qpu(task4supportedimageformats3xi['QPU'])
                message3print = "{(Step 1C1/33) got" + "; qpuimage-got-by-get3imageinfo: " + str(info3return['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'RPU' in keys3supportedimageformats:                     
            try:
                info3return['RPU'] = get3imageinfo4rpu(task4supportedimageformats3xi['RPU'])
                message3print = "{(Step 1C1/33) got" + "; rpuimage-got-by-get3imageinfo: " + str(info3return['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'SPU' in keys3supportedimageformats:                     
            try:
                info3return['SPU'] = get3imageinfo4spu(task4supportedimageformats3xi['SPU'])
                message3print = "{(Step 1C1/33) got" + "; spuimage-got-by-get3imageinfo: " + str(info3return['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'TPU' in keys3supportedimageformats:                     
            try:
                info3return['TPU'] = get3imageinfo4tpu(task4supportedimageformats3xi['TPU'])
                message3print = "{(Step 1C1/33) got" + "; tpuimage-got-by-get3imageinfo: " + str(info3return['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'UPU' in keys3supportedimageformats:                     
            try:
                info3return['UPU'] = get3imageinfo4upu(task4supportedimageformats3xi['UPU'])
                message3print = "{(Step 1C1/33) got" + "; upuimage-got-by-get3imageinfo: " + str(info3return['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'VPU' in keys3supportedimageformats:                    
            try:
                info3return['VPU'] = get3imageinfo4vpu(task4supportedimageformats3xi['VPU'])
                message3print = "{(Step 1C1/33) got" + "; vpuimage-got-by-get3imageinfo: " + str(info3return['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'WPU' in keys3supportedimageformats:                     
            try:
                info3return['WPU'] = get3imageinfo4wpu(task4supportedimageformats3xi['WPU'])
                message3print = "{(Step 1C1/33) got" + "; wpuimage-got-by-get3imageinfo: " + str(info3return['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'XPU' in keys3supportedimageformats:                     
            try:
                info3return['XPU'] = get3imageinfo4xpu(task4supportedimageformats3xi['XPU'])
                message3print = "{(Step 1C1/33) got" + "; xpuimage-got-by-get3imageinfo: " + str(info3return['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'YPU' in keys3supportedimageformats:                     
            try:
                info3return['YPU'] = get3imageinfo4ypu(task4supportedimageformats3xi['YPU'])
                message3print = "{(Step 1C1/33) got" + "; ypuimage-got-by-get3imageinfo: " + str(info3return['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'ZPU' in keys3supportedimageformats:                     
            try:
                info3return['ZPU'] = get3imageinfo4zpu(task4supportedimageformats3xi['ZPU'])
                message3print = "{(Step 1C1/33) got" + "; zpuimage-got-by-get3imageinfo: " + str(info3return['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
                     
            
    message3print = "{(Step 33/33) returning" + "; info3return-returning-by-get3imageinfo: " + str(info3return) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)
    # 


    if debug is True:
        print('(Step 33/33) of get3imageinfo4xi - RETURNING INFO3RETURN:  ', info3return)  
        #1 
        # {'GPU': {'WIDTH': 800, 'HEIGHT': 800}, 
        #  'ZPU': {'WIDTH': 800, 'HEIGHT': 800}, 
        #  'PPU': {'WIDTH': 800, 'HEIGHT': 800}, 
        #  'APU': {'WIDTH': 800, 'HEIGHT': 800}}
        #2
        # {'GPU': {'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, ....

    return info3return
            
#</function4xi> 
 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get3supportedimageformats4xi" usage = "
#
#   print('(Step 3A1/700) OF IMAGE3D4XI5TEST - TRYING TO GET SUPPORTED 3D IMAGE FORMATS FOR XI ', time4xi())    
#   task4getinfo3image = {}
#   kb3task = {}
#   kb3task ['APU'] = {}
#   kb3task ['GPU'] = {}
#   kb3task ['PPU'] = {}
#   kb3task ['ZPU'] = {}
#   keys3task = kb3task.keys()
#   for key3task in sorted(keys3task):
#       task4getinfo3image [key3task] = {}
#        
#   try:                
#       response = get3supportedimageformats4xi(task4getinfo3image)   
#       keys3response = response.keys()
#       for key3response in sorted(keys3response):
#           print(key3response, ' : ', response[key3response])
#           # APU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
#           # GPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
#           # PPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
#           # ZPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
#   except:
#       print('(Step 3Z3/700) OF IMAGE3D4XI5TEST *** FAILED TO GET SUPPORTED 3D IMAGE FORMATS FOR XI', time4xi())
#      
#">

# -------------------------------------------------------------------------------------------------   
def get3supportedimageformats4xi(task4supportedimageformats3xi=None):  

    '''
    gets supported image formats for xi
    '''
    global image3d4xi
    global info3image4xi    

    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "get3supportedimageformats4xi"
    method3print = "get3supportedimageformats4xi"
    
    message3print = "{(Step 0A/33) started" + "; get3supportedimageformats4xi-started: " + str(get3supportedimageformats4xi)  + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)
    # <function get3supportedimageformats4xi at 0x0000000003A9E9C8>  
    
    message3print = "{(Step 0A/33) passed" + "; task4supportedimageformats3xi-passed-to-get3supportedimageformats4xi: " + str(task4supportedimageformats3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)   
    #
    if debug is True:
        print('(step 0a/33) of get3supportedimageformats4xi - passed-to-get3supportedimageformats4xi task4supportedimageformats3xi:  ', task4supportedimageformats3xi)   
        # {'GPU': {}, 'ZPU': {}, 'PPU': {}, 'APU': {}}
        
    if task4supportedimageformats3xi is None:
        task4supportedimageformats3xi = {}
        
    keys3supportedimageformats = task4supportedimageformats3xi.keys()     
        
    
    if image3d4xi is None:
        # -------------------------------------------------------------------------------------
        # TRY TO CREATE           
        # -------------------------------------------------------------------------------------           
        image3d4xi = create3image4xi()
        
        message3print = "{(Step 1B/33) initialized" + "; image3d4xi-initialized-by-get3supportedimageformats to: " + str(image3d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)
        #  
    else:
        # -------------------------------------------------------------------------------------
        # USE           
        # -------------------------------------------------------------------------------------         
        info3formats = {} 
        
        if debug is True:
            print('(Step 1/33) of get3supportedimageformats4xi - keys3supportedimageformats:  ', keys3supportedimageformats) 
            # dict_keys(['GPU', 'ZPU', 'PPU', 'APU'])
          
        if 'APU' in keys3supportedimageformats:
            try:
                info3formats['APU'] = get3supportedimageformats4apu(task4supportedimageformats3xi['APU'])
                message3print = "{(Step 1C1/33) got" + "; apuimage-got-by-get3supportedimageformats: " + str(info3formats['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
                if debug is True:
                    print('(Step 1A/33) of get3supportedimageformats4xi - info3formats:  ', info3formats) 
                    # {'APU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}}
            except:
                pass     
        if 'BPU' in keys3supportedimageformats:
            try:
                info3formats['BPU'] = get3supportedimageformats4bpu(task4supportedimageformats3xi['BPU'])
                message3print = "{(Step 1C1/33) got" + "; bpuimage-got-by-get3supportedimageformats: " + str(info3formats['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'CPU' in keys3supportedimageformats:
            try:
                info3formats['CPU'] = get3supportedimageformats4cpu(task4supportedimageformats3xi['CPU'])
                message3print = "{(Step 1C1/33) got" + "; cpuimage-got-by-get3supportedimageformats: " + str(info3formats['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass     
            
        if 'DPU' in keys3supportedimageformats:
            try:
                info3formats['DPU'] = get3supportedimageformats4dpu(task4supportedimageformats3xi['DPU'])
                message3print = "{(Step 1C1/33) got" + "; dpuimage-got-by-get3supportedimageformats: " + str(info3formats['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'EPU' in keys3supportedimageformats:
            try:
                info3formats['EPU'] = get3supportedimageformats4epu(task4supportedimageformats3xi['EPU'])
                message3print = "{(Step 1C1/33) got" + "; epuimage-got-by-get3supportedimageformats: " + str(info3formats['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'FPU' in keys3supportedimageformats:
            try:
                info3formats['FPU'] = get3supportedimageformats4fpu(task4supportedimageformats3xi['FPU'])
                message3print = "{(Step 1C1/33) got" + "; fpuimage-got-by-get3supportedimageformats: " + str(info3formats['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'GPU' in keys3supportedimageformats:
            try:
                info3formats['GPU'] = get3supportedimageformats4gpu(task4supportedimageformats3xi['GPU'])
                message3print = "{(Step 1C1/33) got" + "; gpuimage-got-by-get3supportedimageformats: " + str(info3formats['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #      
            except:
                pass               
        if 'HPU' in keys3supportedimageformats:
            try:
                info3formats['HPU'] = get3supportedimageformats4hpu(task4supportedimageformats3xi['HPU'])
                message3print = "{(Step 1C1/33) got" + "; hpuimage-got-by-get3supportedimageformats: " + str(info3formats['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #             
            except:
                pass
        if 'IPU' in keys3supportedimageformats:    
            try:
                info3formats['IPU'] = get3supportedimageformats4ipu(task4supportedimageformats3xi['IPU'])
                message3print = "{(Step 1C1/33) got" + "; ipuimage-got-by-get3supportedimageformats: " + str(info3formats['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'JPU' in keys3supportedimageformats:                     
            try:
                info3formats['JPU'] = get3supportedimageformats4jpu(task4supportedimageformats3xi['JPU'])
                message3print = "{(Step 1C1/33) got" + "; jpuimage-got-by-get3supportedimageformats: " + str(info3formats['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'KPU' in keys3supportedimageformats:                     
            try:
                info3formats['KPU'] = get3supportedimageformats4kpu(task4supportedimageformats3xi['KPU'])
                message3print = "{(Step 1C1/33) got" + "; kpuimage-got-by-get3supportedimageformats: " + str(info3formats['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'LPU' in keys3supportedimageformats:                     
            try:
                info3formats['LPU'] = get3supportedimageformats4lpu(task4supportedimageformats3xi['LPU'])
                message3print = "{(Step 1C1/33) got" + "; lpuimage-got-by-get3supportedimageformats: " + str(info3formats['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'MPU' in keys3supportedimageformats:                     
            try:
                info3formats['MPU'] = get3supportedimageformats4mpu(task4supportedimageformats3xi['MPU'])
                message3print = "{(Step 1C1/33) got" + "; mpuimage-got-by-get3supportedimageformats: " + str(info3formats['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'NPU' in keys3supportedimageformats:                     
            try:
                info3formats['NPU'] = get3supportedimageformats4npu(task4supportedimageformats3xi['NPU'])
                message3print = "{(Step 1C1/33) got" + "; npuimage-got-by-get3supportedimageformats: " + str(info3formats['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'OPU' in keys3supportedimageformats:                    
            try:
                info3formats['OPU'] = get3supportedimageformats4opu(task4supportedimageformats3xi['OPU'])
                message3print = "{(Step 1C1/33) got" + "; opuimage-got-by-get3supportedimageformats: " + str(info3formats['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'PPU' in keys3supportedimageformats:                     
            try:
                info3formats['PPU'] = get3supportedimageformats4ppu(task4supportedimageformats3xi['PPU'])
                message3print = "{(Step 1C1/33) got" + "; ppuimage-got-by-get3supportedimageformats: " + str(info3formats['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'QPU' in keys3supportedimageformats:                     
            try:
                info3formats['QPU'] = get3supportedimageformats4qpu(task4supportedimageformats3xi['QPU'])
                message3print = "{(Step 1C1/33) got" + "; qpuimage-got-by-get3supportedimageformats: " + str(info3formats['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'RPU' in keys3supportedimageformats:                     
            try:
                info3formats['RPU'] = get3supportedimageformats4rpu(task4supportedimageformats3xi['RPU'])
                message3print = "{(Step 1C1/33) got" + "; rpuimage-got-by-get3supportedimageformats: " + str(info3formats['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'SPU' in keys3supportedimageformats:                     
            try:
                info3formats['SPU'] = get3supportedimageformats4spu(task4supportedimageformats3xi['SPU'])
                message3print = "{(Step 1C1/33) got" + "; spuimage-got-by-get3supportedimageformats: " + str(info3formats['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'TPU' in keys3supportedimageformats:                     
            try:
                info3formats['TPU'] = get3supportedimageformats4tpu(task4supportedimageformats3xi['TPU'])
                message3print = "{(Step 1C1/33) got" + "; tpuimage-got-by-get3supportedimageformats: " + str(info3formats['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'UPU' in keys3supportedimageformats:                     
            try:
                info3formats['UPU'] = get3supportedimageformats4upu(task4supportedimageformats3xi['UPU'])
                message3print = "{(Step 1C1/33) got" + "; upuimage-got-by-get3supportedimageformats: " + str(info3formats['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'VPU' in keys3supportedimageformats:                    
            try:
                info3formats['VPU'] = get3supportedimageformats4vpu(task4supportedimageformats3xi['VPU'])
                message3print = "{(Step 1C1/33) got" + "; vpuimage-got-by-get3supportedimageformats: " + str(info3formats['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'WPU' in keys3supportedimageformats:                     
            try:
                info3formats['WPU'] = get3supportedimageformats4wpu(task4supportedimageformats3xi['WPU'])
                message3print = "{(Step 1C1/33) got" + "; wpuimage-got-by-get3supportedimageformats: " + str(info3formats['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'XPU' in keys3supportedimageformats:                     
            try:
                info3formats['XPU'] = get3supportedimageformats4xpu(task4supportedimageformats3xi['XPU'])
                message3print = "{(Step 1C1/33) got" + "; xpuimage-got-by-get3supportedimageformats: " + str(info3formats['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'YPU' in keys3supportedimageformats:                     
            try:
                info3formats['YPU'] = get3supportedimageformats4ypu(task4supportedimageformats3xi['YPU'])
                message3print = "{(Step 1C1/33) got" + "; ypuimage-got-by-get3supportedimageformats: " + str(info3formats['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
        if 'ZPU' in keys3supportedimageformats:                     
            try:
                info3formats['ZPU'] = get3supportedimageformats4zpu(task4supportedimageformats3xi['ZPU'])
                message3print = "{(Step 1C1/33) got" + "; zpuimage-got-by-get3supportedimageformats: " + str(info3formats['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class3print, method3print, message3print)
                #
            except:
                pass
                     
            
    message3print = "{(Step 33/33) returning" + "; info3formats-returning-by-get3supportedimageformats: " + str(info3formats) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)
    # 

    if debug is True:
        print('(Step 33/33) of get3supportedimageformats4xi - RETURNING INFO3FORMATS:  ', info3formats)  
        #  {'GPU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}, 
        #   'ZPU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}, '
        #    PPU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}, 
        #   'APU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}}
 

    return info3formats
            
#</function4xi> 

 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "wait3image4xi" usage = "        
#   print('(Step 16C/25) OF IMAGE3D4XI5TEST - TRYING TO WAIT PROCESSING UNIT(S) OF XI FOR JUST CREATED 3D IMAGE: ', time4xi())   
#   try:                               
#       task4wait3image  = {}
#       task4wait3image['APU']  = {}
#       task4wait3image['GPU']  = {}
#       task4wait3image['PPU']  = {}
#       task4wait3image['ZPU']  = {}
#       response4wait3image = wait3image4xi(task4wait3image) 
#       keys3waitresponse = response4wait3image.keys()
#       for key3waitresponse in sorted(keys3waitresponse):
#           print(key3waitresponse, ' : ', response4wait3image[key3waitresponse] )
#           # APU  :  <queue4xi.Queue4Xi object at 0x0000000005CCAEB8>
#           # PPU  :  <queue4xi.Queue4Xi object at 0x0000000005CE0EF0>
#           # ZPU  :  <queue4xi.Queue4Xi object at 0x0000000005CE6E80>                                                                                                 
#   except:
#       print('(Step 16Z3/25) OF IMAGE3D4XI5TEST *** FAILED TO WAIT PROCESSING UNIT(S) OF XI FOR JUST CREATED 3D IMAGE: ', time4xi()) 
#">

# -------------------------------------------------------------------------------------------------   
def wait3image4xi(task4wait3xi=None):

    '''
    waits 
    '''
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    debug = True
    class3print = "wait3image4xi" 
    method3print = "wait3image4xi"

    message3print = "{(Step 1A/33) started" + "; wait3image4xi-started: " + str(wait3image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)                                                              
    # <function wait3image4xi at 0x0000000003AF0348> 
  
             
    message3print = "{(Step 1B/33) passed" + "; task4wait3xi-to-wait3image4xi: " + str(task4wait3xi) + "; time: " + time4xi() + "}"
    print4xi(class3print, method3print, message3print)                                                              # 
    #     
    if task4wait3xi is None:
        task4wait3xi  = {}  
    keys3wait = task4wait3xi.keys()
    if debug is True:
       print("(Step 1C/33) of wait3image4xi - keys3wait: ", sorted(keys3wait))
       # ['APU', 'GPU', 'PPU', 'ZPU']
    
    code3ack  = ' '
    code3nack = ' '    
         
    
    image3dwait4xi = {}
      
             
    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys3wait:
            message3print = "{(Step A/33) passing" + "; task-passing-to-wait3image4apu: " + str(task4wait3xi['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4apu = wait3image4apu()
            image3dwait4xi ['APU'] = response3wait4apu ['QUEUE']                                                     
                         
            message3print = "{(Step A1/33) set" + "; apu-image-wait-set-by-wait3image4apu to: " + str(image3dwait4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of wait3image4xi - set wait4xi of APU image to: ", image3dwait4xi ['APU'])
                # <queue4xi.Queue4Xi object at 0x0000000005CD1518>
                
            code3ack  = code3ack + 'A1-'
        else:
            pass    
    except:
        message3print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-wait3image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys3wait:
            message3print = "{(Step B/33) passing" + "; task-passing-to-wait3image4bpu: " + str(task4wait3xi['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4bpu = wait3image4bpu()
            image3dwait4xi ['BPU']  = response3wait4bpu ['QUEUE']                                                      # 
         
            message3print = "{(Step B1/33) set" + "; bpu-image-wait-set-by-wait3image4bpu to: " + str(image3dwait4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'B1-'
        else:
            pass    
    except:
        message3print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-wait3image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys3wait:
            message3print = "{(Step C/33) passing" + "; task-passing-to-wait3image4cpu: " + str(task4wait3xi['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4cpu = wait3image4cpu()
            image3dwait4xi ['CPU']  = response3wait4cpu ['QUEUE']                                                      # 
         
            message3print = "{(Step C1/33) set" + "; cpu-image-wait-set-by-wait3image4cpu to: " + str(image3dwait4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'C1-'
        else:
            pass    
    except:
        message3print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-wait3image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys3wait:
            message3print = "{(Step D/33) passing" + "; task-passing-to-wait3image4dpu: " + str(task4wait3xi['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4dpu = wait3image4dpu()
            image3dwait4xi ['DPU']  = response3wait4dpu ['QUEUE']                                                      # 
         
            message3print = "{(Step D1/33) set" + "; dpu-image-wait-set-by-wait3image4dpu to: " + str(image3dwait4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'D1-'
        else:
            pass    
    except:
        message3print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-wait3image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys3wait:
            message3print = "{(Step E/33) passing" + "; task-passing-to-wait3image4epu: " + str(task4wait3xi['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4epu = wait3image4epu()
            image3dwait4xi ['EPU']  = response3wait4epu ['QUEUE']                                                      # 
         
            message3print = "{(Step E1/33) set" + "; epu-image-wait-set-by-wait3image4epu to: " + str(image3dwait4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'E1-'
        else:
            pass    
    except:
        message3print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-wait3image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys3wait:
            message3print = "{(Step F/33) passing" + "; task-passing-to-wait3image4fpu: " + str(task4wait3xi['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3waitfpu = wait3image4fpu()
            image3dwait4xi ['FPU']  = response3wait4fpu ['QUEUE']                                                      # 
         
            message3print = "{(Step F1/33) set" + "; fpu-image-wait-set-by-wait3image4fpu to: " + str(image3dwait4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'F1-'
        else:
            pass    
    except:
        message3print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-wait3image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys3wait:
            message3print = "{(Step G/33) passing" + "; task-passing-to-wait3image4gpu: " + str(task4wait3xi['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            #
            response3waitgpu = wait3image4gpu() 
        
            image3dwait4xi ['GPU']  = response3wait4gpu ['QUEUE']                                                       # 
         
            message3print = "{(Step G1/33) set" + "; gpu-image-wait-set-by-wait3image4gpu to: " + str(image3dwait4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'G1-'
        else:
            pass    
    except:
        message3print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-wait3image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys3wait:
            message3print = "{(Step H/33) passing" + "; task-passing-to-wait3image4hpu: " + str(task4wait3xi['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            #
            response3waithpu = wait3image4hpu() 
        
            image3dwait4xi ['HPU']  = response3wait4hpu ['QUEUE']                                                      # 
         
            message3print = "{(Step H1/33) set" + "; hpu-image-wait-set-by-wait3image4hpu to: " + str(image3dwait4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'H1-'
        else:
            pass    
    except:
        message3print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-wait3image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys3wait:
            message3print = "{(Step I/33) passing" + "; task-passing-to-wait3image4ipu: " + str(task4wait3xi['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            #
            response3wait4ipu = wait3image4ipu() 
        
            image3dwait4xi ['IPU']  = response3wait4ipu ['QUEUE']                                                      # 
         
            message3print = "{(Step I1/33) set" + "; ipu-image-wait-set-by-wait3image4ipu to: " + str(image3dwait4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'I1-'
        else:
            pass    
    except:
        message3print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-wait3image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys3wait:
            message3print = "{(Step J/33) passing" + "; task-passing-to-wait3image4jpu: " + str(task4wait3xi['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            #
            response3wait4jpu = wait3image4jpu() 
            image3dwait4xi ['JPU']  = response3wait4jpu ['QUEUE']                                                      # 
         
            message3print = "{(Step J1/33) set" + "; jpu-image-wait-set-by-wait3image4jpu to: " + str(image3dwait4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'J1-'
        else:
            pass    
    except:
        message3print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-wait3image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys3wait:
            message3print = "{(Step K/33) passing" + "; task-passing-to-wait3image4kpu: " + str(task4wait3xi['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4kpu = wait3image4kpu()
            image3dwait4xi ['KPU']  = response3wait4kpu ['QUEUE']                                                      # 
         
            message3print = "{(Step K1/33) set" + "; kpu-image-wait-set-by-wait3image4kpu to: " + str(image3dwait4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'K1-'
        else:
            pass    
    except:
        message3print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-wait3image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys3wait:
            message3print = "{(Step L/33) passing" + "; task-passing-to-wait3image4lpu: " + str(task4wait3xi['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4lpu = wait3image4lpu()
            image3dwait4xi ['LPU']  = response3wait4lpu ['QUEUE']                                                      # 
         
            message3print = "{(Step L1/33) set" + "; lpu-image-wait-set-by-wait3image4lpu to: " + str(image3dwait4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + '1-'
        else:
            pass    
    except:
        message3print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-wait3image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys3wait:
            message3print = "{(Step M/33) passing" + "; task-passing-to-wait3image4mpu: " + str(task4wait3xi['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4mpu = wait3image4mpu()
            image3dwait4xi ['MPU']  = response3wait4mpu ['QUEUE']                                                      # 
         
            message3print = "{(Step M1/33) set" + "; mpu-image-wait-set-by-wait3image4mpu to: " + str(image3dwait4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'M1-'
        else:
            pass    
    except:
        message3print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-wait3image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys3wait:
            message3print = "{(Step N/33) passing" + "; task-passing-to-wait3image4npu: " + str(task4wait3xi['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4npu = wait3image4npu()
            image3dwait4xi ['NPU']  = response3wait4npu ['QUEUE']                                                      # 
         
            message3print = "{(Step N1/33) set" + "; npu-image-wait-set-by-wait3image4npu to: " + str(image3dwait4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'N1-'
        else:
            pass    
    except:
        message3print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-wait3image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys3wait:
            message3print = "{(Step O/33) passing" + "; task-passing-to-wait3image4opu: " + str(task4wait3xi['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4opu = wait3image4opu()
            image3dwait4xi ['OPU']  = response3wait4opu ['QUEUE']                                                      # 
         
            message3print = "{(Step O1/33) set" + "; opu-image-wait-set-by-wait3image4opu to: " + str(image3dwait4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'O1-'
        else:
            pass    
    except:
        message3print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-wait3image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys3wait:
            message3print = "{(Step P/33) passing" + "; task-passing-to-wait3image4ppu: " + str(task4wait3xi['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4ppu = wait3image4ppu()
            image3dwait4xi ['PPU']  = response3wait4ppu ['QUEUE']                                                      # 
         
            message3print = "{(Step P1/33) set" + "; ppu-image-wait-set-by-wait3image4ppu to: " + str(image3dwait4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'P1-'
        else:
            pass    
    except:
        message3print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-wait3image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys3wait:
            message3print = "{(Step Q/33) passing" + "; task-passing-to-wait3image4qpu: " + str(task4wait3xi['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4qpu = wait3image4qpu()
            image3dwait4xi ['QPU']  = response3wait4qpu ['QUEUE']                                                      # 
         
            message3print = "{(Step Q1/33) set" + "; qpu-image-wait-set-by-wait3image4qpu to: " + str(image3dwait4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'Q1-'
        else:
            pass    
    except:
        message3print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-wait3image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys3wait:
            message3print = "{(Step R/33) passing" + "; task-passing-to-wait3image4rpu: " + str(task4wait3xi['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4rpu = wait3image4rpu()
            image3dwait4xi ['RPU']  = response3wait4rpu ['QUEUE']                                                      # 
         
            message3print = "{(Step R1/33) set" + "; rpu-image-wait-set-by-wait3image4rpu to: " + str(image3dwait4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'R1-'
        else:
            pass    
    except:
        message3print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-wait3image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys3wait:
            message3print = "{(Step S/33) passing" + "; task-passing-to-wait3image4spu: " + str(task4wait3xi['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4spu = wait3image4spu()
            image3dwait4xi ['SPU']  = response3wait4spu ['QUEUE']                                                      # 
         
            message3print = "{(Step S1/33) set" + "; spu-image-wait-set-by-wait3image4spu to: " + str(image3dwait4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'S1-'
        else:
            pass    
    except:
        message3print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-wait3image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys3wait:
            message3print = "{(Step T/33) passing" + "; task-passing-to-wait3image4tpu: " + str(task4wait3xi['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4tpu = wait3image4tpu()
            image3dwait4xi ['TPU']  = response3wait4tpu ['QUEUE']                                                      # 
         
            message3print = "{(Step T1/33) set" + "; tpu-image-wait-set-by-wait3image4tpu to: " + str(image3dwait4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'T1-'
        else:
            pass    
    except:
        message3print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-wait3image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys3wait:
            message3print = "{(Step U/33) passing" + "; task-passing-to-wait3image4upu: " + str(task4wait3xi['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4upu = wait3image4upu()
            image3dwait4xi ['UPU']  = response3wait4upu ['QUEUE']                                                      # 
         
            message3print = "{(Step U1/33) set" + "; upu-image-wait-set-by-wait3image4upu to: " + str(image3dwait4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'U1-'
        else:
            pass    
    except:
        message3print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-wait3image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys3wait:
            message3print = "{(Step V/33) passing" + "; task-passing-to-wait3image4vpu: " + str(task4wait3xi['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4vpu = wait3image4vpu()
            image3dwait4xi ['VPU']  = response3wait4vpu ['QUEUE']                                                      # 
         
            message3print = "{(Step V1/33) set" + "; vpu-image-wait-set-by-wait3image4vpu to: " + str(image3dwait4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'V1-'
        else:
            pass    
    except:
        message3print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-wait3image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys3wait:
            message3print = "{(Step W/33) passing" + "; task-passing-to-wait3image4wpu: " + str(task4wait3xi['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4wpu = wait3image4wpu()
            image3dwait4xi ['WPU']  = response3wait4wpu ['QUEUE']                                                      # 
         
            message3print = "{(Step W1/33) set" + "; wpu-image-wait-set-by-wait3image4wpu to: " + str(image3dwait4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'W1-'
        else:
            pass    
    except:
        message3print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-wait3image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys3wait:
            message3print = "{(Step X/33) passing" + "; task-passing-to-wait3image4xpu: " + str(task4wait3xi['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4xpu = wait3image4xpu() 
            image3dwait4xi ['XPU']  = response3wait4xpu ['QUEUE']                                                      # 
         
            message3print = "{(Step X1/33) set" + "; xpu-image-wait-set-by-wait3image4xpu to: " + str(image3dwait4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of wait3image4xi - set wait4xi of XPU image to: ", image3dwait4xi ['XPU'])
            code3ack  = code3ack + 'X1-'
        else:
            pass    
    except:
        message3print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-wait3image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys3wait:
            message3print = "{(Step Y/33) passing" + "; task-passing-to-wait3image4ypu: " + str(task4wait3xi['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4ypu = wait3image4ypu()
            image3dwait4xi ['YPU']  = response3wait4ypu ['QUEUE']                                                      # 
         
            message3print = "{(Step Y1/33) set" + "; ypu-image-wait-set-by-wait3image4ypu to: " + str(image3dwait4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
        
            code3ack  = code3ack + 'Y1-'
        else:
            pass    
    except:
        message3print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-wait3image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys3wait:
            message3print = "{(Step Z/33) passing" + "; task-passing-to-wait3image4zpu: " + str(task4wait3xi['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class3print, method3print, message3print)                                                         
            # 
            response3wait4zpu = wait3image4zpu()
            image3dwait4xi ['ZPU']  = response3wait4zpu ['QUEUE']                                                      # 
         
            message3print = "{(Step Z1/33) set" + "; zpu-image-wait-set-by-wait3image4zpu to: " + str(image3dwait4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of wait3image4xi - set wait4xi of ZPU image to: ", image3dwait4xi ['ZPU'])
            code3ack  = code3ack + 'Z1-'
        else:
            pass    
    except:
        message3print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-wait3image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        code3nack  = code3nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of wait3image4xi - RETURNING IMAGE3DWAIT4XI : ", image3dwait4xi)
        # APU  :  <queue4xi.Queue4Xi object at 0x0000000005DDF630>
        # PPU  :  <queue4xi.Queue4Xi object at 0x0000000005DF3668>
        # ZPU  :  <queue4xi.Queue4Xi object at 0x0000000005DF95F8>
        
    message3print = "{(Step 33/33) returning" + "; image3dwait4xi-returning-by-wait3image4xi: " + str(image3dwait4xi) + "; time: " + time4xi() + "}" 
    print4xi(class3print, method3print, message3print)
    # 
    
    return image3dwait4xi
    
    

   
#</function4xi> 
                                               
# =================================================================================================
#<class4xi class = "Image3D4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for XI 3D image" usage = "OpenCL XI 3D image"
#>

# =================================================================================================
class Image3D4Xi(object): 
    ''' 
    Image3D4Xi offers  methods for XI 3D image
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable3xi = cpu_corecount4xi()
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'create3image',                    # ACK 5.31   p76    
            'copy3image',                      # ACK 5.31   p88
            'copy3imagetobuffer',              # ACK 5.3.4  p90
            'copy3buffertoimage',              # ACK 5.3.4  p92
            'read3image',                      # ACK 5.3.3  p84
            'write3image',                     # ACK 5.3.3  p84            
            'map3image',                       # ACK 5.3.5  p94            
            'get3imageinfo',                   # ACK 5.3.6  p97
            'get3supportedimageformats',       # ACK 5.3.2  p82 
            'retain3image',                    # ACK 5.4.1  p99 
            'release3image',                   # ACK 5.4.1  p99
            'trace3image',                     # ACK 
            'set3imagecallback',               # ACK 
            'set3image',                       # ACK                
            'wait3image',                      # ACK 
            'sense',                           # ACK 
            'reason',                          # ACK 
            'ace')                             # ACK         
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Image3D4Xi" usage = "
    #   print('(Step 105A/700) OF IMAGE3D4XI5TEST - CREATING IMAGE4XI OBJECT ', time4xi())     
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                        
    #       # ---------------------------------------------------------------------------------------------        
    #       imageobject3xi = Image3D4Xi()
    #       print('(Step 105B/700) OF IMAGE3D4XI5TEST - CREATED IMAGE4XI OBJECT: ', imageobject3xi)                                  
    #       # <image3d4xi.Image3D4Xi object at 0x00000000048AAB38>
    #   except:
    #       print('(Step 105Z/700) OF IMAGE3D4XI5TEST *** FAILED TO CREATE IMAGE4XI OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4imagecreate3xi = None):
        '''
        _init__ method initializes Image3D4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class3print = "Image3D4Xi"
        method3print = "__init__"
                     
        message3print = "{(Step 1A/33) started" + "; init-of-Image3D4Xi-started: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                          
        # 23:41:37 09/06/11 Pacific Daylight Time 

        message3print = "{(Step 1B/33) borning" + "; image3d4xi-of-Image3D4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None 
                
        message3print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-image3d4xi-of-Image3D4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # <class 'object'>
        
        message3print = "{(Step 1D/33) sharing" + "; classvariable3xi-sharing-by-image3d4xi-of-Image3D4Xi: " + str(Image3D4Xi.classvariable3xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 4             
                                
        message3print = "{(Step 1E/33) passed" + "; task4imagecreate3xi-passed-to-init-of-Image3D4Xi: " + str(task4imagecreate3xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None                            
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message3print = "{(Step 2A/33) passing" + "; task4imagecreate3xi-passing-to-create3image4xi-by-init-of-Image3D4Xi: " + str(task4imagecreate3xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None  
        
        image3xi = create3image4xi(task4imagecreate3xi)
        
        message3print = "{(Step 2B/33) performed" + "; create3image4xi-performed-by-init-of-Image3D4Xi: " + str(create3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # <function create3image4xi at 0x0000000003A9E7C8>
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 3A/33) activated" + "; image3d4xi-of-Image3D4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # { Image3D4Xi : __init__ ; (Step 3A/33) activated; image3d4xi-of-Image3D4Xi-activated: ; time: 00:14:05 09/07/11 Pacific Daylight Time} 
                
        message3print = "{(Step 3B/33) inherited" + "; object-inherited-by-image3d4xi-of-Image3D4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # <class 'object'> 
        
        message3print = "{(Step 3C/33) shared" + "; classvariable3xi-shared-by-image3d4xi-of-Image3D4Xi: " + str(Image3D4Xi.classvariable3xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 4           
       
        message3print = "{(Step 3D/33) returning" + "; init-of-Image3D4Xi-returning: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                          
        # 00:14:05 09/07/11 Pacific Daylight Time
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create3image-of-Image3D4Xi" usage = "
    #    print('(Step 123A/700) OF IMAGE3D4XI5TEST - TRYING TO CREATE 3D IMAGE for XI ', time4xi()) 
    # 
    #    try:
    #        xi3xi = Image3D4Xi()                            
    #        
    #        task4create3image = {} 
    #        for key3pu in keys3pu:
    #            task4create3image [key3pu]  = {}
    #                        
    #        response4create3Dimage = xi3xi.create3image(task4create3image)                                  
    #        
    #        keys3response = response4create3Dimage.keys()
    #        
    #        for key3response in sorted(keys3response):
    #            print(key3response, ' : ', response4create3Dimage[key3response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF IMAGE3D4XI5TEST *** FAILED TO CREATE 3D IMAGE for XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create3image(self, task4image3create = None):
        '''
        create3image method creates 3D image objects of Image3D4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "create3image"
                     
        message3print = "{(Step 1A/33) started" + "; create3image-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
            
        message3print = "{(Step 1B/33) passed" + "; task4image3create-passed-to-create-of-Image3D4Xi: " + str(task4image3create) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4image3create-passing-to-create3image4xi-by-create3image-of-Image3D4Xi: " + str(task4image3create) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)            
        #      
  
        image3xi = create3image4xi(task4image3create)

        message3print = "{(Step 2B/33) performed" + "; create3image4xi-performed-by-create3image-of-Image3D4Xi: " + str(create3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message3print = "{(Step 3/33) returning" + "; image3xi-returning-by-create3image-of-Image3D4Xi: " + str(image3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                          # 
        # 

        return image3xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set3image-of-Image3D4Xi" usage = "
    # 
    #    response4set3Dimage = {} 
    #    print('(Step 114A/700) OF IMAGE3D4XI5TEST - TRYING TO SET 3D IMAGE4XI ', time4xi())   
    #    try:                               
    #        response4set3Dimage = imageobject3xi.set3image(task4set3image)                                                                                                         
    #                                                                                      
    #        print('(Step 114B/700) OF IMAGE3D4XI5TEST - SET 3D IMAGE4XI ', time4xi())
    #        keys3response = response4set3Dimage.keys()
    #        for key3response in sorted(keys3response):
    #            print(key3response, ' : ', response4set3Dimage[key3response])
    #            # APU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
    #            # ....
    #            # ZPU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
    #            
    #        print('(Step 114B/700) OF IMAGE3D4XI5TEST - SET 3D IMAGE4XI ', time4xi())
    #        # 06:50:19 11/05/11 Pacific Daylight Time
    #             
    #    except:
    #        print('(Step 114Z/700) OF IMAGE3D4XI5TEST *** FAILED TO SET 3D IMAGE4XI *** ', time4xi()) 
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set3image(self, task4set3image = None):
        '''
        sets 3D image XI objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "set3image"
                     
        message3print = "{(Step 1A/33) started" + "; set3image-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
            
        message3print = "{(Step 1B/33) passed" + "; task4set3image-passed-to-set3image-of-Image3D4Xi: " + str(task4set3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4set3image-passing-to-set3image4xi-by-set3image-of-Image3D4Xi: " + str(task4set3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # 

        image3xi = set3image4xi(task4set3image)

        message3print = "{(Step 2B/33) performed" + "; set3image4xi-performed-by-set3image-of-Image3D4Xi: " + str(set3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # <function set3image4xi at 0x0000000003AB36C8> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; image3xi-returning-by-set3image-of-Image3D4Xi: " + str(image3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
                
        return image3xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get3imageinfo-of-Image3D4Xi" usage = "
    #   
    #    print('(Step 106A1/700) OF IMAGE3D4XI5TEST - TRYING TO GET 3D IMAGE INFO WITH METHOD ', time4xi())    
    #    try: 
    #        task4getinfo3image = {}
    #        for key3pu in keys3pu:
    #            if KB3CC [key3pu] == 'ACK':
    #                task4getinfo3image [key3pu]  = {}
    #                task4getinfo3image [key3pu] ['WIDTH']  = 0
    #                task4getinfo3image [key3pu] ['HEIGHT']  = 0 
    #               
    #        response4get3imageinfo = imageobject3xi.get3imageinfo(task4getinfo3image)                                 
    #                                               
    #        keys3response = response4get3imageinfo.keys()
    #        for key3response in sorted(keys3response):
    #            print(key3response, ' : ', response4get3imageinfo[key3response])
    #            # APU  :  {'WIDTH': 800, 'HEIGHT': 800}
    #            # GPU  :  {'WIDTH': 800, 'HEIGHT': 800}
    #            # ZPU  :  {'WIDTH': 800, 'HEIGHT': 800}
    #    except:
    #        print('(Step 106Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO GET 3D IMAGE INFO WITH METHOD ', time4xi())    
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get3imageinfo(self, task4imageinfo3xi=None):
        '''
        get3imageinfo method gets 3D objects of Image3D4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "get3imageinfo"
                     
        message3print = "{(Step 1A/33) started" + "; get3imageinfo-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        image3xi = get3imageinfo4xi(task4imageinfo3xi)
        
        message3print = "{(Step 2A/33) returning" + "; image3xi-returning-by-get3imageinfo-of-Image3D4Xi: " + str(image3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
        
        return image3xi
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get3supportedimageformats-of-Image3D4Xi" usage = "
    # 
    #    print('(Step 106B1/700) OF IMAGE3D4XI5TEST - TRYING TO GET SUPPORTED IMAGE FORMATS FOR XI')
    #    try:
    #        task4supportedimageformats3image = {} 
    #        for key3pu in keys3pu:
    #            if KB3CC [key3pu] == 'ACK':
    #                task4supportedimageformats3image [key3pu]  = {}
    #        
    #        response4supportedimageformats = imageobject3xi.get3supportedimageformats(task4supportedimageformats3image)
    #           
    #        keys3response = response4supportedimageformats.keys()
    #        for key3response in sorted(keys3response):
    #            print(key3response, ' : ', response4supportedimageformats[key3response])
    #            # APU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
    #            # GPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
    #            # ZPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'} 
    #    except:
    #        print('(Step 102Z/33) OF XI4XI5TEST *** FAILED TO GET SUPPORTED 3D IMAGE FORMATS FOR XI***')    
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get3supportedimageformats(self, task4supportedimageformats3xi=None ):
        '''
        get3supportedimageformats method gets supported imageformats by objects of Image3D4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "get3supportedimageformats"
                     
        message3print = "{(Step 1A/33) started" + "; get3supportedimageformats-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        supportedimageformats3xi = get3supportedimageformats4xi(task4supportedimageformats3xi)
        
        message3print = "{(Step 2A/33) returning" + "; supportedimageformats3xi-returning-by-get3imageinfo-of-Image3D4Xi: " + str(supportedimageformats3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
        
        return supportedimageformats3xi
                            
    #</methodize4xi>    
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "read3image-of-Image3D4Xi" usage = "
    #
    #    print('(Step 127C/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH READ3IMAGE4XI ', time4xi())        
    #    try: 
    #        task4read3image = {} 
    #        for key3pu in keys3pu:
    #            task4read3image[key3pu]  = {}    
    #        
    #        response4read3image = xi3xi.read3image(task4read3image)
    #        
    #        keys3readresponse = response4read3image.keys()
    #        for key3readresponse in sorted(keys3readresponse):
    #            kb3detail = response4read3image[key3readresponse]
    #            keys3detail = kb3detail.keys()
    #            for key3detail in keys3detail: 
    #                print(key3readresponse, key3detail, kb3detail[key3detail])
    #                #
    #    except:
    #        print('(Step 127Z4/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH READ3IMAGE4XI ', time4xi()) 
    #      
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def read3image(self, task4read3image = None):
        '''
        reads Image3D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "read3image"
                     
        message3print = "{(Step 1A/33) started" + "; read3image-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 00:20:02 10/05/11 Pacific Daylight Time 
            
        message3print = "{(Step 1B/33) passed" + "; task4read3image-passed-to-read3image-of-Image3D4Xi: " + str(task4read3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4read3image-passing-to-read3image4xi-by-read3image-of-Image3D4Xi: " + str(task4read3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # None
  
        response4readimage3xi = read3image4xi(task4read3image)

        message3print = "{(Step 2B/33) performed" + "; read3image4xi-performed-by-read3image-of-Image3D4Xi: " + str(read3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # <function read3image4xi at 0x000000000385DA48> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; response4readimage3xi-returning-by-read3image-of-Image3D4Xi: " + str(response4readimage3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
  
        return response4readimage3xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "map3image-of-Image3D4Xi" usage = "
    # 
    #    print('=' *33)          
    #    print('(Step 132A/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH MAP3IMAGE4XI ', time4xi())        
    #    print('=' *33)      
    #    #                         
    #    response4map3image      = {} 
    #    task4map3image        = {}                                                                                    
    #    queue4map          = {} 
    #    channel4map3publish = {} 
    #    channel4map3consume = {} 
    #    try:
    #        task4map3image = {} 
    #        for key3pu in keys3pu:
    #            if KB3CC [key3pu] == 'ACK':
    #                task4map3image [key3pu]  = {}
    #                                                
    #        response4map3image = xi3xi.map3image(task4map3image)
    #        
    #        print('(Step 132B/700) OF IMAGE3D4XI5TEST - GOT RESPONSE4MAP3IMAGE ', response4map3image)
    #        # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E678D0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7228>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7224>}, 
    #        #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E6E128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7260>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7256>}, 
    #        #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E67F28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7196>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7192>}}
    #        print('(Step 9CB/700) OF IMAGE3D4XI5TEST - CONTINUES AFTER GETTING RESPONSE4MAP3IMAGE ', time4xi())   
    #    except:
    #        print('(Step 132Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH MAP3IMAGE4XI ', time4xi())
    #                 
    #    print('(Step 132C/700) OF IMAGE3D4XI5TEST - TRYING TO INITIALIZE QUEUE FOR MAP ', time4xi())               
    #    try: 
    #        queue4map          = {}
    #    except:
    #        print('(Step 132Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO INITIALIZE QUEUES FOR MAP ', time4xi()) 
    #    try:            
    #        channel4map3publish = {}
    #    except:
    #        print('(Step 132Z2/700) OF IMAGE3D4XI5TEST *** FAILED TO INITIALIZE PUBLISHING CHANNELS FOR MAP ', time4xi()) 
    #    
    #    try:    
    #        channel4map3consume = {}
    #    except:    
    #        print('(Step 132Z5/700) OF IMAGE3D4XI5TEST *** FAILED TO INITIALIZE CONSUMING CHANNELS FOR MAP ', time4xi())
    #    try:         
    #        for key3pu in keys3pu:
    #            try:
    #                if KB3CC [key3pu] == 'ACK':
    #                    try:   
    #                        queue4map [key3pu] = response4map3image [key3pu] ['QUEUE']
    #                        print(key3pu, ' SET QUEUE TO : ', queue4map [key3pu])
    #                        # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046588>
    #                        # GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046400>
    #                        # APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046390>
    #                    except:
    #                        print('(Step 132Z6/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
    #                    try:    
    #                        channel4map3publish [key3pu] = response4map3image [key3pu] ['PUBLISHERCHANNEL']
    #                        print(key3pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4map3publish [key3pu])
    #                        # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7256>
    #                        # GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7224>
    #                        # APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7192>
    #                                           
    #                    except:
    #                        print('(Step 132Z7/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
    #                    try:            
    #                        channel4map3consume [key3pu] = response4map3image [key3pu]['CONSUMERCHANNEL']
    #                        print(key3pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4map3consume [key3pu])
    #                        # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7252>
    #                        # GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7220>
    #                        # APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7188>
    #                    except:
    #                        print('(Step 132Z8/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi())     
    #            except:
    #                print('(Step 132Z9/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi())             
    #    except:
    #        print('(Step 132Z10/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def map3image(self, task4map3image = None):
        '''
        maps Image3D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "map3image"
                     
        message3print = "{(Step 1A/33) started" + "; map3image-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
            
        message3print = "{(Step 1B/33) passed" + "; task4map3image-passed-to-map3image-of-Image3D4Xi: " + str(task4map3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4map3image-passing-to-map3image4xi-by-map3image-of-Image3D4Xi: " + str(task4map3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # None
  
        response4mapimage3xi = map3image4xi(task4map3image)

        message3print = "{(Step 2B/33) performed" + "; map3image4xi-performed-by-map3image-of-Image3D4Xi: " + str(map3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # <function map3image4xi at 0x000000000390BAC8> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; response4mapimage3xi-returning-by-map3image-of-Image3D4Xi: " + str(response4mapimage3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 

        
        return response4mapimage3xi
                                                           
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release3image-of-Image3D4Xi" usage = "
    #
    #    print('(Step 133A/700) OF IMAGE3D4XI5TEST - TRYING TO RELEASE 3D IMAGES OF XI DEVICE ', time4xi())    
    #    # 
    #    try: 
    #        task4release = {} 
    #        for key3pu in keys3pu:
    #            task4release [key3pu]  = {}
    #                
    #        response4release = xi3xi.release3image(task4release)
    #        
    #        key3response = response4release.keys()
    #        for key3response in keys3response:
    #            print(key3response, ' : ', response4release [key3response] )
    #            #    
    #    except:
    #        print('(Step 133Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO RELEASE IMAGES OF XI DEVICE ', time4xi()) 
    #     
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release3image(self, task4release3image = None):
        '''
        releases Image3D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "release3image"
                     
        message3print = "{(Step 1A/33) started" + "; release3image-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
            
        message3print = "{(Step 1B/33) passed" + "; task4release3image-passed-to-release3image-of-Image3D4Xi: " + str(task4release3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4release3image-passing-to-release3image4xi-by-release3image-of-Image3D4Xi: " + str(task4release3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # 
  
        image3xi = release3image4xi(task4release3image)

        message3print = "{(Step 2B/33) performed" + "; release3image4xi-performed-by-release3image-of-Image3D4Xi: " + str(release3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; image3xi-returning-by-release3image-of-Image3D4Xi: " + str(image3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        #                          
                
        return image3xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain3image-of-Image3D4Xi" usage = "
    #
    #    print('(Step 134A/700) OF IMAGE3D4XI5TEST - TRYING TO RETAIN 3D IMAGE OF XI DEVICE ', time4xi())   
    #    try:
    #        task4retain3image = {} 
    #        for key3pu in keys3pu:
    #            task4retain3image [key3pu]  = {}
    #            task4retain3image [key3pu] ['COUNT2REFERENCE'] = 1 
    #    
    #            response4retain3Dimage = xi3xi.retain3image(task4retain3image)                                                                                                 
    #                                    
    #            keys3response = response4retain3Dimage.keys()
    #            for key3response in keys3response:
    #                print(key3response, ' : ', response4retain3Dimage[key3response])
    #                #
    #    except:
    #        print('(Step 134Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO RETAIN 3D IMAGE OF XI DEVICE ', time4xi())
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain3image(self, task4retain3image = None):
        '''
        retains Image3D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "retain3image"
                     
        message3print = "{(Step 1A/33) started" + "; retain3image-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 00:14:05 09/07/11 Pacific Daylight Time 
            
        message3print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain3image-of-Image3D4Xi: " + str(task4retain3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain3image4xi-by-retain-of-Image3D4Xi: " + str(task4retain3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # 
  
        image3xi = retain3image4xi(task4retain3image)

        message3print = "{(Step 2B/33) performed" + "; retain3image4xi-performed-by-retain3image-of-Image3D4Xi: " + str(retain3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # <function retain3image4xi at 0x00000000039DF948>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; image3xi-returning-by-retain3image-of-Image3D4Xi: " + str(image3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
                         
                
        return image3xi
                                                           
    #</methodize4xi>   
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "wait3image-of-Image3D4Xi" usage = "
    # 
    #    print('(Step 126A/25) OF IMAGE3D4XI5TEST - TRYING TO WAIT XI 3D IMAGE: ', time4xi())  
    #    try:                               
    #        task4wait3image  = {}
    #        for key3pu in keys3pu:
    #            task4wait3image[key3pu]  = {}
    #            
    #        response4wait3image = xi3xi.wait3image(task4wait3image) 
    #        # {(Step 33/33) of wait3image4xi - RETURNING IMAGE3DWAIT4XI :  
    #        # {
    #        # 'DPU': <queue4xi.Queue4Xi object at 0x0000000005F82CF8>, 
    #        # 'EPU': <queue4xi.Queue4Xi object at 0x0000000005F829E8>, 
    #        # 'BPU': <queue4xi.Queue4Xi object at 0x0000000005F87080>, 
    #        # 'CPU': <queue4xi.Queue4Xi object at 0x0000000005F820B8>, 
    #        # 'VPU': <queue4xi.Queue4Xi object at 0x0000000005F79A90>, 
    #        # 'RPU': <queue4xi.Queue4Xi object at 0x0000000005F7CC18>, 
    #        # 'WPU': <queue4xi.Queue4Xi object at 0x0000000005F79F98>, 
    #        # 'SPU': <queue4xi.Queue4Xi object at 0x0000000005F7CA90>, 
    #        # 'PPU': <queue4xi.Queue4Xi object at 0x0000000005F7C2E8>, 
    #        # 'QPU': <queue4xi.Queue4Xi object at 0x0000000005F7C5F8>, 
    #        # 'KPU': <queue4xi.Queue4Xi object at 0x0000000005F82B70>, 
    #        # 'YPU': <queue4xi.Queue4Xi object at 0x0000000006199E10>, 
    #        # 'LPU': <queue4xi.Queue4Xi object at 0x0000000005F7CEF0>, 
    #        # 'ZPU': <queue4xi.Queue4Xi object at 0x0000000006199C88>, 
    #        # 'TPU': <queue4xi.Queue4Xi object at 0x0000000005F7C128>, 
    #        # 'UPU': <queue4xi.Queue4Xi object at 0x0000000005F79E10>, 
    #        # 'XPU': <queue4xi.Queue4Xi object at 0x0000000006199F98>, 
    #        # 'OPU': <queue4xi.Queue4Xi object at 0x0000000005F7CB00>, 
    #        # 'APU': <queue4xi.Queue4Xi object at 0x0000000005F870B8>, 
    #        # 'MPU': <queue4xi.Queue4Xi object at 0x0000000005F7C4E0>, 
    #        # 'IPU': <queue4xi.Queue4Xi object at 0x0000000005F82588>, 
    #        # 'NPU': <queue4xi.Queue4Xi object at 0x0000000005F7C8D0>, 
    #        # 'JPU': <queue4xi.Queue4Xi object at 0x0000000005F82550>}
    #                
    #        keys3response = response4wait3image.keys()
    #        for key3response in sorted(keys3response):
    #            print(key3response, ' : ', response4wait3image[key3response] )
    #            # 
    #                                                                                                          
    #    except:
    #        print('(Step 126Z/25) OF IMAGE3D4XI5TEST *** FAILED TO WAIT XI 3D IMAGE: ', time4xi())      
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def wait3image(self, task4wait3image = None):
        '''
        waits Image3D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "wait3image"
                     
        message3print = "{(Step 1A/33) started" + "; wait3image-of-Image3D4Xi-started: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)   
        # 00:14:05 09/07/11 Pacific Daylight Time 
            
        message3print = "{(Step 1B/33) passed" + "; task4wait3image-passed-to-wait3image-of-Image3D4Xi: " + str(task4wait3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4wait-passing-to-wait3image4xi-by-wait3image-of-Image3D4Xi: " + str(task4wait3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # None
  
        image3xi = wait3image4xi(task4wait3image)

        message3print = "{(Step 2B/33) performed" + "; wait3image4xi-performed-by-wait3image-of-Image3D4Xi: " + str(wait3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; image3xi-returning-by-wait3image-of-Image3D4Xi: " + str(image3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
                
        return image3xi
                                                           
    #</methodize4xi> 
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "write3image-of-Image3D4Xi" usage = "
    #
    #    print('(Step 128C/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH WRITE3IMAGE4XI ', time4xi())        
    #    try: 
    #        task4write3image = {} 
    #        for key3pu in keys3pu:
    #            task4write3image[key3pu]  = {}    
    #        
    #        response4write3image = xi3xi.write3image(task4write3image)
    #        
    #        keys3writeresponse = response4write3image.keys()
    #        for key3writeresponse in sorted(keys3writeresponse):
    #            kb3detail = response4write3image[key3writeresponse]
    #            keys3detail = kb3detail.keys()
    #            for key3detail in keys3detail: 
    #                print(key3writeresponse, key3detail, kb3detail[key3detail])
    #                #
    #    except:
    #        print('(Step 128Z4/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH WRITE3IMAGE4XI ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def write3image(self, task4write3image = None):
        '''
        writes Image3D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "write3image"
                     
        message3print = "{(Step 1A/33) started" + "; write3image-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
            
        message3print = "{(Step 1B/33) passed" + "; task4write3image-passed-to-write3image-of-Image3D4Xi: " + str(task4write3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4write3image-passing-to-write3image4xi-by-write3image-of-Image3D4Xi: " + str(task4write3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # None
  
        response4writeimage3xi = write3image4xi(task4write3image)

        message3print = "{(Step 2B/33) performed" + "; write3image4xi-performed-by-write3image-of-Image3D4Xi: " + str(write3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # <function write3image4xi at 0x000000000380AEC8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; response4writeimage3xi-returning-by-write3image-of-Image3D4Xi: " + str(response4writeimage3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        #       
                
        return response4writeimage3xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "copy3image-of-Image3D4Xi" usage = "
    # 
    #    print('(Step 129C/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY3IMAGE4XI ', time4xi())        
    #    try: 
    #        task4copy3image = {} 
    #        for key3pu in keys3pu:
    #            task4copy3image[key3pu]  = {}    
    #        
    #        response4copy3image = xi3xi.copy3image(task4copy3image)
    #        
    #        keys3copyresponse = response4copy3image.keys()
    #        for key3copyresponse in sorted(keys3copyresponse):
    #            kb3detail = response4copy3image[key3copyresponse]
    #            keys3detail = kb3detail.keys()
    #            for key3detail in keys3detail: 
    #                print(key3copyresponse, key3detail, kb3detail[key3detail])
    #                #
    #    except:
    #        print('(Step 129Z4/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY3IMAGE4XI ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def copy3image(self, task4copy3image = None):
        '''
        copies Image3D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "copy3image"
                     
        message3print = "{(Step 1A/33) started" + "; copy3image-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        #  
            
        message3print = "{(Step 1B/33) passed" + "; task4copy3image-passed-to-copy3image-of-Image3D4Xi: " + str(task4copy3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4copy3image-passing-to-copy3image4xi-by-copy3image-of-Image3D4Xi: " + str(task4copy3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # None 
  
        response4copyimage3xi = copy3image4xi(task4copy3image)

        message3print = "{(Step 2B/33) performed" + "; copy3image4xi-performed-by-copy3image-of-Image3D4Xi: " + str(copy3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # <function copy3image4xi at 0x000000000390B8C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; response4copyimage3xi-returning-by-copy3image-of-Image3D4Xi: " + str(response4copyimage3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
        
        return response4copyimage3xi
                                                           
    #</methodize4xi>
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "copy3imagetobuffer-of-Image3D4Xi" usage = "
    # 
    #    print('=' *33)          
    #    print('(Step 60A/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY3IMAGETOBUFFER4XI ', time4xi())        
    #    print('=' *33)      
    #    #                         
    #    response4copy3imagetobuffer      = {} 
    #    task4copy3imagetobuffer        = {}                                                                                    
    #    queue4copyimagetobuffer          = {} 
    #    channel4copyimagetobuffer3publish = {} 
    #    channel4copyimagetobuffer3consume = {} 
    #    try:
    #        task4copy3imagetobuffer = {} 
    #        for key3pu in keys3pu:
    #            if KB3CC [key3pu] == 'ACK':
    #                task4copy3imagetobuffer [key3pu]  = {}
    #                                                
    #        response4copy3imagetobuffer = xi3xi.copy3imagetobuffer(task4copy3imagetobuffer)
    #        
    #        print('(Step 60B/700) OF IMAGE3D4XI5TEST - GOT RESPONSE4COPY3IMAGETOBUFFER4XI3IMAGE ', response4copy3imagetobuffer)
    #        # 
    #    except:
    #        print('(Step 60Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY3IMAGETOBUFFER4XI ', time4xi())
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def copy3imagetobuffer(self, task4copy3imagetobuffer = None):
        '''
        copies 3D images to buffer
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "copy3imagetobuffer"
                     
        message3print = "{(Step 1A/33) started" + "; copy3imagetobuffer-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
            
        message3print = "{(Step 1B/33) passed" + "; task4copy3imagetobuffer-passed-to-copy3imagetobuffer-of-Image3D4Xi: " + str(task4copy3imagetobuffer) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4copy3imagetobuffer-passing-to-copy3imagetobuffer4xi-by-copy3imagetobuffer-of-Image3D4Xi: " + str(task4copy3imagetobuffer) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # None
  
        response4copyimage3xi = copy3imagetobuffer4xi(task4copy3imagetobuffer)

        message3print = "{(Step 2B/33) performed" + "; copy3imagetobuffer4xi-performed-by-copy3imagetobuffer-of-Image3D4Xi: " + str(copy3imagetobuffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # <function copy3imagetobuffer4xi at 0x000000000390B948>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; response4copyimage3xi-returning-by-copy3imagetobuffer-of-Image3D4Xi: " + str(response4copyimage3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
          
        return response4copyimage3xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "copy3buffertoimage-of-Image3D4Xi" usage = "
    # 
    #    print('=' *33)          
    #    print('(Step 129A/700) OF IMAGE3D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY3BUFFERTOIMAGE4XI ', time4xi())        
    #    print('=' *33)      
    #    #                         
    #    response4copy3buffertoimage      = {} 
    #    task4copy3buffertoimage        = {}                                                                                    
    #    queue4copybuffertoimage          = {} 
    #    channel4copybuffertoimage3publish = {} 
    #    channel4copybuffertoimage3consume = {} 
    #    try:
    #        task4copy3buffertoimage = {} 
    #        for key3pu in keys3pu:
    #            if KB3CC [key3pu] == 'ACK':
    #                task4copy3buffertoimage [key3pu]  = {}
    #                                                
    #        response4copy3buffertoimage = xi3xi.copy3buffertoimage(task4copy3buffertoimage)
    #        
    #        print('(Step 129B/700) OF IMAGE3D4XI5TEST - GOT RESPONSE4COPY3BUFFERTOIMAGE4XI3IMAGE ', response4copy3buffertoimage)
    #        # 
    #    except:
    #        print('(Step 129Z1/700) OF IMAGE3D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY3BUFFERTOIMAGE4XI ', time4xi())
    #                 
    #    print('(Step 129C/700) OF IMAGE3D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR COPY3BUFFERTOIMAGE4XI ', time4xi())               
    #    try: 
    #        queue4copybuffertoimage          = {}
    #        channel4copybuffertoimage3publish = {} 
    #        channel4copybuffertoimage3consume = {}
    #        for key3pu in keys3pu:
    #            if KB3CC [key3pu] == 'ACK':   
    #                queue4copybuffertoimage [key3pu] = response4copy3buffertoimage [key3pu] ['QUEUE']
    #                print(key3pu, ' SET QUEUE TO : ', queue4copybuffertoimage [key3pu])
    #    
    #                channel4copybuffertoimage3publish [key3pu] = response4copy3buffertoimage [key3pu] ['PUBLISHERCHANNEL']
    #                 print(key3pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4copybuffertoimage3publish [key3pu])
    #         
    #                 channel4copybuffertoimage3consume [key3pu] = response4copy3buffertoimage [key3pu]['CONSUMERCHANNEL']
    #                 print(key3pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4copybuffertoimage3consume [key3pu])
    #                 # 
    #                 # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4F98>
    #                 # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7160>
    #                 # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7156>
    #                 # GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4AC8>
    #                 # GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7128>
    #                 # GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7124>
    #                 # APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4A58>
    #                 # APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7096>
    #                 # APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7092> 
    #                         
    #    except:
    #        print('(Step 129Z2/700) OF IMAGE3D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR COPY3BUFFERTOIMAGE4XI ', time4xi())       
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def copy3buffertoimage(self, task4copy3buffertoimage = None):
        '''
        copies 3D images to buffer
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "copy3buffertoimage"
                     
        message3print = "{(Step 1A/33) started" + "; copy3buffertoimage-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
            
        message3print = "{(Step 1B/33) passed" + "; task4copy3buffertoimage-passed-to-copy3buffertoimage-of-Image3D4Xi: " + str(task4copy3buffertoimage) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4copy3buffertoimage-passing-to-copy3buffertoimage4xi-by-copy3buffertoimage-of-Image3D4Xi: " + str(task4copy3buffertoimage) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # None
  
        response4copyimage3xi = copy3buffertoimage4xi(task4copy3buffertoimage)

        message3print = "{(Step 2B/33) performed" + "; copy3buffertoimage4xi-performed-by-copy3buffertoimage-of-Image3D4Xi: " + str(copy3buffertoimage4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # <function copy3buffertoimage4xi at 0x000000000390B9C8> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; response4copyimage3xi-returning-by-copy3buffertoimage-of-Image3D4Xi: " + str(response4copyimage3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
                
        return response4copyimage3xi
                                                           
    #</methodize4xi>    
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace3image-of-Image3D4Xi" usage = "
    #
    #    print('(Step 125A/25) OF IMAGE3D4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
    #    try:                               
    #        task4trace3image  = {}
    #        for key3pu in keys3pu:
    #            task4trace3image[key3pu]  = {}
    #            
    #        response4trace3image = xi3xi.trace3image(task4trace3image) 
    #        
    #        key3response = response4trace3image.keys()
    #        for key3response in sorted(keys3response):
    #            print(key3response, ' : ', response4trace3image[key3response] )
    #            # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4apu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4apu', 'METHOD': 'trace3image4apu'}
    #            # BPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4bpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4bpu', 'METHOD': 'trace3image4bpu'}
    #            # CPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4cpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4cpu', 'METHOD': 'trace3image4cpu'}
    #            # DPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4dpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4dpu', 'METHOD': 'trace3image4dpu'}
    #            # EPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4epu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4epu', 'METHOD': 'trace3image4epu'}
    #            # FPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4fpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4fpu', 'METHOD': 'trace3image4fpu'}
    #            # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4gpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4gpu', 'METHOD': 'trace3image4gpu'}
    #            # HPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4hpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4hpu', 'METHOD': 'trace3image4hpu'}
    #            # IPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4ipu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4ipu', 'METHOD': 'trace3image4ipu'}
    #            # JPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4jpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4jpu', 'METHOD': 'trace3image4jpu'}
    #            # KPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4kpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4kpu', 'METHOD': 'trace3image4kpu'}
    #            # LPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4lpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4lpu', 'METHOD': 'trace3image4lpu'}
    #            # MPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4mpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4mpu', 'METHOD': 'trace3image4mpu'}
    #            # NPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4npu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4npu', 'METHOD': 'trace3image4npu'}
    #            # OPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4opu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4opu', 'METHOD': 'trace3image4opu'}
    #            # PPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4ppu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4ppu', 'METHOD': 'trace3image4ppu'}
    #            # QPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4qpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4qpu', 'METHOD': 'trace3image4qpu'}
    #            # RPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4rpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4rpu', 'METHOD': 'trace3image4rpu'}
    #            # SPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4spu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4spu', 'METHOD': 'trace3image4spu'}
    #            # TPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4tpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4tpu', 'METHOD': 'trace3image4tpu'}
    #            # UPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4upu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4upu', 'METHOD': 'trace3image4upu'}
    #            # VPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4vpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4vpu', 'METHOD': 'trace3image4vpu'}
    #            # WPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4wpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4wpu', 'METHOD': 'trace3image4wpu'}
    #            # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4xpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4xpu', 'METHOD': 'trace3image4xpu'}
    #            # YPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4ypu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4ypu', 'METHOD': 'trace3image4ypu'}
    #            # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace3image4zpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace3image4zpu', 'METHOD': 'trace3image4zpu'}
    #                                                                                                       
    #    except:
    #        print('(Step 125Z/25) OF IMAGE3D4XI5TEST *** FAILED TO TRACE XI: ', time4xi())       
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace3image(self, task4trace3image = None):
        '''
        traces Image3D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "trace3image"
                     
        message3print = "{(Step 1A/33) started" + "; trace3image-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
            
        message3print = "{(Step 1B/33) passed" + "; task4trace3image-passed-to-trace-of-Image3D4Xi: " + str(task4trace3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None   
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4trace3image-passing-to-trace3image4xi-by-trace3image-of-Image3D4Xi: " + str(task4trace3image) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # None  
  
        trace3xi = trace3image4xi(task4trace3image)

        message3print = "{(Step 2B/33) performed" + "; trace3image4xi-performed-by-trace3image-of-Image3D4Xi: " + str(trace3image4xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; trace3xi-returning-by-trace3image-of-Image3D4Xi: " + str(trace3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
                 
                
        return trace3xi
                                                           
    #</methodize4xi>       


    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set3imagecallback-of-Image3D4Xi" usage = "
    # 
    #    print('(Step 124A/700) OF IMAGE3D4XI5TEST - TRYING TO SET IMAGE CALLBACK WITH METHOD OF OBJECT XI2XI: ', xi3xi) 
    # 
    #    try:
    #        task4callback3image = {} 
    #        for key3pu in keys3pu:
    #            task4callback3image [key3pu]  = {}
    #                                         
    #        response4callback = xi3xi.set3imagecallback(task4callback3image)                                  
    #        
    #        key3response = response4callback.keys()
    #        for key3response in sorted(keys3response):
    #            print(key3response, ' : ', response4callback [key3response] )
    #            # APU  :  {'CALLBACK': <function trace3image4apu at 0x00000000043E2648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # BPU  :  {'CALLBACK': <function trace3image4bpu at 0x00000000044C40C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # CPU  :  {'CALLBACK': <function trace3image4cpu at 0x0000000004581848>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # DPU  :  {'CALLBACK': <function trace3image4dpu at 0x00000000046AD048>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # EPU  :  {'CALLBACK': <function trace3image4epu at 0x00000000047667C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # FPU  :  {'CALLBACK': <function trace3image4fpu at 0x000000000483AF48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # GPU  :  {'CALLBACK': <function trace3image4gpu at 0x0000000004914748>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # HPU  :  {'CALLBACK': <function trace3image4hpu at 0x00000000049B0EC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # IPU  :  {'CALLBACK': <function trace3image4ipu at 0x0000000004A8F6C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # JPU  :  {'CALLBACK': <function trace3image4jpu at 0x0000000004B19E48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # KPU  :  {'CALLBACK': <function trace3image4kpu at 0x0000000004C00648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # LPU  :  {'CALLBACK': <function trace3image4lpu at 0x0000000004CC4DC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # MPU  :  {'CALLBACK': <function trace3image4mpu at 0x0000000004DA55C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # NPU  :  {'CALLBACK': <function trace3image4npu at 0x0000000004E47D48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # OPU  :  {'CALLBACK': <function trace3image4opu at 0x0000000004F4B548>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # PPU  :  {'CALLBACK': <function trace3image4ppu at 0x0000000004FDDCC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # QPU  :  {'CALLBACK': <function trace3image4qpu at 0x00000000051034C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # RPU  :  {'CALLBACK': <function trace3image4rpu at 0x0000000005248C48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # SPU  :  {'CALLBACK': <function trace3image4spu at 0x0000000005337448>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # TPU  :  {'CALLBACK': <function trace3image4tpu at 0x00000000053F7BC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # UPU  :  {'CALLBACK': <function trace3image4upu at 0x00000000054A23C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # VPU  :  {'CALLBACK': <function trace3image4vpu at 0x0000000005537B48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # WPU  :  {'CALLBACK': <function trace3image4wpu at 0x00000000056AAAC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # XPU  :  {'CALLBACK': <function trace3image4xpu at 0x0000000005628348>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # YPU  :  {'CALLBACK': <function trace3image4ypu at 0x00000000057572C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # ZPU  :  {'CALLBACK': <function trace3image4zpu at 0x0000000005854A48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #                          
    #    except:
    #        print('(Step 124Z/700) OF IMAGE3D4XI5TEST *** FAILED TO SET IMAGE CALLBACK WITH METHOD ***', time4xi())    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set3imagecallback(self, task4set3imagecallback = None): 
        '''
        set3imagecallback of Image3D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class3print = "Image3D4Xi"
        method3print = "set3imagecallback"
                     
        message3print = "{(Step 1A/33) started" + "; set3imagecallback-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
            
        message3print = "{(Step 1B/33) passed" + "; task4set3imagecallback-passed-to-set3imagecallback-of-Image3D4Xi: " + str(task4set3imagecallback) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                          
        # None    
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message3print = "{(Step 2A/33) passing" + "; task4set3imagecallback-passing-to-set3imagecallback -by-set3imagecallback-of-Image3D4Xi: " + str(task4set3imagecallback) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)                                                               
        # None
        
        callback3xi4image = {} 
        try:
            callback3xi4image = set3imagecallback4xi (task4set3imagecallback)

            message3print = "{(Step 2B/33) callback3xi4image" + "; callback3xi4image-set-by-set3imagecallback-of-Image3D4Xi to: " + str(callback3xi4image) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print)             
            # 
        except:
            message3print = "{(Step 4A/33) failed" + "; callback3xi4image-failed-by-set3imagecallback-of-Image3D4Xi: " + str(callback3xi4image) + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message3print = "{(Step 3A/33) returning" + "; callback3xi4image-returning-by-set3imagecallback-of-Image3D4Xi: " + str(callback3xi4image) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print) 
        # 
                                             
        return callback3xi4image
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Image3D4Xi" usage = "
    #
    #    print('(Step 170A/700) OF IMAGE3D4XI5TEST - SENSING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4sense = xi3xi.sense()
    #         
    #         print(response4sense)
    #         # {'classvariable3xi-of-Image3D4Xi': 4, 'object': <image3d4xi.Image3D4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 170Z/700) OF IMAGE3D4XI5TEST *** FAILED TO SENSE ', time4xi())      
    #  
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Image3D4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class3print = 'Image3D4Xi'
        method3print = 'sense'
        
                     
        message3print = "{(Step 1A/33) started" + "; sense-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message3print = "{(Step 2A/33) sensing" + "; Image3D4Xi-sensing-by-sense-of-Image3D4Xi: " + str(Image3D4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)         
        # <class 'image3d4xi.Image3D4Xi'>         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb3xi = sense_object4xi(self)
        
        message3print = "{(Step 3A/33) got" + "; kb3xi-got-by-sense-of-Image3D4Xi: " + str(kb3xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)
        # {'object': <image3d4xi.Image3D4Xi object at 0x0000000004188400>}   
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb3xi['time3xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb3xi['classvariable3xi-of-Image3D4Xi'] = Image3D4Xi.classvariable3xi
        except:
            message3print = "{(Step 4A/33) yielded" + "; kb3xi-yielded-by-sense-of-Image3D4Xi: " + str(kb3xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print) 
            
      
        message3print = "{(Step 5A/33) sensed" + "; Image3D4Xi-sensed-by-sense-of-Image3D4Xi: " + str(Image3D4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)    
        # <class 'image3d4xi.Image3D4Xi'>
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message3print = "{(Step 6A/33) returning" + "; kb3xi-returning-by-sense-of-Image3D4Xi: " + str(kb3xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                          
        #             
          
        return kb3xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Image3D4Xi" usage = "
    # 
    #    print('(Step 171A/700) OF IMAGE3D4XI5TEST - REASONING ', time4xi())  
    #    # 
    #    try:
    #                
    #        response4reason = xi3xi.reason()
    #        
    #        print(response4reason)
    #        # {'object-reason-object4xi': <image3d4xi.Image3D4Xi object at 0x0000000006018278>, 'time-reason-of-Image3D4Xi': '09:46:11 11/05/11 Pacific Daylight Time'}         
    # 
    #     except:
    #         print('(Step 171Z/700) OF IMAGE3D4XI5TEST *** FAILED TO REASON ', time4xi())  
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Image3D4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class3print = 'Image3D4Xi'
        method3print = 'reason'

                     
        message3print = "{(Step 1A/33) started" + "; reason-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        # 01:02:22 09/07/11 Pacific Daylight Time 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message3print = "{(Step 2A/33) reasoning" + "; Image3D4Xi-reasoning-by-reason-of-Image3D4Xi: " + str(Image3D4Xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print) 
        # <class 'image3d4xi.Image3D4Xi'>  
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message3print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-Image3D4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)
        # {'object-reason-object4xi': <image3d4xi.Image3D4Xi object at 0x0000000004188400>}      
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time3xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-Image3D4Xi'] = time4xi() #adding time
        except:
            message3print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-Image3D4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class3print, method3print, message3print) 
        
          
        
        message3print = "{(Step 5A/33) reasoned" + "; Image3D4Xi-reasoned-by-reason-of-Image3D4Xi: " + str(Image3D4Xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)        
        # <class 'image3d4xi.Image3D4Xi'>
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message3print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-Image3D4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                          
        #            
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Image3D4Xi" usage = "
    # 
    #    print('(Step 172A/700) OF IMAGE3D4XI5TEST - ACING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4ace = xi3xi.ace()
    # 
    #         print(response4ace)
    #         # {'cores-of-Image3D4Xi': 4, 'object8xi': <image3d4xi.Image3D4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 172Z/700) OF IMAGE3D4XI5TEST *** FAILED TO ACE ', time4xi())                                     
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Image3D4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class3print = 'Image3D4Xi'
        method3print = 'ace'
        
                     
        message3print = "{(Step 1A/33) started" + "; ace-of-Image3D4Xi-started: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)   
        #  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message3print = "{(Step 2A/33) acing" + "; Image3D4Xi-acing-by-ace-of-Image3D4Xi: " + str(Image3D4Xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)         
        # <class 'image3d4xi.Image3D4Xi'>           
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message3print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-Image3D4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)
        # {'object8xi': <image3d4xi.Image3D4Xi object at 0x0000000004188400>}   


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time3xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-Image3D4Xi'] = Image3D4Xi.classvariable3xi
        except:
             message3print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-Image3D4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class3print, method3print, message3print) 
  
        message3print = "{(Step 5A/33) aced" + "; Image3D4Xi-aced-by-ace-of-Image3D4Xi: " + str(Image3D4Xi) + "; time: " + time4xi() + "}"
        print4xi(class3print, method3print, message3print)         
        # <class 'image3d4xi.Image3D4Xi'>  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message3print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-Image3D4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class3print, method3print, message3print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   image3d4xi5test.txt
#   sense-image3d4xi5test.xml
#   reason-image3d4xi5test.xml
#   ace-image3d4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of image3d4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
